# SPDX-License-Identifier: GPL-2.0-only

# Localized KCONFIG settings
CONFIG_SPECTRA_ISP := y
CONFIG_SPECTRA_ICP := y
CONFIG_SPECTRA_JPEG := y
CONFIG_SPECTRA_CRE := y
CONFIG_SPECTRA_SENSOR := y
CONFIG_SPECTRA_LLCC_STALING := y
CONFIG_SPECTRA_USE_RPMH_DRV_API := y
CONFIG_SPECTRA_USE_CLK_CRM_API := y
CONFIG_DOMAIN_ID_SECURE_CAMERA := y
CONFIG_DYNAMIC_FD_PORT_CONFIG := y
CONFIG_CSF_2_5_SECURE_CAMERA := y

# Flags to pass into C preprocessor
ccflags-y += -DCONFIG_SPECTRA_ISP=1
ccflags-y += -DCONFIG_SPECTRA_ICP=1
ccflags-y += -DCONFIG_SPECTRA_JPEG=1
ccflags-y += -DCONFIG_SPECTRA_CRE=1
ccflags-y += -DCONFIG_SPECTRA_SENSOR=1
ccflags-y += -DCONFIG_SPECTRA_LLCC_STALING=1
ccflags-y += -DCONFIG_SPECTRA_USE_RPMH_DRV_API=1
ccflags-y += -DCONFIG_SPECTRA_USE_CLK_CRM_API=1
ccflags-y += -DCONFIG_DOMAIN_ID_SECURE_CAMERA=1
ccflags-y += -DCONFIG_DYNAMIC_FD_PORT_CONFIG=1
ccflags-y += -DCONFIG_CSF_2_5_SECURE_CAMERA=1

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU1Q) \
	$(CONFIG_SEC_PLATFORM_MU2Q) \
	$(CONFIG_SEC_PLATFORM_MU3Q) \
	$(CONFIG_SEC_PLATFORM_E1Q) \
	$(CONFIG_SEC_PLATFORM_E2Q) \
	$(CONFIG_SEC_PLATFORM_E3Q) \
	$(CONFIG_SEC_PLATFORM_Q6Q) \
	$(CONFIG_SEC_PLATFORM_Q6AQ) \
	$(CONFIG_SEC_PLATFORM_B6Q) \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI) \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
CONFIG_CAMERA_SYSFS_V2 := y
CONFIG_CAMERA_FRAME_CNT_DBG := y
CONFIG_CAMERA_RF_MIPI := y
CONFIG_SAMSUNG_DEBUG_SENSOR_I2C := y
CONFIG_SAMSUNG_DEBUG_SENSOR_TIMING := y
CONFIG_SAMSUNG_DEBUG_HW_INFO := y
ifneq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI) \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
CONFIG_SAMSUNG_OIS_MCU_STM32 := y
CONFIG_SENSOR_RETENTION := y
CONFIG_CAMERA_ADAPTIVE_MIPI := y
endif
CONFIG_CAMERA_CDR_TEST := y
CONFIG_CAMERA_HW_ERROR_DETECT := y
CONFIG_SAMSUNG_CAMERA := y
ifneq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_B6Q) \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI) \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
CONFIG_SAMSUNG_REAR_TRIPLE := y
endif
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU1Q) \
	$(CONFIG_SEC_PLATFORM_E1Q)))
CONFIG_SEC_E1Q_PROJECT := y
CONFIG_SAMSUNG_FRONT_CAMERA_ACTUATOR := y
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU2Q) \
	$(CONFIG_SEC_PLATFORM_E2Q)))
CONFIG_SEC_E2Q_PROJECT := y
CONFIG_SAMSUNG_FRONT_CAMERA_ACTUATOR := y
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU3Q) \
	$(CONFIG_SEC_PLATFORM_E3Q)))
CONFIG_SEC_E3Q_PROJECT := y
CONFIG_SAMSUNG_REAR_QUADRA := y
CONFIG_SAMSUNG_ACTUATOR_PREVENT_SHAKING := y
CONFIG_SAMSUNG_READ_BPC_FROM_OTP := y
CONFIG_SAMSUNG_WACOM_NOTIFIER := y
CONFIG_SAMSUNG_SUPPORT_RUMBA_FW_UPDATE := y
CONFIG_SAMSUNG_FRONT_CAMERA_ACTUATOR := y
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_Q6Q)))
CONFIG_SEC_Q6Q_PROJECT := y
CONFIG_SAMSUNG_FRONT_TOP :=y
CONFIG_SAMSUNG_FRONT_TOP_EEPROM :=y
CONFIG_SOF_FREEZE_FRAME_CNT_READ :=y
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_Q6AQ)))
CONFIG_SEC_Q6AQ_PROJECT := y
CONFIG_SAMSUNG_FRONT_TOP :=y
CONFIG_SAMSUNG_FRONT_TOP_EEPROM :=y
CONFIG_SAMSUNG_ACTUATOR_PREVENT_SHAKING := y
CONFIG_SAMSUNG_READ_BPC_FROM_OTP := y
CONFIG_SAMSUNG_SENSOR_TEMP := y
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_B6Q)))
CONFIG_SEC_B6Q_PROJECT := y
CONFIG_SEC_GPIO_ENABLED_VREG := y
CONFIG_SAMSUNG_PMIC_FLASH := y
CONFIG_SAMSUNG_OIS_ADC_TEMPERATURE_SUPPORT := y
ifeq ($(TARGET_PRODUCT), $(filter $(TARGET_PRODUCT),b6qzcx b6qzhx))
CONFIG_SEC_B6Q_CHN_PROJECT := y
endif
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI)))
CONFIG_SEC_GTS10P_PROJECT := y
CONFIG_HI847_OTP := y
CONFIG_HI1337_OTP := y
CONFIG_SAMSUNG_PMIC_FLASH := y
CONFIG_SAMSUNG_ACTUATOR_HW_SOFTLANDING := y
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
CONFIG_SEC_GTS10U_PROJECT := y
CONFIG_HI847_OTP := y
CONFIG_SAMSUNG_PMIC_FLASH := y
CONFIG_SAMSUNG_FRONT_DUAL := y
CONFIG_SAMSUNG_FRONT_TOP_EEPROM := y
CONFIG_SAMSUNG_ACTUATOR_HW_SOFTLANDING := y
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU1Q) \
	$(CONFIG_SEC_PLATFORM_MU2Q) \
	$(CONFIG_SEC_PLATFORM_MU3Q) \
	$(CONFIG_SEC_PLATFORM_E1Q) \
	$(CONFIG_SEC_PLATFORM_E2Q) \
	$(CONFIG_SEC_PLATFORM_E3Q) \
	$(CONFIG_SEC_PLATFORM_Q6Q) \
	$(CONFIG_SEC_PLATFORM_Q6AQ) \
	$(CONFIG_SEC_PLATFORM_B6Q) \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI) \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
ccflags-y += -DCONFIG_CAMERA_SYSFS_V2=1
ccflags-y += -DCONFIG_CAMERA_FRAME_CNT_DBG=1
ccflags-y += -DCONFIG_CAMERA_FRAME_CNT_CHECK=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_EEPROM=1
ccflags-y += -DCONFIG_SAMSUNG_REAR_DUAL=1
ifneq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_B6Q) \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI) \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
ccflags-y += -DCONFIG_SAMSUNG_REAR_TRIPLE=1
endif
ccflags-y += -DCONFIG_USE_CAMERA_HW_BIG_DATA=1
ccflags-y += -DCONFIG_CAMERA_RF_MIPI=1
ccflags-y += -DCONFIG_SAMSUNG_DEBUG_SENSOR_I2C=1
ccflags-y += -DCONFIG_SAMSUNG_DEBUG_SENSOR_TIMING=1
ccflags-y += -DCONFIG_SAMSUNG_DEBUG_HW_INFO=1
ifneq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI) \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
ccflags-y += -DCONFIG_SAMSUNG_ACTUATOR_READ_HALL_VALUE=1
ccflags-y += -DCONFIG_SAMSUNG_OIS_MCU_STM32=1
ccflags-y += -DCONFIG_SENSOR_RETENTION=1
ccflags-y += -DCONFIG_CAMERA_ADAPTIVE_MIPI=1
endif
ccflags-y += -DCONFIG_CAMERA_CDR_TEST=1
ccflags-y += -DCONFIG_CAMERA_HW_ERROR_DETECT=1
ccflags-y += -DCONFIG_SAMSUNG_CAMERA=1
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU1Q) \
	$(CONFIG_SEC_PLATFORM_E1Q)))
ccflags-y += -DCONFIG_SEC_E1Q_PROJECT=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_CAMERA_ACTUATOR=1
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU2Q) \
	$(CONFIG_SEC_PLATFORM_E2Q)))
ccflags-y += -DCONFIG_SEC_E2Q_PROJECT=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_CAMERA_ACTUATOR=1
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_MU3Q) \
	$(CONFIG_SEC_PLATFORM_E3Q)))
ccflags-y += -DCONFIG_SEC_E3Q_PROJECT=1
ccflags-y += -DCONFIG_SAMSUNG_REAR_QUADRA=1
ccflags-y += -DCONFIG_SAMSUNG_ACTUATOR_PREVENT_SHAKING=1
ccflags-y += -DCONFIG_SAMSUNG_READ_BPC_FROM_OTP=1
ccflags-y += -DCONFIG_SAMSUNG_WACOM_NOTIFIER=1
ccflags-y += -DCONFIG_SAMSUNG_SUPPORT_RUMBA_FW_UPDATE=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_CAMERA_ACTUATOR=1
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_Q6Q)))
ccflags-y += -DCONFIG_SEC_Q6Q_PROJECT=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_TOP=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_TOP_EEPROM=1
ccflags-y += -DCONFIG_SOF_FREEZE_FRAME_CNT_READ=1
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_Q6AQ)))
ccflags-y += -DCONFIG_SEC_Q6AQ_PROJECT=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_TOP=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_TOP_EEPROM=1
ccflags-y += -DCONFIG_SAMSUNG_ACTUATOR_PREVENT_SHAKING=1
ccflags-y += -DCONFIG_SAMSUNG_READ_BPC_FROM_OTP=1
ccflags-y += -DCONFIG_SAMSUNG_SENSOR_TEMP=1
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_B6Q)))
ccflags-y += -DCONFIG_SEC_B6Q_PROJECT=1
ccflags-y += -DCONFIG_SEC_GPIO_ENABLED_VREG=1
ccflags-y += -DCONFIG_SAMSUNG_PMIC_FLASH=1
ccflags-y += -DCONFIG_SAMSUNG_OIS_ADC_TEMPERATURE_SUPPORT=1
ifeq ($(TARGET_PRODUCT), $(filter $(TARGET_PRODUCT),b6qzcx b6qzhx))
ccflags-y += -DCONFIG_SEC_B6Q_CHN_PROJECT=1
endif
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_GTS10P) \
	$(CONFIG_SEC_PLATFORM_GTS10PWIFI)))
ccflags-y += -DCONFIG_SEC_GTS10P_PROJECT=1
ccflags-y += -DCONFIG_HI847_OTP=1
ccflags-y += -DCONFIG_HI1337_OTP=1
ccflags-y += -DCONFIG_SAMSUNG_PMIC_FLASH=1
ccflags-y += -DCONFIG_SAMSUNG_ACTUATOR_HW_SOFTLANDING=1
endif

ifeq (y, $(filter y, \
	$(CONFIG_SEC_PLATFORM_GTS10U) \
	$(CONFIG_SEC_PLATFORM_GTS10UWIFI)))
ccflags-y += -DCONFIG_SEC_GTS10U_PROJECT=1
ccflags-y += -DCONFIG_HI847_OTP=1
ccflags-y += -DCONFIG_SAMSUNG_PMIC_FLASH=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_TOP_EEPROM=1
ccflags-y += -DCONFIG_SAMSUNG_FRONT_DUAL=1
ccflags-y += -DCONFIG_SAMSUNG_ACTUATOR_HW_SOFTLANDING=1
endif

# External Dependencies
KBUILD_CPPFLAGS += -DCONFIG_MSM_MMRM=1
ifeq ($(CONFIG_QCOM_VA_MINIDUMP), y)
KBUILD_CPPFLAGS += -DCONFIG_QCOM_VA_MINIDUMP=1
endif
