/* Copyright (c) 2017, The Linux Foundation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _CAM_SENSOR_ADAPTIVE_MIPI_IMX471_H_
#define _CAM_SENSOR_ADAPTIVE_MIPI_IMX471_H_

#include "cam_sensor_dev.h"

int num_front_top_mipi_setting = 1;

/*************************************/
/* ========== Mode A =============== */
/*************************************/

enum {
	CAM_IMX471_SET_A_Full_793p6_MHZ = 0,
	CAM_IMX471_SET_A_Full_723p2_MHZ = 1,
	CAM_IMX471_SET_A_Full_771p2_MHZ = 2,
	CAM_IMX471_SET_A_Full_774p4_MHZ = 3,
};

struct cam_sensor_i2c_reg_array MIPI_FULL_793p6_MHZ_REG_ARRAY[] = {
    {0x030F, 0xF8, 0x00, 0x00},
};

struct cam_sensor_i2c_reg_array MIPI_FULL_723p2_MHZ_REG_ARRAY[] = {
    {0x030F, 0xE2, 0x00, 0x00},
};

struct cam_sensor_i2c_reg_array MIPI_FULL_771p2_MHZ_REG_ARRAY[] = {
    {0x030F, 0xF1, 0x00, 0x00},
};

struct cam_sensor_i2c_reg_array MIPI_FULL_774p4_MHZ_REG_ARRAY[] = {
    {0x030F, 0xF2, 0x00, 0x00},
};

static const struct cam_sensor_i2c_reg_setting sensor_imx471_setfile_A_mipi_FULL_793p6_mhz[] = {
    { MIPI_FULL_793p6_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_793p6_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_BYTE, 0 }
};

static const struct cam_sensor_i2c_reg_setting sensor_imx471_setfile_A_mipi_FULL_723p2_mhz[] = {
    { MIPI_FULL_723p2_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_723p2_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_BYTE, 0 }
};

static const struct cam_sensor_i2c_reg_setting sensor_imx471_setfile_A_mipi_FULL_771p2_mhz[] = {
    { MIPI_FULL_771p2_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_771p2_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_BYTE, 0 }
};

static const struct cam_sensor_i2c_reg_setting sensor_imx471_setfile_A_mipi_FULL_774p4_mhz[] = {
    { MIPI_FULL_774p4_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_774p4_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_BYTE, 0 }
};

static const struct cam_mipi_setting sensor_imx471_setfile_A_mipi_setting_FULL[] = {
	{ "793.6 Mhz",
	  sensor_imx471_setfile_A_mipi_FULL_793p6_mhz, ARRAY_SIZE(sensor_imx471_setfile_A_mipi_FULL_793p6_mhz) },
	{ "723.2 Mhz",
	  sensor_imx471_setfile_A_mipi_FULL_723p2_mhz, ARRAY_SIZE(sensor_imx471_setfile_A_mipi_FULL_723p2_mhz) },
	{ "771.2 Mhz",
	  sensor_imx471_setfile_A_mipi_FULL_771p2_mhz, ARRAY_SIZE(sensor_imx471_setfile_A_mipi_FULL_771p2_mhz) },
	{ "774.4 Mhz",
	  sensor_imx471_setfile_A_mipi_FULL_774p4_mhz, ARRAY_SIZE(sensor_imx471_setfile_A_mipi_FULL_774p4_mhz) },
};

static const struct cam_mipi_channel sensor_imx471_setfile_A_mipi_channel_FULL[] = {
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_001_GSM_GSM850), 0, 0, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_002_GSM_EGSM900), 0, 0, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_003_GSM_DCS1800), 0, 0, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_004_GSM_PCS1900), 0, 0, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10562, 10676, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10677, 10704, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10705, 10751, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10752, 10838, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9662, 9684, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9685, 9725, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9726, 9759, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9760, 9882, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9883, 9906, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9907, 9938, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1162, 1213, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1214, 1288, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1289, 1412, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1413, 1487, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1488, 1513, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1537, 1651, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1652, 1679, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1680, 1726, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1727, 1738, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_015_WCDMA_WB05), 4357, 4376, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_015_WCDMA_WB05), 4377, 4402, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_015_WCDMA_WB05), 4403, 4458, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2237, 2256, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2257, 2380, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2381, 2455, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2456, 2563, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 2937, 3024, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 3025, 3038, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 3039, 3088, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 0, 5, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 6, 252, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 253, 309, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 310, 402, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 403, 599, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 600, 668, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 669, 751, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 752, 818, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 819, 1064, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 1065, 1112, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 1113, 1199, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1200, 1327, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1328, 1477, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1478, 1724, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1725, 1874, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1875, 1949, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 1950, 1955, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 1956, 2202, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 2203, 2259, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 2260, 2352, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 2353, 2399, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_095_LTE_LB05), 2400, 2463, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_095_LTE_LB05), 2464, 2514, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_095_LTE_LB05), 2515, 2649, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 2750, 2813, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 2814, 3060, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 3061, 3210, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 3211, 3449, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3450, 3648, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3649, 3676, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3677, 3799, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_102_LTE_LB12), 5010, 5179, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_103_LTE_LB13), 5180, 5184, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_103_LTE_LB13), 5185, 5238, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_103_LTE_LB13), 5239, 5279, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_104_LTE_LB14), 5280, 5314, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_104_LTE_LB14), 5315, 5379, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_107_LTE_LB17), 5730, 5849, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_108_LTE_LB18), 5850, 5904, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_108_LTE_LB18), 5905, 5999, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_109_LTE_LB19), 6000, 6003, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_109_LTE_LB19), 6004, 6054, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_109_LTE_LB19), 6055, 6149, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6150, 6250, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6251, 6449, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_111_LTE_LB21), 6450, 6494, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_111_LTE_LB21), 6495, 6599, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8040, 8108, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8109, 8191, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8192, 8258, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8259, 8504, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8505, 8552, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8553, 8654, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8655, 8689, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8690, 8754, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8755, 8853, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8854, 8904, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8905, 9039, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9210, 9244, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9245, 9490, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9491, 9510, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9511, 9640, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9641, 9659, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_119_LTE_LB29), 9660, 9707, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_119_LTE_LB29), 9708, 9769, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_120_LTE_LB30), 9770, 9869, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 9920, 10006, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 10007, 10150, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 10151, 10156, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 10157, 10359, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_124_LTE_LB34), 36200, 36261, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_124_LTE_LB34), 36262, 36274, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_124_LTE_LB34), 36275, 36349, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37750, 37766, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37767, 37798, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37799, 37916, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37917, 38163, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 38164, 38249, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38250, 38421, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38422, 38539, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38540, 38571, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38572, 38649, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38650, 38717, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38718, 38739, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38740, 38986, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38987, 39078, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39079, 39096, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39097, 39136, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39137, 39382, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39383, 39440, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39441, 39482, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39483, 39532, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39533, 39649, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39650, 39678, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39679, 39715, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39716, 39763, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39764, 40010, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40011, 40064, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40065, 40076, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40077, 40160, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40161, 40406, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40407, 40438, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40439, 40556, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40557, 40803, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40804, 40953, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40954, 41200, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 41201, 41350, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 41351, 41589, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41590, 41639, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41640, 41655, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41656, 41789, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41790, 42036, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42037, 42186, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42187, 42433, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42434, 42583, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42584, 42830, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42831, 42951, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42952, 42980, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42981, 43227, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43228, 43313, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43314, 43375, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43376, 43377, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43378, 43589, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55240, 55377, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55378, 55463, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55464, 55525, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55526, 55527, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55528, 55773, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55774, 55825, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55826, 55911, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55912, 55923, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55924, 56170, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56171, 56186, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56187, 56297, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56298, 56320, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56321, 56567, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56568, 56682, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56683, 56698, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56699, 56717, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56718, 56739, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66436, 66441, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66442, 66688, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66689, 66745, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66746, 66838, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66839, 67084, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 67085, 67106, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 67107, 67234, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 67235, 67335, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68586, 68689, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68690, 68839, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68840, 68935, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_051_TDSCDMA_TD1), 0, 0, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_052_TDSCDMA_TD2), 0, 0, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_053_TDSCDMA_TD3), 0, 0, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_054_TDSCDMA_TD4), 0, 0, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_055_TDSCDMA_TD5), 0, 0, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_056_TDSCDMA_TD6), 0, 0, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_061_CDMA_BC0), 0, 0, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_062_CDMA_BC1), 0, 0, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_071_CDMA_BC10), 0, 0, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 173800, 174960, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 174961, 175830, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 175831, 178380, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 178381, 178780, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 185000, 185620, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 185621, 187480, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 187481, 190380, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 190381, 190420, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 190421, 191980, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_267_NR5G_N012), 145800, 148380, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_267_NR5G_N012), 148381, 148920, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_267_NR5G_N012), 148921, 149200, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 158200, 159540, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 159541, 160660, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 160661, 161500, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 161501, 163920, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 163921, 164180, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 151600, 152820, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 152821, 154260, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 154261, 156700, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 156701, 159540, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 159541, 160580, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 636667, 637567, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 637568, 638147, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 638148, 638567, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 638568, 640207, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 640208, 640547, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 640548, 641127, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 641128, 641207, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 641208, 642867, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 642868, 642967, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 642968, 643707, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 643708, 643867, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 643868, 645507, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 645508, 646267, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 646268, 646387, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 646388, 646507, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_303_NR5G_N048), 646508, 646666, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 123400, 124950, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 124951, 125780, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 125781, 126300, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 126301, 129300, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 129301, 130380, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 620000, 621380, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 621381, 625540, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 625541, 627880, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 627881, 628300, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 628301, 634600, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 634601, 637580, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 637581, 640740, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 640741, 641540, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 641541, 647820, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 647821, 649640, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 649641, 653580, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 653581, 654660, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 654661, 661060, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 661061, 661700, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 661701, 666440, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 666441, 667980, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 667981, 674280, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 674281, 679300, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_332_NR5G_N077), 679301, 680000, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 620000, 620900, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 620901, 623760, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 623761, 625380, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 625381, 628580, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 628581, 633540, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 633541, 636200, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 636201, 638260, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 638261, 641640, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 641641, 646180, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 646181, 648660, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 648661, 651140, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_333_NR5G_N078), 651141, 653333, CAM_IMX471_SET_A_Full_774p4_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 693334, 694434, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 694435, 700734, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 700735, 704794, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 704795, 707674, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 707675, 713954, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 713955, 716834, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 716835, 720894, CAM_IMX471_SET_A_Full_723p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 720895, 727194, CAM_IMX471_SET_A_Full_793p6_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 727195, 728894, CAM_IMX471_SET_A_Full_771p2_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_334_NR5G_N079), 728895, 733333, CAM_IMX471_SET_A_Full_723p2_MHZ },
};

static const struct cam_mipi_sensor_mode sensor_front_top_mipi_A_mode[] = {
	{
		sensor_imx471_setfile_A_mipi_channel_FULL,	ARRAY_SIZE(sensor_imx471_setfile_A_mipi_channel_FULL),
		sensor_imx471_setfile_A_mipi_setting_FULL,	ARRAY_SIZE(sensor_imx471_setfile_A_mipi_setting_FULL)
	},
};

/*************************************/
/* ========== DUMMY ================ */
/*************************************/
enum {
	CAM_FRONT_TOP_SET_DUMMY_MHZ = 0,
};

struct cam_sensor_i2c_reg_array MIPI_FRONT_TOP_DUMMY_MHZ_REG_ARRAY[] = {
};

static const struct cam_sensor_i2c_reg_setting sensor_front_top_setfile_dummy_mhz[] = {
    { MIPI_FRONT_TOP_DUMMY_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FRONT_TOP_DUMMY_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_mipi_setting sensor_front_top_setfile_dummy_mipi_setting[] = {
	{ "DUMMY Mhz",
	  sensor_front_top_setfile_dummy_mhz, ARRAY_SIZE(sensor_front_top_setfile_dummy_mhz) },
};

static const struct cam_mipi_channel sensor_front_top_setfile_dummy_channel[] = {
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_001_GSM_GSM850), 0, 0, CAM_FRONT_TOP_SET_DUMMY_MHZ },
};


static const struct cam_mipi_sensor_mode sensor_front_top_mipi_B_mode[] = {
	{
		sensor_front_top_setfile_dummy_channel,	ARRAY_SIZE(sensor_front_top_setfile_dummy_channel),
		sensor_front_top_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_front_top_setfile_dummy_mipi_setting)
	},
};
static const struct cam_mipi_sensor_mode sensor_front_top_mipi_C_mode[] = {
	{
		sensor_front_top_setfile_dummy_channel,	ARRAY_SIZE(sensor_front_top_setfile_dummy_channel),
		sensor_front_top_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_front_top_setfile_dummy_mipi_setting)
	},
};

static const struct cam_mipi_sensor_mode sensor_front_top_mipi_D_mode[] = {
	{
		sensor_front_top_setfile_dummy_channel,	ARRAY_SIZE(sensor_front_top_setfile_dummy_channel),
		sensor_front_top_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_front_top_setfile_dummy_mipi_setting)
	},
};
#endif /* _CAM_SENSOR_ADAPTIVE_MIPI_IMX471_H_ */