/* Copyright (c) 2017, The Linux Foundation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _CAM_SENSOR_ADAPTIVE_MIPI_S5K2LD_H_
#define _CAM_SENSOR_ADAPTIVE_MIPI_S5K2LD_H_

#include "cam_sensor_dev.h"

int num_wide_mipi_setting = 1;

/*************************************/
/* ========== Mode A =============== */
/*************************************/

enum {
	CAM_S5K2LD_SET_A_FULL_3142_MHZ = 0,
	CAM_S5K2LD_SET_A_FULL_3232_MHZ = 1,
};

struct cam_sensor_i2c_reg_array MIPI_FULL_3142_MHZ_REG_ARRAY[] = {
    {0x0310, 0x01EB, 0x00, 0x00},
};

struct cam_sensor_i2c_reg_array MIPI_FULL_3232_MHZ_REG_ARRAY[] = {
    {0x0310, 0x01F9, 0x00, 0x00},
};

static const struct cam_sensor_i2c_reg_setting sensor_s5k2ld_setfile_A_mipi_FULL_3142_mhz[] = {
    { MIPI_FULL_3142_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_3142_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_sensor_i2c_reg_setting sensor_s5k2ld_setfile_A_mipi_FULL_3232_mhz[] = {
    { MIPI_FULL_3232_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_3232_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_mipi_setting sensor_s5k2ld_setfile_A_mipi_setting_FULL[] = {
	{ "3142 Mhz",
	  sensor_s5k2ld_setfile_A_mipi_FULL_3142_mhz, ARRAY_SIZE(sensor_s5k2ld_setfile_A_mipi_FULL_3142_mhz) },
	{ "3232 Mhz",
	  sensor_s5k2ld_setfile_A_mipi_FULL_3232_mhz, ARRAY_SIZE(sensor_s5k2ld_setfile_A_mipi_FULL_3232_mhz) },
};

static const struct cam_mipi_channel sensor_s5k2ld_setfile_A_mipi_channel_FULL[] = {
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_001_GSM_GSM850), 0, 0, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_002_GSM_EGSM900), 0, 0, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_003_GSM_DCS1800), 0, 0, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_004_GSM_PCS1900), 0, 0, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10562, 10735, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10736, 10787, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10788, 10838, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9662, 9744, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9745, 9791, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9792, 9938, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1162, 1177, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1178, 1252, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1253, 1324, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1325, 1396, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1397, 1513, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1537, 1710, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1711, 1738, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_015_WCDMA_WB05), 4357, 4414, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_015_WCDMA_WB05), 4415, 4458, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_016_WCDMA_WB06), 4387, 4413, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2237, 2292, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2293, 2563, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 2937, 2954, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 2955, 2975, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 2976, 3050, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 3051, 3088, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_029_WCDMA_WB19), 712, 739, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_029_WCDMA_WB19), 740, 763, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 0, 371, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 372, 475, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 476, 599, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 600, 613, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 614, 789, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 790, 883, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 884, 1199, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1200, 1254, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1255, 1404, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1405, 1549, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1550, 1693, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1694, 1929, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1930, 1949, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 1950, 2321, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 2322, 2399, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_095_LTE_LB05), 2400, 2538, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_095_LTE_LB05), 2539, 2649, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 2750, 2884, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 2885, 3449, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3450, 3509, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3510, 3551, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3552, 3701, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3702, 3799, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_102_LTE_LB12), 5010, 5051, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_102_LTE_LB12), 5052, 5179, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_103_LTE_LB13), 5180, 5279, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_104_LTE_LB14), 5280, 5320, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_104_LTE_LB14), 5321, 5379, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_107_LTE_LB17), 5730, 5849, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_108_LTE_LB18), 5850, 5928, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_108_LTE_LB18), 5929, 5999, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_109_LTE_LB19), 6000, 6078, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_109_LTE_LB19), 6079, 6149, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6150, 6244, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6245, 6394, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6395, 6449, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_111_LTE_LB21), 6450, 6599, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8040, 8053, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8054, 8229, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8230, 8323, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8324, 8672, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8673, 8689, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8690, 8778, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8779, 8928, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8929, 9039, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9210, 9250, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9251, 9400, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9401, 9634, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9635, 9659, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_119_LTE_LB29), 9660, 9769, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 9770, 9945, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 9946, 10095, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 10096, 10138, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 10139, 10288, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 10289, 10359, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_124_LTE_LB34), 36200, 36224, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_124_LTE_LB34), 36225, 36349, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37750, 38138, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 38139, 38249, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38250, 38369, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38370, 38613, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38614, 38649, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38650, 38660, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38661, 38789, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38790, 39141, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39142, 39217, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39218, 39430, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39431, 39549, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39550, 39649, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39650, 39678, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39679, 40009, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40010, 40106, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40107, 40249, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40250, 40351, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40352, 40778, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40779, 40876, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40877, 40910, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40911, 41455, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 41456, 41589, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41590, 41707, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41708, 41968, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41969, 42081, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42082, 42253, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42254, 42362, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42363, 42679, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42680, 42829, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42830, 42867, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42868, 42965, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42966, 43428, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43429, 43589, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55240, 55578, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55579, 55821, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55822, 56326, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56327, 56476, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56477, 56739, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66436, 66807, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66808, 66911, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66912, 67335, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68586, 68647, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68648, 68935, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_051_TDSCDMA_TD1), 0, 0, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_052_TDSCDMA_TD2), 0, 0, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_053_TDSCDMA_TD3), 0, 0, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_054_TDSCDMA_TD4), 0, 0, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_055_TDSCDMA_TD5), 0, 0, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_056_TDSCDMA_TD6), 0, 0, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_061_CDMA_BC0), 0, 0, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_062_CDMA_BC1), 0, 0, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_071_CDMA_BC10), 0, 0, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 173800, 177310, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 177311, 178780, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 185000, 190920, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 190921, 191980, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_267_NR5G_N012), 145800, 149200, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 158200, 159340, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 159341, 163090, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 163091, 164180, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 151600, 155500, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 155501, 159340, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 159341, 160580, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_321_NR5G_N066), 422000, 440000, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 123400, 125520, CAM_S5K2LD_SET_A_FULL_3142_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 125521, 130380, CAM_S5K2LD_SET_A_FULL_3232_MHZ },
};

static const struct cam_mipi_sensor_mode sensor_wide_mipi_A_mode[] = {
	{
		sensor_s5k2ld_setfile_A_mipi_channel_FULL,	ARRAY_SIZE(sensor_s5k2ld_setfile_A_mipi_channel_FULL),
		sensor_s5k2ld_setfile_A_mipi_setting_FULL,	ARRAY_SIZE(sensor_s5k2ld_setfile_A_mipi_setting_FULL)
	},
};

/*************************************/
/* ========== DUMMY ================ */
/*************************************/
enum {
	CAM_WIDE_SET_DUMMY_MHZ = 0,
};

struct cam_sensor_i2c_reg_array MIPI_WIDE_DUMMY_MHZ_REG_ARRAY[] = {
};

static const struct cam_sensor_i2c_reg_setting sensor_wide_setfile_dummy_mhz[] = {
    { MIPI_WIDE_DUMMY_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_WIDE_DUMMY_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_mipi_setting sensor_wide_setfile_dummy_mipi_setting[] = {
	{ "DUMMY Mhz",
	  sensor_wide_setfile_dummy_mhz, ARRAY_SIZE(sensor_wide_setfile_dummy_mhz) },
};

static const struct cam_mipi_channel sensor_wide_setfile_dummy_channel[] = {
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_001_GSM_GSM850), 0, 0, CAM_WIDE_SET_DUMMY_MHZ },
};

static const struct cam_mipi_sensor_mode sensor_wide_mipi_B_mode[] = {
	{
		sensor_wide_setfile_dummy_channel,	ARRAY_SIZE(sensor_wide_setfile_dummy_channel),
		sensor_wide_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_wide_setfile_dummy_mipi_setting)
	},
};

static const struct cam_mipi_sensor_mode sensor_wide_mipi_C_mode[] = {
	{
		sensor_wide_setfile_dummy_channel,	ARRAY_SIZE(sensor_wide_setfile_dummy_channel),
		sensor_wide_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_wide_setfile_dummy_mipi_setting)
	},
};

static const struct cam_mipi_sensor_mode sensor_wide_mipi_D_mode[] = {
	{
		sensor_wide_setfile_dummy_channel,	ARRAY_SIZE(sensor_wide_setfile_dummy_channel),
		sensor_wide_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_wide_setfile_dummy_mipi_setting)
	},
};
#endif /* _CAM_SENSOR_ADAPTIVE_MIPI_S5K2LD_H_ */
