/* Copyright (c) 2017, The Linux Foundation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef _CAM_SENSOR_ADAPTIVE_MIPI_S5K3K1_H_
#define _CAM_SENSOR_ADAPTIVE_MIPI_S5K3K1_H_

#include "cam_sensor_dev.h"

int num_tele_mipi_setting = 1;

/*
Mode A : Full mode, 2-Binning (1152 / 1196.8 / 1139.2)
*/

/*************************************/
/* ========== Mode A =============== */
/*************************************/

enum {
	CAM_S5K3K1_SET_A_FULL_1152_MHZ = 0,
	CAM_S5K3K1_SET_A_FULL_1196_MHZ = 1,
	CAM_S5K3K1_SET_A_FULL_1139_MHZ = 2,
};

struct cam_sensor_i2c_reg_array MIPI_FULL_1152_MHZ_REG_ARRAY[] = {
    {0x0310, 0x00B4, 0x00, 0x00},
};

struct cam_sensor_i2c_reg_array MIPI_FULL_1196_MHZ_REG_ARRAY[] = {
    {0x0310, 0x00BB, 0x00, 0x00},
};

struct cam_sensor_i2c_reg_array MIPI_FULL_1139_MHZ_REG_ARRAY[] = {
    {0x0310, 0x00B2, 0x00, 0x00},
};

static const struct cam_sensor_i2c_reg_setting sensor_s5k3k1_setfile_A_mipi_FULL_1152_mhz[] = {
    { MIPI_FULL_1152_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_1152_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_sensor_i2c_reg_setting sensor_s5k3k1_setfile_A_mipi_FULL_1196_mhz[] = {
    { MIPI_FULL_1196_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_1196_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_sensor_i2c_reg_setting sensor_s5k3k1_setfile_A_mipi_FULL_1139_mhz[] = {
    { MIPI_FULL_1139_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_FULL_1139_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_mipi_setting sensor_s5k3k1_setfile_A_mipi_setting_FULL[] = {
	{ "1152 Mhz",
	  sensor_s5k3k1_setfile_A_mipi_FULL_1152_mhz, ARRAY_SIZE(sensor_s5k3k1_setfile_A_mipi_FULL_1152_mhz) },
	{ "1196 Mhz",
	  sensor_s5k3k1_setfile_A_mipi_FULL_1196_mhz, ARRAY_SIZE(sensor_s5k3k1_setfile_A_mipi_FULL_1196_mhz) },
	{ "1139 Mhz",
	  sensor_s5k3k1_setfile_A_mipi_FULL_1139_mhz, ARRAY_SIZE(sensor_s5k3k1_setfile_A_mipi_FULL_1139_mhz) },
};

static const struct cam_mipi_channel sensor_s5k3k1_setfile_A_mipi_channel_FULL[] = {
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_001_GSM_GSM850), 0, 0, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_002_GSM_EGSM900), 0, 0, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_003_GSM_DCS1800), 0, 0, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_004_GSM_PCS1900), 0, 0, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10562, 10597, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10598, 10618, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10619, 10693, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_011_WCDMA_WB01), 10694, 10838, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9662, 9754, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9755, 9829, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_012_WCDMA_WB02), 9830, 9938, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1162, 1207, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1208, 1282, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1283, 1303, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1304, 1362, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1363, 1378, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_013_WCDMA_WB03), 1379, 1513, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1537, 1572, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1573, 1593, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1594, 1668, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_014_WCDMA_WB04), 1669, 1738, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_015_WCDMA_WB05), 4357, 4458, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_016_WCDMA_WB06), 4387, 4413, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2237, 2335, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2336, 2410, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2411, 2527, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2528, 2551, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_017_WCDMA_WB07), 2552, 2563, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 2937, 2945, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 2946, 3073, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_018_WCDMA_WB08), 3074, 3088, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_2_WCDMA, CAM_BAND_029_WCDMA_WB19), 712, 763, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 0, 94, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 95, 136, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 137, 286, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_091_LTE_LB01), 287, 599, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 600, 808, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 809, 958, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_092_LTE_LB02), 959, 1199, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1200, 1314, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1315, 1464, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1465, 1506, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1507, 1625, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1626, 1656, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_093_LTE_LB03), 1657, 1949, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 1950, 2044, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 2045, 2086, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 2087, 2236, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_094_LTE_LB04), 2237, 2399, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_095_LTE_LB05), 2400, 2424, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_095_LTE_LB05), 2425, 2649, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 2750, 2970, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 2971, 3120, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 3121, 3354, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 3355, 3402, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_097_LTE_LB07), 3403, 3449, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3450, 3490, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3491, 3746, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_098_LTE_LB08), 3747, 3799, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_102_LTE_LB12), 5010, 5132, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_102_LTE_LB12), 5133, 5179, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_103_LTE_LB13), 5180, 5279, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_104_LTE_LB14), 5280, 5304, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_104_LTE_LB14), 5305, 5379, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_107_LTE_LB17), 5730, 5802, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_107_LTE_LB17), 5803, 5849, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_108_LTE_LB18), 5850, 5964, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_108_LTE_LB18), 5965, 5999, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_109_LTE_LB19), 6000, 6149, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6150, 6259, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6260, 6293, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6294, 6378, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_110_LTE_LB20), 6379, 6449, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_111_LTE_LB21), 6450, 6525, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_111_LTE_LB21), 6526, 6541, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_111_LTE_LB21), 6542, 6599, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8040, 8248, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8249, 8398, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_115_LTE_LB25), 8399, 8689, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8690, 8814, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_116_LTE_LB26), 8815, 9039, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9210, 9234, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9235, 9334, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9335, 9384, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_118_LTE_LB28), 9385, 9659, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_119_LTE_LB29), 9660, 9769, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_120_LTE_LB30), 9770, 9810, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_120_LTE_LB30), 9811, 9869, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 9920, 10300, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_122_LTE_LB32), 10301, 10359, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_124_LTE_LB34), 36200, 36335, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_124_LTE_LB34), 36336, 36349, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37750, 37894, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37895, 37905, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 37906, 38044, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_128_LTE_LB38), 38045, 38249, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38250, 38428, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38429, 38523, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38524, 38532, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38533, 38574, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_129_LTE_LB39), 38575, 38649, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38650, 38663, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38664, 38764, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 38765, 39190, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39191, 39340, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39341, 39611, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_130_LTE_LB40), 39612, 39649, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39650, 39688, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39689, 39724, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39725, 39958, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 39959, 40108, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40109, 40534, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40535, 40545, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40546, 40684, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 40685, 41110, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 41111, 41260, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 41261, 41494, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 41495, 41542, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_131_LTE_LB41), 41543, 41589, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41590, 41623, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41624, 41649, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 41650, 42075, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42076, 42222, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42223, 42225, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42226, 42651, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42652, 42801, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 42802, 43035, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43036, 43185, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43186, 43227, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43228, 43377, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_132_LTE_LB42), 43378, 43589, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55240, 55335, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55336, 55377, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55378, 55527, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55528, 55953, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 55954, 56103, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56104, 56145, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56146, 56218, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56219, 56295, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56296, 56529, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56530, 56566, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56567, 56679, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_138_LTE_LB48), 56680, 56739, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66436, 66530, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66531, 66572, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66573, 66722, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 66723, 67148, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 67149, 67224, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 67225, 67298, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_156_LTE_LB66), 67299, 67335, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68586, 68676, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68677, 68826, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_3_LTE, CAM_BAND_161_LTE_LB71), 68827, 68935, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_051_TDSCDMA_TD1), 0, 0, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_052_TDSCDMA_TD2), 0, 0, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_053_TDSCDMA_TD3), 0, 0, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_054_TDSCDMA_TD4), 0, 0, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_055_TDSCDMA_TD5), 0, 0, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_4_TDSCDMA, CAM_BAND_056_TDSCDMA_TD6), 0, 0, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_061_CDMA_BC0), 0, 0, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_062_CDMA_BC1), 0, 0, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_5_CDMA, CAM_BAND_071_CDMA_BC10), 0, 0, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 173800, 175180, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_260_NR5G_N005), 175181, 178780, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 185000, 186700, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_263_NR5G_N008), 186701, 191980, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_267_NR5G_N012), 145800, 147340, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_267_NR5G_N012), 147341, 149200, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 158200, 160370, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 160371, 161960, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 161961, 163660, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_275_NR5G_N020), 163661, 164180, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 151600, 153730, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 153731, 155980, CAM_S5K3K1_SET_A_FULL_1139_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_283_NR5G_N028), 155981, 160580, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 123400, 124300, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 124301, 129100, CAM_S5K3K1_SET_A_FULL_1196_MHZ },
	{ CAM_RAT_BAND(CAM_RAT_7_NR5G, CAM_BAND_326_NR5G_N071), 129101, 130380, CAM_S5K3K1_SET_A_FULL_1152_MHZ },
};

static const struct cam_mipi_sensor_mode sensor_tele_mipi_A_mode[] = {
	{
		sensor_s5k3k1_setfile_A_mipi_channel_FULL,	ARRAY_SIZE(sensor_s5k3k1_setfile_A_mipi_channel_FULL),
		sensor_s5k3k1_setfile_A_mipi_setting_FULL,	ARRAY_SIZE(sensor_s5k3k1_setfile_A_mipi_setting_FULL)
	},
};

/*************************************/
/* ========== DUMMY ================ */
/*************************************/
enum {
	CAM_TELE_SET_DUMMY_MHZ = 0,
};

struct cam_sensor_i2c_reg_array MIPI_TELE_DUMMY_MHZ_REG_ARRAY[] = {
};

static const struct cam_sensor_i2c_reg_setting sensor_tele_setfile_dummy_mhz[] = {
    { MIPI_TELE_DUMMY_MHZ_REG_ARRAY, ARRAY_SIZE(MIPI_TELE_DUMMY_MHZ_REG_ARRAY),
	  CAMERA_SENSOR_I2C_TYPE_WORD, CAMERA_SENSOR_I2C_TYPE_WORD, 0 }
};

static const struct cam_mipi_setting sensor_tele_setfile_dummy_mipi_setting[] = {
	{ "DUMMY Mhz",
	  sensor_tele_setfile_dummy_mhz, ARRAY_SIZE(sensor_tele_setfile_dummy_mhz) },
};

static const struct cam_mipi_channel sensor_tele_setfile_dummy_channel[] = {
	{ CAM_RAT_BAND(CAM_RAT_1_GSM, CAM_BAND_001_GSM_GSM850), 0, 0, CAM_TELE_SET_DUMMY_MHZ },
};

static const struct cam_mipi_sensor_mode sensor_tele_mipi_B_mode[] = {
	{
		sensor_tele_setfile_dummy_channel,	ARRAY_SIZE(sensor_tele_setfile_dummy_channel),
		sensor_tele_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_tele_setfile_dummy_mipi_setting)
	},
};

static const struct cam_mipi_sensor_mode sensor_tele_mipi_C_mode[] = {
	{
		sensor_tele_setfile_dummy_channel,	ARRAY_SIZE(sensor_tele_setfile_dummy_channel),
		sensor_tele_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_tele_setfile_dummy_mipi_setting)
	},
};

static const struct cam_mipi_sensor_mode sensor_tele_mipi_D_mode[] = {
	{
		sensor_tele_setfile_dummy_channel,	ARRAY_SIZE(sensor_tele_setfile_dummy_channel),
		sensor_tele_setfile_dummy_mipi_setting,	ARRAY_SIZE(sensor_tele_setfile_dummy_mipi_setting)
	},
};
#endif /* _CAM_SENSOR_ADAPTIVE_MIPI_S5K3K1_H_ */
