/*
 * =================================================================
 *
 *
 *	Description:  samsung display common file
 *	Company:  Samsung Electronics
 *
 * ================================================================
 */
/*
<one line to give the program's name and a brief idea of what it does.>
Copyright (C) 2024, Samsung Electronics. All rights reserved.

*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
*/
#ifndef _SAMSUNG_DSI_MDNIE_E1_S6E3FAE_AMB616FM01_
#define _SAMSUNG_DSI_MDNIE_E1_S6E3FAE_AMB616FM01_

#include "ss_dsi_mdnie_lite_common.h"

#define MDNIE_COLOR_BLINDE_CMD_OFFSET 32
#define MDNIE_SCR_CMD_OFFSET 20

#define ADDRESS_SCR_WHITE_RED   0x32
#define ADDRESS_SCR_WHITE_GREEN 0x34
#define ADDRESS_SCR_WHITE_BLUE  0x36

#define SCR_BUFFER_WHITE_RED   30
#define SCR_BUFFER_WHITE_GREEN 32
#define SCR_BUFFER_WHITE_BLUE  34

#define MDNIE_STEP1_INDEX 1
#define MDNIE_STEP2_INDEX 2
#define MDNIE_STEP3_INDEX 3

#define MDNIE_TRANS_DIMMING_DATA_INDEX	18
#define MDNIE_TRANS_DIMMING_SLOPE_INDEX	20
#define MDNIE_LINEAR_ASCR_INDEX	1

#define VIVIDNESS_MAX_IDX 3
#define VIVIDNESS_3x3_MATRIX_IDX 3
#define VIVIDNESS_3x3_MATRIX_SIZE 18
#define VIVIDNESS_SKIN_TONE_IDX 20
#define VIVIDNESS_SKIN_TONE_SIZE 12

static char level_1_key_on[] = {
	0xF0,
	0x5A, 0x5A
};

static char level_1_key_off[] = {
	0xF0,
	0xA5, 0xA5
};

static char adjust_ldu_data_1[] = {
	0xff, 0xff, 0xff,
	0xff, 0xff, 0xff,
	0xff, 0xff, 0xff,
	0xff, 0xff, 0xff,
	0xff, 0xff, 0xff,
	0xff, 0xff, 0xff,
};

static char adjust_ldu_data_2[] = {
	0xff, 0xfb, 0xf3,
	0xff, 0xfb, 0xf3,
	0xff, 0xfb, 0xf3,
	0xff, 0xfb, 0xf3,
	0xff, 0xfb, 0xf3,
	0xff, 0xfb, 0xf3,
};

static char *adjust_ldu_data[MAX_MODE] = {
	adjust_ldu_data_2,
	adjust_ldu_data_2,
	adjust_ldu_data_2,
	adjust_ldu_data_1,
	adjust_ldu_data_1,
};

static char hbm_scr_data[] = {
	0xff,	0x30,	0x1f,	0xff,	0xff,	0x00,	0xff,	0x00,	0xff,	0xff,	0xff,	0xff,	0x00,	0xff,	0xff,	0x00,	0xff,	0x00,	0xff,	0x30,	0x00,	0xff,	0xff,	0x00,	0xff,	0x00,	0xf7,	0x00,	0x00,	0xff,	0xff,	0x00,	0xff,	0x00,	0xff,	0x00,
};

static char night_mode_data[] = {
	0xef, 0x00, 0x00, 0xff, 0xed, 0x00, 0xff, 0x10, 0xe6, 0xff, 0xfb, 0xf4, 0x3a, 0xef, 0xf6, 0x00, 0xe6, 0x00, 0xff, 0x00, 0x10, 0xf9, 0xe6, 0x00, 0xff, 0x09, 0xed, 0x00, 0x00, 0xf4, 0xff, 0x00, 0xfb, 0x00, 0xf4, 0x00, /*	6500K	*/
	0xef, 0x00, 0x00, 0xff, 0xec, 0x00, 0xff, 0x10, 0xe2, 0xff, 0xfa, 0xf0, 0x3a, 0xef, 0xf5, 0x00, 0xe2, 0x00, 0xff, 0x00, 0x10, 0xf8, 0xe2, 0x00, 0xff, 0x09, 0xec, 0x00, 0x00, 0xf0, 0xff, 0x00, 0xfa, 0x00, 0xf0, 0x00, /*	6300K	*/
	0xef, 0x00, 0x00, 0xff, 0xea, 0x00, 0xff, 0x10, 0xdd, 0xff, 0xf8, 0xeb, 0x3a, 0xef, 0xf3, 0x00, 0xdd, 0x00, 0xff, 0x00, 0x10, 0xf6, 0xdd, 0x00, 0xff, 0x09, 0xea, 0x00, 0x00, 0xeb, 0xff, 0x00, 0xf8, 0x00, 0xeb, 0x00, /*	6100K	*/
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd8, 0xff, 0xf6, 0xe5, 0x3a, 0xef, 0xf1, 0x00, 0xd8, 0x00, 0xff, 0x00, 0x0f, 0xf4, 0xd8, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe5, 0xff, 0x00, 0xf6, 0x00, 0xe5, 0x00, /*	5900K	*/
	0xef, 0x00, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x0f, 0xd3, 0xff, 0xf4, 0xe0, 0x3a, 0xef, 0xef, 0x00, 0xd3, 0x00, 0xff, 0x00, 0x0f, 0xf2, 0xd3, 0x00, 0xff, 0x09, 0xe7, 0x00, 0x00, 0xe0, 0xff, 0x00, 0xf4, 0x00, 0xe0, 0x00, /*	5700K	*/
	0xef, 0x00, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x0f, 0xce, 0xff, 0xf2, 0xDB, 0x3a, 0xef, 0xed, 0x00, 0xce, 0x00, 0xff, 0x00, 0x0f, 0xf0, 0xce, 0x00, 0xff, 0x09, 0xe5, 0x00, 0x00, 0xdb, 0xff, 0x00, 0xf2, 0x00, 0xDB, 0x00, /*	5500K	*/
	0xef, 0x00, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x0f, 0xbb, 0xff, 0xea, 0xc7, 0x3a, 0xef, 0xe5, 0x00, 0xbb, 0x00, 0xff, 0x00, 0x0f, 0xe8, 0xbb, 0x00, 0xff, 0x09, 0xdd, 0x00, 0x00, 0xc7, 0xff, 0x00, 0xea, 0x00, 0xc7, 0x00, /*	4900K	*/
	0xef, 0x00, 0x00, 0xff, 0xd5, 0x00, 0xff, 0x0e, 0xa8, 0xff, 0xe1, 0xb3, 0x3a, 0xef, 0xdd, 0x00, 0xa8, 0x00, 0xff, 0x00, 0x0e, 0xdf, 0xa8, 0x00, 0xff, 0x09, 0xd5, 0x00, 0x00, 0xb3, 0xff, 0x00, 0xe1, 0x00, 0xb3, 0x00,	/*	4300K	*/
	0xef, 0x00, 0x00, 0xff, 0xc9, 0x00, 0xff, 0x0d, 0x91, 0xff, 0xd5, 0x9a, 0x3a, 0xef, 0xd1, 0x00, 0x91, 0x00, 0xff, 0x00, 0x0d, 0xd3, 0x91, 0x00, 0xff, 0x09, 0xc9, 0x00, 0x00, 0x9a, 0xff, 0x00, 0xd5, 0x00, 0x9a, 0x00,	/*	3700K	*/
	0xef, 0x00, 0x00, 0xff, 0xbb, 0x00, 0xff, 0x0c, 0x76, 0xff, 0xc6, 0x7d, 0x3a, 0xef, 0xc2, 0x00, 0x76, 0x00, 0xff, 0x00, 0x0c, 0xc4, 0x76, 0x00, 0xff, 0x09, 0xbb, 0x00, 0x00, 0x7d, 0xff, 0x00, 0xc6, 0x00, 0x7d, 0x00,	/*	3100K	*/
	0xef, 0x00, 0x00, 0xff, 0xa0, 0x00, 0xff, 0x0b, 0x48, 0xff, 0xa9, 0x4d, 0x3a, 0xef, 0xa6, 0x00, 0x48, 0x00, 0xff, 0x00, 0x0b, 0xa8, 0x48, 0x00, 0xff, 0x09, 0xa0, 0x00, 0x00, 0x4d, 0xff, 0x00, 0xa9, 0x00, 0x4d, 0x00,	/*	2300K	*/

	0xef, 0x00, 0x00, 0xff, 0xe9, 0x00, 0xff, 0x0f, 0xdb, 0xff, 0xf7, 0xe9, 0x3a, 0xef, 0xf2, 0x00, 0xdb, 0x00, 0xff, 0x00, 0x0f, 0xf5, 0xdb, 0x00, 0xff, 0x09, 0xe9, 0x00, 0x00, 0xe9, 0xff, 0x00, 0xf7, 0x00, 0xe9, 0x00, 	/*	6000K	*/	/*	BLF	Vivid	Adaptive*/
	0xef, 0x00, 0x00, 0xff, 0xe9, 0x00, 0xff, 0x0f, 0xda, 0xff, 0xf7, 0xe8, 0x3a, 0xef, 0xf2, 0x00, 0xda, 0x00, 0xff, 0x00, 0x0f, 0xf5, 0xda, 0x00, 0xff, 0x09, 0xe9, 0x00, 0x00, 0xe8, 0xff, 0x00, 0xf7, 0x00, 0xe8, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe9, 0x00, 0xff, 0x0f, 0xda, 0xff, 0xf7, 0xe8, 0x3a, 0xef, 0xf2, 0x00, 0xda, 0x00, 0xff, 0x00, 0x0f, 0xf5, 0xda, 0x00, 0xff, 0x09, 0xe9, 0x00, 0x00, 0xe8, 0xff, 0x00, 0xf7, 0x00, 0xe8, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd9, 0xff, 0xf6, 0xe7, 0x3a, 0xef, 0xf1, 0x00, 0xd9, 0x00, 0xff, 0x00, 0x0f, 0xf4, 0xd9, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe7, 0xff, 0x00, 0xf6, 0x00, 0xe7, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd9, 0xff, 0xf6, 0xe7, 0x3a, 0xef, 0xf1, 0x00, 0xd9, 0x00, 0xff, 0x00, 0x0f, 0xf4, 0xd9, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe7, 0xff, 0x00, 0xf6, 0x00, 0xe7, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd8, 0xff, 0xf6, 0xe6, 0x3a, 0xef, 0xf1, 0x00, 0xd8, 0x00, 0xff, 0x00, 0x0f, 0xf4, 0xd8, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe6, 0xff, 0x00, 0xf6, 0x00, 0xe6, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd8, 0xff, 0xf6, 0xe6, 0x3a, 0xef, 0xf1, 0x00, 0xd8, 0x00, 0xff, 0x00, 0x0f, 0xf4, 0xd8, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe6, 0xff, 0x00, 0xf6, 0x00, 0xe6, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd8, 0xff, 0xf5, 0xe5, 0x3a, 0xef, 0xf0, 0x00, 0xd8, 0x00, 0xff, 0x00, 0x0f, 0xf3, 0xd8, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe5, 0xff, 0x00, 0xf5, 0x00, 0xe5, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd8, 0xff, 0xf5, 0xe5, 0x3a, 0xef, 0xf0, 0x00, 0xd8, 0x00, 0xff, 0x00, 0x0f, 0xf3, 0xd8, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe5, 0xff, 0x00, 0xf5, 0x00, 0xe5, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd7, 0xff, 0xf5, 0xe4, 0x3a, 0xef, 0xf0, 0x00, 0xd7, 0x00, 0xff, 0x00, 0x0f, 0xf3, 0xd7, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe4, 0xff, 0x00, 0xf5, 0x00, 0xe4, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd6, 0xff, 0xf5, 0xe3, 0x3a, 0xef, 0xf0, 0x00, 0xd6, 0x00, 0xff, 0x00, 0x0f, 0xf3, 0xd6, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe3, 0xff, 0x00, 0xf5, 0x00, 0xe3, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x0f, 0xd6, 0xff, 0xf5, 0xe3, 0x3a, 0xef, 0xf0, 0x00, 0xd6, 0x00, 0xff, 0x00, 0x0f, 0xf3, 0xd6, 0x00, 0xff, 0x09, 0xe8, 0x00, 0x00, 0xe3, 0xff, 0x00, 0xf5, 0x00, 0xe3, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x0f, 0xd5, 0xff, 0xf4, 0xe2, 0x3a, 0xef, 0xef, 0x00, 0xd5, 0x00, 0xff, 0x00, 0x0f, 0xf2, 0xd5, 0x00, 0xff, 0x09, 0xe7, 0x00, 0x00, 0xe2, 0xff, 0x00, 0xf4, 0x00, 0xe2, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x0f, 0xd5, 0xff, 0xf4, 0xe2, 0x3a, 0xef, 0xef, 0x00, 0xd5, 0x00, 0xff, 0x00, 0x0f, 0xf2, 0xd5, 0x00, 0xff, 0x09, 0xe7, 0x00, 0x00, 0xe2, 0xff, 0x00, 0xf4, 0x00, 0xe2, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x0f, 0xd4, 0xff, 0xf4, 0xe1, 0x3a, 0xef, 0xef, 0x00, 0xd4, 0x00, 0xff, 0x00, 0x0f, 0xf2, 0xd4, 0x00, 0xff, 0x09, 0xe7, 0x00, 0x00, 0xe1, 0xff, 0x00, 0xf4, 0x00, 0xe1, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x0f, 0xd4, 0xff, 0xf4, 0xe1, 0x3a, 0xef, 0xef, 0x00, 0xd4, 0x00, 0xff, 0x00, 0x0f, 0xf2, 0xd4, 0x00, 0xff, 0x09, 0xe7, 0x00, 0x00, 0xe1, 0xff, 0x00, 0xf4, 0x00, 0xe1, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe6, 0x00, 0xff, 0x0f, 0xd3, 0xff, 0xf3, 0xe0, 0x3a, 0xef, 0xee, 0x00, 0xd3, 0x00, 0xff, 0x00, 0x0f, 0xf1, 0xd3, 0x00, 0xff, 0x09, 0xe6, 0x00, 0x00, 0xe0, 0xff, 0x00, 0xf3, 0x00, 0xe0, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe6, 0x00, 0xff, 0x0f, 0xd3, 0xff, 0xf3, 0xe0, 0x3a, 0xef, 0xee, 0x00, 0xd3, 0x00, 0xff, 0x00, 0x0f, 0xf1, 0xd3, 0x00, 0xff, 0x09, 0xe6, 0x00, 0x00, 0xe0, 0xff, 0x00, 0xf3, 0x00, 0xe0, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe6, 0x00, 0xff, 0x0f, 0xd2, 0xff, 0xf3, 0xdf, 0x3a, 0xef, 0xee, 0x00, 0xd2, 0x00, 0xff, 0x00, 0x0f, 0xf1, 0xd2, 0x00, 0xff, 0x09, 0xe6, 0x00, 0x00, 0xdf, 0xff, 0x00, 0xf3, 0x00, 0xdf, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe6, 0x00, 0xff, 0x0f, 0xd1, 0xff, 0xf3, 0xde, 0x3a, 0xef, 0xee, 0x00, 0xd1, 0x00, 0xff, 0x00, 0x0f, 0xf1, 0xd1, 0x00, 0xff, 0x09, 0xe6, 0x00, 0x00, 0xde, 0xff, 0x00, 0xf3, 0x00, 0xde, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x0f, 0xd1, 0xff, 0xf2, 0xde, 0x3a, 0xef, 0xed, 0x00, 0xd1, 0x00, 0xff, 0x00, 0x0f, 0xf0, 0xd1, 0x00, 0xff, 0x09, 0xe5, 0x00, 0x00, 0xde, 0xff, 0x00, 0xf2, 0x00, 0xde, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x0f, 0xd0, 0xff, 0xf2, 0xdd, 0x3a, 0xef, 0xed, 0x00, 0xd0, 0x00, 0xff, 0x00, 0x0f, 0xf0, 0xd0, 0x00, 0xff, 0x09, 0xe5, 0x00, 0x00, 0xdd, 0xff, 0x00, 0xf2, 0x00, 0xdd, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x0f, 0xcf, 0xff, 0xf2, 0xdc, 0x3a, 0xef, 0xed, 0x00, 0xcf, 0x00, 0xff, 0x00, 0x0f, 0xf0, 0xcf, 0x00, 0xff, 0x09, 0xe5, 0x00, 0x00, 0xdc, 0xff, 0x00, 0xf2, 0x00, 0xdc, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x0f, 0xce, 0xff, 0xf2, 0xdb, 0x3a, 0xef, 0xed, 0x00, 0xce, 0x00, 0xff, 0x00, 0x0f, 0xf0, 0xce, 0x00, 0xff, 0x09, 0xe5, 0x00, 0x00, 0xdb, 0xff, 0x00, 0xf2, 0x00, 0xdb, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe4, 0x00, 0xff, 0x0f, 0xce, 0xff, 0xf1, 0xdb, 0x3a, 0xef, 0xec, 0x00, 0xce, 0x00, 0xff, 0x00, 0x0f, 0xef, 0xce, 0x00, 0xff, 0x09, 0xe4, 0x00, 0x00, 0xdb, 0xff, 0x00, 0xf1, 0x00, 0xdb, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe4, 0x00, 0xff, 0x0f, 0xcd, 0xff, 0xf1, 0xda, 0x3a, 0xef, 0xec, 0x00, 0xcd, 0x00, 0xff, 0x00, 0x0f, 0xef, 0xcd, 0x00, 0xff, 0x09, 0xe4, 0x00, 0x00, 0xda, 0xff, 0x00, 0xf1, 0x00, 0xda, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe4, 0x00, 0xff, 0x0f, 0xcc, 0xff, 0xf1, 0xd9, 0x3a, 0xef, 0xec, 0x00, 0xcc, 0x00, 0xff, 0x00, 0x0f, 0xef, 0xcc, 0x00, 0xff, 0x09, 0xe4, 0x00, 0x00, 0xd9, 0xff, 0x00, 0xf1, 0x00, 0xd9, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe4, 0x00, 0xff, 0x0f, 0xcc, 0xff, 0xf1, 0xd9, 0x3a, 0xef, 0xec, 0x00, 0xcc, 0x00, 0xff, 0x00, 0x0f, 0xef, 0xcc, 0x00, 0xff, 0x09, 0xe4, 0x00, 0x00, 0xd9, 0xff, 0x00, 0xf1, 0x00, 0xd9, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe3, 0x00, 0xff, 0x0f, 0xcb, 0xff, 0xf0, 0xd8, 0x3a, 0xef, 0xeb, 0x00, 0xcb, 0x00, 0xff, 0x00, 0x0f, 0xee, 0xcb, 0x00, 0xff, 0x09, 0xe3, 0x00, 0x00, 0xd8, 0xff, 0x00, 0xf0, 0x00, 0xd8, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe3, 0x00, 0xff, 0x0f, 0xca, 0xff, 0xf0, 0xd7, 0x3a, 0xef, 0xeb, 0x00, 0xca, 0x00, 0xff, 0x00, 0x0f, 0xee, 0xca, 0x00, 0xff, 0x09, 0xe3, 0x00, 0x00, 0xd7, 0xff, 0x00, 0xf0, 0x00, 0xd7, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe3, 0x00, 0xff, 0x0f, 0xc9, 0xff, 0xf0, 0xd6, 0x3a, 0xef, 0xeb, 0x00, 0xc9, 0x00, 0xff, 0x00, 0x0f, 0xee, 0xc9, 0x00, 0xff, 0x09, 0xe3, 0x00, 0x00, 0xd6, 0xff, 0x00, 0xf0, 0x00, 0xd6, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe2, 0x00, 0xff, 0x0f, 0xc9, 0xff, 0xef, 0xd6, 0x3a, 0xef, 0xea, 0x00, 0xc9, 0x00, 0xff, 0x00, 0x0f, 0xed, 0xc9, 0x00, 0xff, 0x09, 0xe2, 0x00, 0x00, 0xd6, 0xff, 0x00, 0xef, 0x00, 0xd6, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe2, 0x00, 0xff, 0x0f, 0xc8, 0xff, 0xef, 0xd5, 0x3a, 0xef, 0xea, 0x00, 0xc8, 0x00, 0xff, 0x00, 0x0f, 0xed, 0xc8, 0x00, 0xff, 0x09, 0xe2, 0x00, 0x00, 0xd5, 0xff, 0x00, 0xef, 0x00, 0xd5, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe2, 0x00, 0xff, 0x0f, 0xc8, 0xff, 0xef, 0xd4, 0x3a, 0xef, 0xea, 0x00, 0xc8, 0x00, 0xff, 0x00, 0x0f, 0xed, 0xc8, 0x00, 0xff, 0x09, 0xe2, 0x00, 0x00, 0xd4, 0xff, 0x00, 0xef, 0x00, 0xd4, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe2, 0x00, 0xff, 0x0f, 0xc7, 0xff, 0xef, 0xd3, 0x3a, 0xef, 0xea, 0x00, 0xc7, 0x00, 0xff, 0x00, 0x0f, 0xed, 0xc7, 0x00, 0xff, 0x09, 0xe2, 0x00, 0x00, 0xd3, 0xff, 0x00, 0xef, 0x00, 0xd3, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x0f, 0xc7, 0xff, 0xee, 0xd3, 0x3a, 0xef, 0xe9, 0x00, 0xc7, 0x00, 0xff, 0x00, 0x0f, 0xec, 0xc7, 0x00, 0xff, 0x09, 0xe1, 0x00, 0x00, 0xd3, 0xff, 0x00, 0xee, 0x00, 0xd3, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x0f, 0xc6, 0xff, 0xee, 0xd2, 0x3a, 0xef, 0xe9, 0x00, 0xc6, 0x00, 0xff, 0x00, 0x0f, 0xec, 0xc6, 0x00, 0xff, 0x09, 0xe1, 0x00, 0x00, 0xd2, 0xff, 0x00, 0xee, 0x00, 0xd2, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x0f, 0xc5, 0xff, 0xee, 0xd1, 0x3a, 0xef, 0xe9, 0x00, 0xc5, 0x00, 0xff, 0x00, 0x0f, 0xec, 0xc5, 0x00, 0xff, 0x09, 0xe1, 0x00, 0x00, 0xd1, 0xff, 0x00, 0xee, 0x00, 0xd1, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe0, 0x00, 0xff, 0x0f, 0xc5, 0xff, 0xed, 0xd1, 0x3a, 0xef, 0xe8, 0x00, 0xc5, 0x00, 0xff, 0x00, 0x0f, 0xeb, 0xc5, 0x00, 0xff, 0x09, 0xe0, 0x00, 0x00, 0xd1, 0xff, 0x00, 0xed, 0x00, 0xd1, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe0, 0x00, 0xff, 0x0f, 0xc4, 0xff, 0xed, 0xd0, 0x3a, 0xef, 0xe8, 0x00, 0xc4, 0x00, 0xff, 0x00, 0x0f, 0xeb, 0xc4, 0x00, 0xff, 0x09, 0xe0, 0x00, 0x00, 0xd0, 0xff, 0x00, 0xed, 0x00, 0xd0, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe0, 0x00, 0xff, 0x0f, 0xc3, 0xff, 0xed, 0xcf, 0x3a, 0xef, 0xe8, 0x00, 0xc3, 0x00, 0xff, 0x00, 0x0f, 0xeb, 0xc3, 0x00, 0xff, 0x09, 0xe0, 0x00, 0x00, 0xcf, 0xff, 0x00, 0xed, 0x00, 0xcf, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xe0, 0x00, 0xff, 0x0f, 0xc3, 0xff, 0xed, 0xcf, 0x3a, 0xef, 0xe8, 0x00, 0xc3, 0x00, 0xff, 0x00, 0x0f, 0xeb, 0xc3, 0x00, 0xff, 0x09, 0xe0, 0x00, 0x00, 0xcf, 0xff, 0x00, 0xed, 0x00, 0xcf, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdf, 0x00, 0xff, 0x0f, 0xc2, 0xff, 0xec, 0xce, 0x3a, 0xef, 0xe7, 0x00, 0xc2, 0x00, 0xff, 0x00, 0x0f, 0xea, 0xc2, 0x00, 0xff, 0x09, 0xdf, 0x00, 0x00, 0xce, 0xff, 0x00, 0xec, 0x00, 0xce, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdf, 0x00, 0xff, 0x0f, 0xc1, 0xff, 0xec, 0xcd, 0x3a, 0xef, 0xe7, 0x00, 0xc1, 0x00, 0xff, 0x00, 0x0f, 0xea, 0xc1, 0x00, 0xff, 0x09, 0xdf, 0x00, 0x00, 0xcd, 0xff, 0x00, 0xec, 0x00, 0xcd, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdf, 0x00, 0xff, 0x0f, 0xc1, 0xff, 0xec, 0xcd, 0x3a, 0xef, 0xe7, 0x00, 0xc1, 0x00, 0xff, 0x00, 0x0f, 0xea, 0xc1, 0x00, 0xff, 0x09, 0xdf, 0x00, 0x00, 0xcd, 0xff, 0x00, 0xec, 0x00, 0xcd, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdf, 0x00, 0xff, 0x0f, 0xc0, 0xff, 0xec, 0xcc, 0x3a, 0xef, 0xe7, 0x00, 0xc0, 0x00, 0xff, 0x00, 0x0f, 0xea, 0xc0, 0x00, 0xff, 0x09, 0xdf, 0x00, 0x00, 0xcc, 0xff, 0x00, 0xec, 0x00, 0xcc, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xde, 0x00, 0xff, 0x0f, 0xbf, 0xff, 0xeb, 0xcb, 0x3a, 0xef, 0xe6, 0x00, 0xbf, 0x00, 0xff, 0x00, 0x0f, 0xe9, 0xbf, 0x00, 0xff, 0x09, 0xde, 0x00, 0x00, 0xcb, 0xff, 0x00, 0xeb, 0x00, 0xcb, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xde, 0x00, 0xff, 0x0f, 0xbf, 0xff, 0xeb, 0xcb, 0x3a, 0xef, 0xe6, 0x00, 0xbf, 0x00, 0xff, 0x00, 0x0f, 0xe9, 0xbf, 0x00, 0xff, 0x09, 0xde, 0x00, 0x00, 0xcb, 0xff, 0x00, 0xeb, 0x00, 0xcb, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xde, 0x00, 0xff, 0x0f, 0xbe, 0xff, 0xeb, 0xca, 0x3a, 0xef, 0xe6, 0x00, 0xbe, 0x00, 0xff, 0x00, 0x0f, 0xe9, 0xbe, 0x00, 0xff, 0x09, 0xde, 0x00, 0x00, 0xca, 0xff, 0x00, 0xeb, 0x00, 0xca, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x0f, 0xbd, 0xff, 0xea, 0xc9, 0x3a, 0xef, 0xe5, 0x00, 0xbd, 0x00, 0xff, 0x00, 0x0f, 0xe8, 0xbd, 0x00, 0xff, 0x09, 0xdd, 0x00, 0x00, 0xc9, 0xff, 0x00, 0xea, 0x00, 0xc9, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x0f, 0xbd, 0xff, 0xea, 0xc9, 0x3a, 0xef, 0xe5, 0x00, 0xbd, 0x00, 0xff, 0x00, 0x0f, 0xe8, 0xbd, 0x00, 0xff, 0x09, 0xdd, 0x00, 0x00, 0xc9, 0xff, 0x00, 0xea, 0x00, 0xc9, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x0f, 0xbc, 0xff, 0xea, 0xc8, 0x3a, 0xef, 0xe5, 0x00, 0xbc, 0x00, 0xff, 0x00, 0x0f, 0xe8, 0xbc, 0x00, 0xff, 0x09, 0xdd, 0x00, 0x00, 0xc8, 0xff, 0x00, 0xea, 0x00, 0xc8, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x0f, 0xbb, 0xff, 0xea, 0xc7, 0x3a, 0xef, 0xe5, 0x00, 0xbb, 0x00, 0xff, 0x00, 0x0f, 0xe8, 0xbb, 0x00, 0xff, 0x09, 0xdd, 0x00, 0x00, 0xc7, 0xff, 0x00, 0xea, 0x00, 0xc7, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdc, 0x00, 0xff, 0x0f, 0xbb, 0xff, 0xe9, 0xc7, 0x3a, 0xef, 0xe4, 0x00, 0xbb, 0x00, 0xff, 0x00, 0x0f, 0xe7, 0xbb, 0x00, 0xff, 0x09, 0xdc, 0x00, 0x00, 0xc7, 0xff, 0x00, 0xe9, 0x00, 0xc7, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdc, 0x00, 0xff, 0x0f, 0xba, 0xff, 0xe9, 0xc6, 0x3a, 0xef, 0xe4, 0x00, 0xba, 0x00, 0xff, 0x00, 0x0f, 0xe7, 0xba, 0x00, 0xff, 0x09, 0xdc, 0x00, 0x00, 0xc6, 0xff, 0x00, 0xe9, 0x00, 0xc6, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdc, 0x00, 0xff, 0x0f, 0xb9, 0xff, 0xe9, 0xc5, 0x3a, 0xef, 0xe4, 0x00, 0xb9, 0x00, 0xff, 0x00, 0x0f, 0xe7, 0xb9, 0x00, 0xff, 0x09, 0xdc, 0x00, 0x00, 0xc5, 0xff, 0x00, 0xe9, 0x00, 0xc5, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdb, 0x00, 0xff, 0x0f, 0xb8, 0xff, 0xe8, 0xc4, 0x3a, 0xef, 0xe3, 0x00, 0xb8, 0x00, 0xff, 0x00, 0x0f, 0xe6, 0xb8, 0x00, 0xff, 0x09, 0xdb, 0x00, 0x00, 0xc4, 0xff, 0x00, 0xe8, 0x00, 0xc4, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdb, 0x00, 0xff, 0x0f, 0xb8, 0xff, 0xe8, 0xc4, 0x3a, 0xef, 0xe3, 0x00, 0xb8, 0x00, 0xff, 0x00, 0x0f, 0xe6, 0xb8, 0x00, 0xff, 0x09, 0xdb, 0x00, 0x00, 0xc4, 0xff, 0x00, 0xe8, 0x00, 0xc4, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xdb, 0x00, 0xff, 0x0f, 0xb8, 0xff, 0xe8, 0xc3, 0x3a, 0xef, 0xe3, 0x00, 0xb8, 0x00, 0xff, 0x00, 0x0f, 0xe6, 0xb8, 0x00, 0xff, 0x09, 0xdb, 0x00, 0x00, 0xc3, 0xff, 0x00, 0xe8, 0x00, 0xc3, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xda, 0x00, 0xff, 0x0e, 0xb7, 0xff, 0xe7, 0xc2, 0x3a, 0xef, 0xe2, 0x00, 0xb7, 0x00, 0xff, 0x00, 0x0e, 0xe5, 0xb7, 0x00, 0xff, 0x09, 0xda, 0x00, 0x00, 0xc2, 0xff, 0x00, 0xe7, 0x00, 0xc2, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xda, 0x00, 0xff, 0x0e, 0xb6, 0xff, 0xe7, 0xc1, 0x3a, 0xef, 0xe2, 0x00, 0xb6, 0x00, 0xff, 0x00, 0x0e, 0xe5, 0xb6, 0x00, 0xff, 0x09, 0xda, 0x00, 0x00, 0xc1, 0xff, 0x00, 0xe7, 0x00, 0xc1, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xda, 0x00, 0xff, 0x0e, 0xb6, 0xff, 0xe7, 0xc1, 0x3a, 0xef, 0xe2, 0x00, 0xb6, 0x00, 0xff, 0x00, 0x0e, 0xe5, 0xb6, 0x00, 0xff, 0x09, 0xda, 0x00, 0x00, 0xc1, 0xff, 0x00, 0xe7, 0x00, 0xc1, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd9, 0x00, 0xff, 0x0e, 0xb5, 0xff, 0xe6, 0xc0, 0x3a, 0xef, 0xe1, 0x00, 0xb5, 0x00, 0xff, 0x00, 0x0e, 0xe4, 0xb5, 0x00, 0xff, 0x09, 0xd9, 0x00, 0x00, 0xc0, 0xff, 0x00, 0xe6, 0x00, 0xc0, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd9, 0x00, 0xff, 0x0e, 0xb4, 0xff, 0xe6, 0xbf, 0x3a, 0xef, 0xe1, 0x00, 0xb4, 0x00, 0xff, 0x00, 0x0e, 0xe4, 0xb4, 0x00, 0xff, 0x09, 0xd9, 0x00, 0x00, 0xbf, 0xff, 0x00, 0xe6, 0x00, 0xbf, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd9, 0x00, 0xff, 0x0e, 0xb3, 0xff, 0xe6, 0xbe, 0x3a, 0xef, 0xe1, 0x00, 0xb3, 0x00, 0xff, 0x00, 0x0e, 0xe4, 0xb3, 0x00, 0xff, 0x09, 0xd9, 0x00, 0x00, 0xbe, 0xff, 0x00, 0xe6, 0x00, 0xbe, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd8, 0x00, 0xff, 0x0e, 0xb2, 0xff, 0xe5, 0xbd, 0x3a, 0xef, 0xe1, 0x00, 0xb2, 0x00, 0xff, 0x00, 0x0e, 0xe3, 0xb2, 0x00, 0xff, 0x09, 0xd8, 0x00, 0x00, 0xbd, 0xff, 0x00, 0xe5, 0x00, 0xbd, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd8, 0x00, 0xff, 0x0e, 0xb2, 0xff, 0xe5, 0xbd, 0x3a, 0xef, 0xe1, 0x00, 0xb2, 0x00, 0xff, 0x00, 0x0e, 0xe3, 0xb2, 0x00, 0xff, 0x09, 0xd8, 0x00, 0x00, 0xbd, 0xff, 0x00, 0xe5, 0x00, 0xbd, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd8, 0x00, 0xff, 0x0e, 0xb1, 0xff, 0xe5, 0xbc, 0x3a, 0xef, 0xe1, 0x00, 0xb1, 0x00, 0xff, 0x00, 0x0e, 0xe3, 0xb1, 0x00, 0xff, 0x09, 0xd8, 0x00, 0x00, 0xbc, 0xff, 0x00, 0xe5, 0x00, 0xbc, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x0e, 0xb0, 0xff, 0xe4, 0xbb, 0x3a, 0xef, 0xe0, 0x00, 0xb0, 0x00, 0xff, 0x00, 0x0e, 0xe2, 0xb0, 0x00, 0xff, 0x09, 0xd7, 0x00, 0x00, 0xbb, 0xff, 0x00, 0xe4, 0x00, 0xbb, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x0e, 0xaf, 0xff, 0xe4, 0xba, 0x3a, 0xef, 0xe0, 0x00, 0xaf, 0x00, 0xff, 0x00, 0x0e, 0xe2, 0xaf, 0x00, 0xff, 0x09, 0xd7, 0x00, 0x00, 0xba, 0xff, 0x00, 0xe4, 0x00, 0xba, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x0e, 0xaf, 0xff, 0xe4, 0xba, 0x3a, 0xef, 0xe0, 0x00, 0xaf, 0x00, 0xff, 0x00, 0x0e, 0xe2, 0xaf, 0x00, 0xff, 0x09, 0xd7, 0x00, 0x00, 0xba, 0xff, 0x00, 0xe4, 0x00, 0xba, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x0e, 0xae, 0xff, 0xe3, 0xb9, 0x3a, 0xef, 0xdf, 0x00, 0xae, 0x00, 0xff, 0x00, 0x0e, 0xe1, 0xae, 0x00, 0xff, 0x09, 0xd7, 0x00, 0x00, 0xb9, 0xff, 0x00, 0xe3, 0x00, 0xb9, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x0e, 0xad, 0xff, 0xe3, 0xb8, 0x3a, 0xef, 0xdf, 0x00, 0xad, 0x00, 0xff, 0x00, 0x0e, 0xe1, 0xad, 0x00, 0xff, 0x09, 0xd7, 0x00, 0x00, 0xb8, 0xff, 0x00, 0xe3, 0x00, 0xb8, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x0e, 0xac, 0xff, 0xe3, 0xb7, 0x3a, 0xef, 0xdf, 0x00, 0xac, 0x00, 0xff, 0x00, 0x0e, 0xe1, 0xac, 0x00, 0xff, 0x09, 0xd7, 0x00, 0x00, 0xb7, 0xff, 0x00, 0xe3, 0x00, 0xb7, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd6, 0x00, 0xff, 0x0e, 0xab, 0xff, 0xe2, 0xb6, 0x3a, 0xef, 0xde, 0x00, 0xab, 0x00, 0xff, 0x00, 0x0e, 0xe0, 0xab, 0x00, 0xff, 0x09, 0xd6, 0x00, 0x00, 0xb6, 0xff, 0x00, 0xe2, 0x00, 0xb6, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd6, 0x00, 0xff, 0x0e, 0xaa, 0xff, 0xe2, 0xb5, 0x3a, 0xef, 0xde, 0x00, 0xaa, 0x00, 0xff, 0x00, 0x0e, 0xe0, 0xaa, 0x00, 0xff, 0x09, 0xd6, 0x00, 0x00, 0xb5, 0xff, 0x00, 0xe2, 0x00, 0xb5, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd5, 0x00, 0xff, 0x0e, 0xa9, 0xff, 0xe1, 0xb4, 0x3a, 0xef, 0xdd, 0x00, 0xa9, 0x00, 0xff, 0x00, 0x0e, 0xdf, 0xa9, 0x00, 0xff, 0x09, 0xd5, 0x00, 0x00, 0xb4, 0xff, 0x00, 0xe1, 0x00, 0xb4, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd5, 0x00, 0xff, 0x0e, 0xa8, 0xff, 0xe1, 0xb3, 0x3a, 0xef, 0xdd, 0x00, 0xa8, 0x00, 0xff, 0x00, 0x0e, 0xdf, 0xa8, 0x00, 0xff, 0x09, 0xd5, 0x00, 0x00, 0xb3, 0xff, 0x00, 0xe1, 0x00, 0xb3, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd4, 0x00, 0xff, 0x0e, 0xa8, 0xff, 0xe0, 0xb2, 0x3a, 0xef, 0xdc, 0x00, 0xa8, 0x00, 0xff, 0x00, 0x0e, 0xde, 0xa8, 0x00, 0xff, 0x09, 0xd4, 0x00, 0x00, 0xb2, 0xff, 0x00, 0xe0, 0x00, 0xb2, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd4, 0x00, 0xff, 0x0e, 0xa7, 0xff, 0xe0, 0xb1, 0x3a, 0xef, 0xdc, 0x00, 0xa7, 0x00, 0xff, 0x00, 0x0e, 0xde, 0xa7, 0x00, 0xff, 0x09, 0xd4, 0x00, 0x00, 0xb1, 0xff, 0x00, 0xe0, 0x00, 0xb1, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd3, 0x00, 0xff, 0x0e, 0xa6, 0xff, 0xdf, 0xb0, 0x3a, 0xef, 0xdb, 0x00, 0xa6, 0x00, 0xff, 0x00, 0x0e, 0xdd, 0xa6, 0x00, 0xff, 0x09, 0xd3, 0x00, 0x00, 0xb0, 0xff, 0x00, 0xdf, 0x00, 0xb0, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd3, 0x00, 0xff, 0x0e, 0xa6, 0xff, 0xdf, 0xb0, 0x3a, 0xef, 0xdb, 0x00, 0xa6, 0x00, 0xff, 0x00, 0x0e, 0xdd, 0xa6, 0x00, 0xff, 0x09, 0xd3, 0x00, 0x00, 0xb0, 0xff, 0x00, 0xdf, 0x00, 0xb0, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd3, 0x00, 0xff, 0x0e, 0xa5, 0xff, 0xdf, 0xaf, 0x3a, 0xef, 0xdb, 0x00, 0xa5, 0x00, 0xff, 0x00, 0x0e, 0xdd, 0xa5, 0x00, 0xff, 0x09, 0xd3, 0x00, 0x00, 0xaf, 0xff, 0x00, 0xdf, 0x00, 0xaf, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd2, 0x00, 0xff, 0x0e, 0xa4, 0xff, 0xde, 0xae, 0x3a, 0xef, 0xda, 0x00, 0xa4, 0x00, 0xff, 0x00, 0x0e, 0xdc, 0xa4, 0x00, 0xff, 0x09, 0xd2, 0x00, 0x00, 0xae, 0xff, 0x00, 0xde, 0x00, 0xae, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd2, 0x00, 0xff, 0x0e, 0xa3, 0xff, 0xde, 0xad, 0x3a, 0xef, 0xda, 0x00, 0xa3, 0x00, 0xff, 0x00, 0x0e, 0xdc, 0xa3, 0x00, 0xff, 0x09, 0xd2, 0x00, 0x00, 0xad, 0xff, 0x00, 0xde, 0x00, 0xad, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd1, 0x00, 0xff, 0x0e, 0xa2, 0xff, 0xdd, 0xac, 0x3a, 0xef, 0xd9, 0x00, 0xa2, 0x00, 0xff, 0x00, 0x0e, 0xdb, 0xa2, 0x00, 0xff, 0x09, 0xd1, 0x00, 0x00, 0xac, 0xff, 0x00, 0xdd, 0x00, 0xac, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd1, 0x00, 0xff, 0x0e, 0xa1, 0xff, 0xdd, 0xab, 0x3a, 0xef, 0xd9, 0x00, 0xa1, 0x00, 0xff, 0x00, 0x0e, 0xdb, 0xa1, 0x00, 0xff, 0x09, 0xd1, 0x00, 0x00, 0xab, 0xff, 0x00, 0xdd, 0x00, 0xab, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd0, 0x00, 0xff, 0x0e, 0xa0, 0xff, 0xdc, 0xaa, 0x3a, 0xef, 0xd8, 0x00, 0xa0, 0x00, 0xff, 0x00, 0x0e, 0xda, 0xa0, 0x00, 0xff, 0x09, 0xd0, 0x00, 0x00, 0xaa, 0xff, 0x00, 0xdc, 0x00, 0xaa, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xd0, 0x00, 0xff, 0x0e, 0x9f, 0xff, 0xdc, 0xa9, 0x3a, 0xef, 0xd8, 0x00, 0x9f, 0x00, 0xff, 0x00, 0x0e, 0xda, 0x9f, 0x00, 0xff, 0x09, 0xd0, 0x00, 0x00, 0xa9, 0xff, 0x00, 0xdc, 0x00, 0xa9, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xcf, 0x00, 0xff, 0x0e, 0x9e, 0xff, 0xdb, 0xa8, 0x3a, 0xef, 0xd7, 0x00, 0x9e, 0x00, 0xff, 0x00, 0x0e, 0xd9, 0x9e, 0x00, 0xff, 0x09, 0xcf, 0x00, 0x00, 0xa8, 0xff, 0x00, 0xdb, 0x00, 0xa8, 0x00,
	0xef, 0x00, 0x00, 0xff, 0xcf, 0x00, 0xff, 0x0e, 0x9d, 0xff, 0xdb, 0xa7, 0x3a, 0xef, 0xd7, 0x00, 0x9d, 0x00, 0xff, 0x00, 0x0e, 0xd9, 0x9d, 0x00, 0xff, 0x09, 0xcf, 0x00, 0x00, 0xa7, 0xff, 0x00, 0xdb, 0x00, 0xa7, 0x00, /*	4000K	*/

	0xdb,	0x2b,	0x24,	0xfa,	0xf5,	0x5d,	0xe0,	0x32,	0xdf,	0xff,	0xfc,	0xf6,	0x72,	0xdb,	0xf6,	0x2b,	0xf0,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xdf,	0x56,	0xfa,	0x25,	0xf5,	0x00,	0x5d,	0xe7,	0xff,	0x00,	0xfb,	0x00,	0xf4,	0x00, /*	6500K	*/ /* Night Dim Vivid custom without black */
	0xda,	0x2b,	0x24,	0xf9,	0xf5,	0x5d,	0xe0,	0x32,	0xde,	0xff,	0xfb,	0xf3,	0x72,	0xda,	0xf6,	0x2b,	0xef,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xde,	0x56,	0xf9,	0x25,	0xf5,	0x00,	0x5d,	0xe6,	0xff,	0x00,	0xfa,	0x00,	0xf0,	0x00,
	0xda,	0x2b,	0x24,	0xf8,	0xf4,	0x5c,	0xe0,	0x31,	0xdc,	0xff,	0xfa,	0xef,	0x71,	0xda,	0xf5,	0x2b,	0xed,	0x24,	0xe0,	0x6b,	0x31,	0xef,	0xdc,	0x55,	0xf8,	0x25,	0xf4,	0x00,	0x5c,	0xe3,	0xff,	0x00,	0xf8,	0x00,	0xeb,	0x00,
	0xd9,	0x2b,	0x24,	0xf8,	0xf3,	0x5b,	0xe0,	0x31,	0xda,	0xff,	0xf8,	0xeb,	0x71,	0xd9,	0xf3,	0x2b,	0xeb,	0x24,	0xe0,	0x6b,	0x31,	0xed,	0xda,	0x55,	0xf8,	0x25,	0xf3,	0x00,	0x5b,	0xe1,	0xff,	0x00,	0xf6,	0x00,	0xe5,	0x00,
	0xd8,	0x2b,	0x23,	0xf7,	0xf2,	0x5b,	0xdf,	0x31,	0xd8,	0xff,	0xf7,	0xe7,	0x70,	0xd8,	0xf2,	0x2b,	0xe9,	0x23,	0xdf,	0x6b,	0x31,	0xec,	0xd8,	0x55,	0xf7,	0x25,	0xf2,	0x00,	0x5b,	0xde,	0xff,	0x00,	0xf4,	0x00,	0xe0,	0x00,
	0xd8,	0x2b,	0x23,	0xf6,	0xf0,	0x5a,	0xde,	0x31,	0xd6,	0xff,	0xf5,	0xe2,	0x6f,	0xd8,	0xf1,	0x2b,	0xe7,	0x23,	0xde,	0x6a,	0x31,	0xeb,	0xd6,	0x54,	0xf6,	0x25,	0xf0,	0x00,	0x5a,	0xdb,	0xff,	0x00,	0xf2,	0x00,	0xDB,	0x00,
	0xd6,	0x2a,	0x23,	0xf3,	0xeb,	0x58,	0xdb,	0x2f,	0xce,	0xff,	0xf0,	0xd3,	0x6d,	0xd6,	0xec,	0x2a,	0xde,	0x23,	0xdb,	0x67,	0x2f,	0xe6,	0xce,	0x52,	0xf3,	0x25,	0xeb,	0x00,	0x58,	0xd4,	0xff,	0x00,	0xea,	0x00,	0xc7,	0x00,
	0xd2,	0x29,	0x22,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x69,	0xd2,	0xe6,	0x29,	0xd3,	0x22,	0xd8,	0x65,	0x2e,	0xe0,	0xc3,	0x50,	0xf0,	0x23,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe1,	0x00,	0xb3,	0x00,
	0xd0,	0x27,	0x21,	0xec,	0xdf,	0x54,	0xd4,	0x2d,	0xb7,	0xff,	0xe0,	0xa4,	0x67,	0xd0,	0xdf,	0x27,	0xc7,	0x21,	0xd4,	0x62,	0x2d,	0xda,	0xb7,	0x4e,	0xec,	0x23,	0xdf,	0x00,	0x54,	0xbe,	0xff,	0x00,	0xd5,	0x00,	0x9a,	0x00,
	0xcc,	0x26,	0x20,	0xe8,	0xd6,	0x51,	0xd1,	0x2b,	0xaa,	0xff,	0xd3,	0x86,	0x63,	0xcc,	0xd6,	0x26,	0xb9,	0x20,	0xd1,	0x5f,	0x2b,	0xd2,	0xaa,	0x4c,	0xe8,	0x21,	0xd6,	0x00,	0x51,	0xb1,	0xff,	0x00,	0xc6,	0x00,	0x7d,	0x00,
	0xc2,	0x23,	0x1d,	0xdc,	0xc1,	0x4b,	0xc7,	0x27,	0x90,	0xff,	0xb8,	0x58,	0x5b,	0xc2,	0xc1,	0x23,	0x9e,	0x1d,	0xc7,	0x57,	0x27,	0xbe,	0x90,	0x45,	0xdc,	0x1f,	0xc1,	0x00,	0x4b,	0x97,	0xff,	0x00,	0xa9,	0x00,	0x4d,	0x00, /*	2300K	*/

	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x00,	0xf7,	0x00,	0xe9,	0x00, /* 6000K */ /* Night Dim Vivid adaptive without black*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x00,	0xf7,	0x00,	0xe8,	0x00, /* Color Gamut 95%~80% & Gray only 0*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe2,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe7,	0xff,	0x00,	0xf7,	0x00,	0xe8,	0x00,
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe1,	0xff,	0xf8,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe1,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe6,	0xff,	0x00,	0xf6,	0x00,	0xe7,	0x00,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x38,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf6,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x34,	0xfb,	0x17,	0xf5,	0x00,	0x38,	0xe6,	0xff,	0x00,	0xf6,	0x00,	0xe7,	0x00,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe6,	0xff,	0x00,	0xf6,	0x00,	0xe6,	0x00,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe0,	0xff,	0xf8,	0xea,	0x47,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x43,	0x1f,	0xf2,	0xe0,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe5,	0xff,	0x00,	0xf6,	0x00,	0xe6,	0x00,
	0xe7,	0x1b,	0x17,	0xfb,	0xf5,	0x3a,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xea,	0x48,	0xe7,	0xf5,	0x1b,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfb,	0x17,	0xf5,	0x00,	0x3a,	0xe5,	0xff,	0x00,	0xf5,	0x00,	0xe5,	0x00,
	0xe7,	0x1c,	0x17,	0xfa,	0xf5,	0x3b,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xe9,	0x48,	0xe7,	0xf5,	0x1c,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfa,	0x18,	0xf5,	0x00,	0x3b,	0xe4,	0xff,	0x00,	0xf5,	0x00,	0xe5,	0x00,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3b,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe9,	0x49,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x45,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3b,	0xe4,	0xff,	0x00,	0xf5,	0x00,	0xe4,	0x00,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe8,	0x4a,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x46,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x00,	0xf5,	0x00,	0xe3,	0x00,
	0xe6,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe8,	0x4a,	0xe6,	0xf4,	0x1c,	0xea,	0x18,	0xea,	0x46,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x00,	0xf5,	0x00,	0xe3,	0x00,
	0xe6,	0x1d,	0x18,	0xfa,	0xf4,	0x3d,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe7,	0x4b,	0xe6,	0xf4,	0x1d,	0xea,	0x18,	0xea,	0x47,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x19,	0xf4,	0x00,	0x3d,	0xe3,	0xff,	0x00,	0xf4,	0x00,	0xe2,	0x00,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf7,	0xe7,	0x4c,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x48,	0x22,	0xf0,	0xdd,	0x39,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe2,	0xff,	0x00,	0xf4,	0x00,	0xe2,	0x00,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4d,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x49,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe1,	0xff,	0x00,	0xf4,	0x00,	0xe1,	0x00,
	0xe5,	0x1e,	0x19,	0xfa,	0xf3,	0x3f,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4e,	0xe5,	0xf4,	0x1e,	0xe9,	0x19,	0xe9,	0x4a,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x1a,	0xf3,	0x00,	0x3f,	0xe1,	0xff,	0x00,	0xf4,	0x00,	0xe1,	0x00,
	0xe4,	0x1e,	0x19,	0xfa,	0xf3,	0x40,	0xe9,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x19,	0xe9,	0x4b,	0x23,	0xf0,	0xdc,	0x3b,	0xfa,	0x1a,	0xf3,	0x00,	0x40,	0xe0,	0xff,	0x00,	0xf3,	0x00,	0xe0,	0x00,
	0xe4,	0x1e,	0x1a,	0xfa,	0xf2,	0x40,	0xe8,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x1a,	0xe8,	0x4b,	0x23,	0xef,	0xdc,	0x3c,	0xfa,	0x1a,	0xf2,	0x00,	0x40,	0xe0,	0xff,	0x00,	0xf3,	0x00,	0xe0,	0x00,
	0xe4,	0x1f,	0x1a,	0xf9,	0xf2,	0x41,	0xe8,	0x23,	0xdb,	0xff,	0xf6,	0xe4,	0x50,	0xe4,	0xf3,	0x1f,	0xe8,	0x1a,	0xe8,	0x4c,	0x23,	0xef,	0xdb,	0x3c,	0xf9,	0x1b,	0xf2,	0x00,	0x41,	0xdf,	0xff,	0x00,	0xf3,	0x00,	0xdf,	0x00,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xdb,	0xff,	0xf6,	0xe4,	0x51,	0xe3,	0xf3,	0x1f,	0xe7,	0x1a,	0xe8,	0x4d,	0x24,	0xef,	0xdb,	0x3d,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xdf,	0xff,	0x00,	0xf3,	0x00,	0xde,	0x00,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xda,	0xff,	0xf5,	0xe3,	0x52,	0xe3,	0xf2,	0x1f,	0xe7,	0x1a,	0xe8,	0x4e,	0x24,	0xef,	0xda,	0x3e,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xde,	0xff,	0x00,	0xf2,	0x00,	0xde,	0x00,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x43,	0xe7,	0x25,	0xda,	0xff,	0xf5,	0xe3,	0x53,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x4f,	0x25,	0xee,	0xda,	0x3e,	0xf9,	0x1c,	0xf1,	0x00,	0x43,	0xde,	0xff,	0x00,	0xf2,	0x00,	0xdd,	0x00,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe2,	0x54,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x50,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x00,	0xf2,	0x00,	0xdc,	0x00,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe1,	0x55,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x51,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x00,	0xf2,	0x00,	0xdb,	0x00,
	0xe1,	0x20,	0x1b,	0xf9,	0xf1,	0x45,	0xe6,	0x25,	0xd8,	0xff,	0xf5,	0xe1,	0x55,	0xe1,	0xf2,	0x20,	0xe5,	0x1b,	0xe6,	0x51,	0x25,	0xee,	0xd8,	0x40,	0xf9,	0x1c,	0xf1,	0x00,	0x45,	0xdc,	0xff,	0x00,	0xf1,	0x00,	0xdb,	0x00,
	0xe1,	0x21,	0x1b,	0xf9,	0xf0,	0x45,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1b,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x40,	0xf9,	0x1d,	0xf0,	0x00,	0x45,	0xdc,	0xff,	0x00,	0xf1,	0x00,	0xda,	0x00,
	0xe1,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1c,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdc,	0xff,	0x00,	0xf1,	0x00,	0xd9,	0x00,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdb,	0xff,	0x00,	0xf1,	0x00,	0xd9,	0x00,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x00,	0xf0,	0x00,	0xd8,	0x00,
	0xe0,	0x22,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x27,	0xd7,	0xff,	0xf4,	0xde,	0x58,	0xe0,	0xf1,	0x22,	0xe4,	0x1c,	0xe5,	0x54,	0x27,	0xec,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x00,	0xf0,	0x00,	0xd7,	0x00,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf4,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x00,	0xf0,	0x00,	0xd6,	0x00,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf3,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x00,	0xef,	0x00,	0xd6,	0x00,
	0xdf,	0x22,	0x1d,	0xf7,	0xef,	0x49,	0xe4,	0x27,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xdf,	0xf0,	0x22,	0xe3,	0x1d,	0xe4,	0x56,	0x27,	0xec,	0xd5,	0x43,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xda,	0xff,	0x00,	0xef,	0x00,	0xd5,	0x00,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x49,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x56,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xd9,	0xff,	0x00,	0xef,	0x00,	0xd4,	0x00,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x4a,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdb,	0x5b,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x57,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x4a,	0xd9,	0xff,	0x00,	0xef,	0x00,	0xd3,	0x00,
	0xde,	0x23,	0x1d,	0xf7,	0xee,	0x4a,	0xe3,	0x28,	0xd4,	0xff,	0xf3,	0xdb,	0x5c,	0xde,	0xef,	0x23,	0xe2,	0x1d,	0xe3,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4a,	0xd9,	0xff,	0x00,	0xee,	0x00,	0xd3,	0x00,
	0xdd,	0x23,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x28,	0xd4,	0xff,	0xf3,	0xda,	0x5c,	0xdd,	0xef,	0x23,	0xe1,	0x1d,	0xe2,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x00,	0xee,	0x00,	0xd2,	0x00,
	0xdd,	0x24,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xda,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1d,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x00,	0xee,	0x00,	0xd1,	0x00,
	0xdd,	0x24,	0x1e,	0xf6,	0xee,	0x4c,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xd9,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1e,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf6,	0x1f,	0xee,	0x00,	0x4c,	0xd8,	0xff,	0x00,	0xed,	0x00,	0xd1,	0x00,
	0xdc,	0x24,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x29,	0xd3,	0xff,	0xf2,	0xd8,	0x5e,	0xdc,	0xee,	0x24,	0xe0,	0x1e,	0xe1,	0x5a,	0x29,	0xea,	0xd3,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x00,	0xed,	0x00,	0xd0,	0x00,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd8,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x00,	0xed,	0x00,	0xcf,	0x00,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd7,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd7,	0xff,	0x00,	0xed,	0x00,	0xcf,	0x00,
	0xdb,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe0,	0x2a,	0xd1,	0xff,	0xf2,	0xd7,	0x60,	0xdb,	0xee,	0x25,	0xdf,	0x1e,	0xe0,	0x5c,	0x2a,	0xe9,	0xd1,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd6,	0xff,	0x00,	0xec,	0x00,	0xce,	0x00,
	0xdb,	0x25,	0x1f,	0xf5,	0xed,	0x4f,	0xe0,	0x2a,	0xd1,	0xff,	0xf1,	0xd6,	0x61,	0xdb,	0xee,	0x25,	0xdf,	0x1f,	0xe0,	0x5d,	0x2a,	0xe9,	0xd1,	0x49,	0xf5,	0x21,	0xed,	0x00,	0x4f,	0xd6,	0xff,	0x00,	0xec,	0x00,	0xcd,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x4f,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd6,	0x61,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5d,	0x2b,	0xe8,	0xd0,	0x49,	0xf5,	0x21,	0xec,	0x00,	0x4f,	0xd5,	0xff,	0x00,	0xec,	0x00,	0xcd,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd5,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x00,	0xec,	0x00,	0xcc,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd4,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x00,	0xeb,	0x00,	0xcb,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x51,	0xdf,	0x2b,	0xcf,	0xff,	0xf1,	0xd4,	0x63,	0xda,	0xed,	0x26,	0xdd,	0x1f,	0xdf,	0x5f,	0x2b,	0xe8,	0xcf,	0x4b,	0xf5,	0x21,	0xec,	0x00,	0x51,	0xd4,	0xff,	0x00,	0xeb,	0x00,	0xcb,	0x00,
	0xd9,	0x26,	0x1f,	0xf5,	0xeb,	0x51,	0xde,	0x2b,	0xcf,	0xff,	0xf0,	0xd3,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x1f,	0xde,	0x5f,	0x2b,	0xe7,	0xcf,	0x4b,	0xf5,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x00,	0xeb,	0x00,	0xca,	0x00,
	0xd9,	0x26,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xcf,	0xff,	0xf0,	0xd2,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x20,	0xde,	0x5f,	0x2c,	0xe7,	0xcf,	0x4b,	0xf4,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x00,	0xea,	0x00,	0xc9,	0x00,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd2,	0x64,	0xd9,	0xec,	0x27,	0xdd,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4b,	0xf4,	0x22,	0xeb,	0x00,	0x51,	0xd3,	0xff,	0x00,	0xea,	0x00,	0xc9,	0x00,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd1,	0x64,	0xd9,	0xec,	0x27,	0xdc,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x00,	0xea,	0x00,	0xc8,	0x00,
	0xd8,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xec,	0x27,	0xdc,	0x20,	0xdd,	0x60,	0x2c,	0xe7,	0xcd,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x00,	0xea,	0x00,	0xc7,	0x00,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xeb,	0x27,	0xdc,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4c,	0xf4,	0x22,	0xea,	0x00,	0x52,	0xd2,	0xff,	0x00,	0xe9,	0x00,	0xc7,	0x00,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x53,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xcf,	0x65,	0xd8,	0xeb,	0x27,	0xdb,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4d,	0xf4,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x00,	0xe9,	0x00,	0xc6,	0x00,
	0xd8,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdd,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd8,	0xeb,	0x27,	0xdb,	0x21,	0xdd,	0x61,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x00,	0xe9,	0x00,	0xc5,	0x00,
	0xd7,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdc,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd7,	0xeb,	0x27,	0xdb,	0x21,	0xdc,	0x62,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd1,	0xff,	0x00,	0xe8,	0x00,	0xc4,	0x00,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x00,	0xe8,	0x00,	0xc4,	0x00,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x00,	0xe8,	0x00,	0xc3,	0x00,
	0xd6,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdb,	0x2d,	0xcb,	0xff,	0xee,	0xcc,	0x67,	0xd6,	0xea,	0x28,	0xda,	0x21,	0xdb,	0x63,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x00,	0xe7,	0x00,	0xc2,	0x00,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x54,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xda,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4e,	0xf2,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x00,	0xe7,	0x00,	0xc1,	0x00,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xd9,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4f,	0xf2,	0x23,	0xe9,	0x00,	0x55,	0xd0,	0xff,	0x00,	0xe7,	0x00,	0xc1,	0x00,
	0xd6,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xed,	0xca,	0x68,	0xd6,	0xe9,	0x28,	0xd9,	0x22,	0xdb,	0x64,	0x2e,	0xe4,	0xca,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x00,	0xe6,	0x00,	0xc0,	0x00,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd9,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x00,	0xe6,	0x00,	0xbf,	0x00,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd8,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x50,	0xf2,	0x23,	0xe8,	0x00,	0x56,	0xcf,	0xff,	0x00,	0xe6,	0x00,	0xbe,	0x00,
	0xd5,	0x29,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc8,	0xff,	0xed,	0xc8,	0x6a,	0xd5,	0xe9,	0x29,	0xd8,	0x22,	0xda,	0x65,	0x2e,	0xe4,	0xc8,	0x50,	0xf2,	0x24,	0xe8,	0x00,	0x56,	0xce,	0xff,	0x00,	0xe5,	0x00,	0xbd,	0x00,
	0xd5,	0x29,	0x23,	0xf1,	0xe7,	0x56,	0xda,	0x2f,	0xc8,	0xff,	0xec,	0xc7,	0x6a,	0xd5,	0xe8,	0x29,	0xd8,	0x23,	0xda,	0x65,	0x2f,	0xe3,	0xc8,	0x50,	0xf1,	0x24,	0xe7,	0x00,	0x56,	0xce,	0xff,	0x00,	0xe5,	0x00,	0xbd,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc7,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x00,	0xe5,	0x00,	0xbc,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc6,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x00,	0xe4,	0x00,	0xbb,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xeb,	0xc5,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x00,	0xe4,	0x00,	0xba,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc4,	0x6b,	0xd4,	0xe8,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc6,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcc,	0xff,	0x00,	0xe4,	0x00,	0xba,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe6,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc3,	0x6b,	0xd4,	0xe7,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe2,	0xc6,	0x51,	0xf1,	0x24,	0xe6,	0x00,	0x57,	0xcc,	0xff,	0x00,	0xe3,	0x00,	0xb9,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xeb,	0xc3,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x00,	0xe3,	0x00,	0xb8,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xea,	0xc2,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x00,	0xe3,	0x00,	0xb7,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc5,	0xff,	0xea,	0xc1,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2e,	0xe2,	0xc5,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xcb,	0xff,	0x00,	0xe2,	0x00,	0xb6,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xc0,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x00,	0xe2,	0x00,	0xb5,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xbf,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x00,	0xe1,	0x00,	0xb4,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe1,	0x00,	0xb3,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe0,	0x00,	0xb2,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe0,	0x00,	0xb1,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbc,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x00,	0xdf,	0x00,	0xb0,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbb,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x00,	0xdf,	0x00,	0xb0,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xba,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x00,	0xdf,	0x00,	0xaf,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xb9,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x00,	0xde,	0x00,	0xae,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe7,	0xb8,	0x69,	0xd2,	0xe4,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xdf,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x00,	0xde,	0x00,	0xad,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb7,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x00,	0xdd,	0x00,	0xac,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb6,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x00,	0xdd,	0x00,	0xab,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe4,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe7,	0xb6,	0x68,	0xd1,	0xe4,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xdf,	0xbf,	0x4f,	0xee,	0x23,	0xe4,	0x00,	0x55,	0xc5,	0xff,	0x00,	0xdc,	0x00,	0xaa,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe6,	0xb5,	0x68,	0xd1,	0xe3,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbf,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc5,	0xff,	0x00,	0xdc,	0x00,	0xa9,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb4,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x00,	0xdb,	0x00,	0xa8,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb3,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x00,	0xdb,	0x00,	0xa7,	0x00, /* 4000K */

	0xdb,	0x2b,	0x24,	0xfa,	0xf5,	0x5d,	0xe0,	0x32,	0xdf,	0xff,	0xfc,	0xf6,	0x72,	0xdb,	0xf6,	0x2b,	0xf0,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xdf,	0x56,	0xfa,	0x25,	0xf5,	0x00,	0x5d,	0xe7,	0xff,	0x10,	0xfb,	0x10,	0xf4,	0x10, /* 6500K */ /* Night Dim Vivid Custom*/
	0xda,	0x2b,	0x24,	0xf9,	0xf5,	0x5d,	0xe0,	0x32,	0xde,	0xff,	0xfb,	0xf3,	0x72,	0xda,	0xf6,	0x2b,	0xef,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xde,	0x56,	0xf9,	0x25,	0xf5,	0x00,	0x5d,	0xe6,	0xff,	0x10,	0xfa,	0x10,	0xf0,	0x10,
	0xda,	0x2b,	0x24,	0xf8,	0xf4,	0x5c,	0xe0,	0x31,	0xdc,	0xff,	0xfa,	0xef,	0x71,	0xda,	0xf5,	0x2b,	0xed,	0x24,	0xe0,	0x6b,	0x31,	0xef,	0xdc,	0x55,	0xf8,	0x25,	0xf4,	0x00,	0x5c,	0xe3,	0xff,	0x10,	0xf8,	0x10,	0xeb,	0x10,
	0xd9,	0x2b,	0x24,	0xf8,	0xf3,	0x5b,	0xe0,	0x31,	0xda,	0xff,	0xf8,	0xeb,	0x71,	0xd9,	0xf3,	0x2b,	0xeb,	0x24,	0xe0,	0x6b,	0x31,	0xed,	0xda,	0x55,	0xf8,	0x25,	0xf3,	0x00,	0x5b,	0xe1,	0xff,	0x10,	0xf6,	0x10,	0xe5,	0x10,
	0xd8,	0x2b,	0x23,	0xf7,	0xf2,	0x5b,	0xdf,	0x31,	0xd8,	0xff,	0xf7,	0xe7,	0x70,	0xd8,	0xf2,	0x2b,	0xe9,	0x23,	0xdf,	0x6b,	0x31,	0xec,	0xd8,	0x55,	0xf7,	0x25,	0xf2,	0x00,	0x5b,	0xde,	0xff,	0x10,	0xf4,	0x10,	0xe0,	0x10,
	0xd8,	0x2b,	0x23,	0xf6,	0xf0,	0x5a,	0xde,	0x31,	0xd6,	0xff,	0xf5,	0xe2,	0x6f,	0xd8,	0xf1,	0x2b,	0xe7,	0x23,	0xde,	0x6a,	0x31,	0xeb,	0xd6,	0x54,	0xf6,	0x25,	0xf0,	0x00,	0x5a,	0xdb,	0xff,	0x10,	0xf2,	0x10,	0xDB,	0x10,
	0xd6,	0x2a,	0x23,	0xf3,	0xeb,	0x58,	0xdb,	0x2f,	0xce,	0xff,	0xf0,	0xd3,	0x6d,	0xd6,	0xec,	0x2a,	0xde,	0x23,	0xdb,	0x67,	0x2f,	0xe6,	0xce,	0x52,	0xf3,	0x25,	0xeb,	0x00,	0x58,	0xd4,	0xff,	0x10,	0xea,	0x10,	0xc7,	0x10,
	0xd2,	0x29,	0x22,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x69,	0xd2,	0xe6,	0x29,	0xd3,	0x22,	0xd8,	0x65,	0x2e,	0xe0,	0xc3,	0x50,	0xf0,	0x23,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe1,	0x10,	0xb3,	0x10,
	0xd0,	0x27,	0x21,	0xec,	0xdf,	0x54,	0xd4,	0x2d,	0xb7,	0xff,	0xe0,	0xa4,	0x67,	0xd0,	0xdf,	0x27,	0xc7,	0x21,	0xd4,	0x62,	0x2d,	0xda,	0xb7,	0x4e,	0xec,	0x23,	0xdf,	0x00,	0x54,	0xbe,	0xff,	0x10,	0xd5,	0x10,	0x9a,	0x10,
	0xcc,	0x26,	0x20,	0xe8,	0xd6,	0x51,	0xd1,	0x2b,	0xaa,	0xff,	0xd3,	0x86,	0x63,	0xcc,	0xd6,	0x26,	0xb9,	0x20,	0xd1,	0x5f,	0x2b,	0xd2,	0xaa,	0x4c,	0xe8,	0x21,	0xd6,	0x00,	0x51,	0xb1,	0xff,	0x10,	0xc6,	0x10,	0x7d,	0x10,
	0xc2,	0x23,	0x1d,	0xdc,	0xc1,	0x4b,	0xc7,	0x27,	0x90,	0xff,	0xb8,	0x58,	0x5b,	0xc2,	0xc1,	0x23,	0x9e,	0x1d,	0xc7,	0x57,	0x27,	0xbe,	0x90,	0x45,	0xdc,	0x1f,	0xc1,	0x00,	0x4b,	0x97,	0xff,	0x10,	0xa9,	0x10,	0x4d,	0x10,

	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x05,	0xf7,	0x05,	0xe9,	0x05, /* 6000K */ /* Night Dim Vivid Adaptive*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x08,	0xf7,	0x08,	0xe8,	0x08, /* Color Gamut 95%~80% & Gray 5 to 16*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe2,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe7,	0xff,	0x08,	0xf7,	0x08,	0xe8,	0x08,
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe1,	0xff,	0xf8,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe1,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe6,	0xff,	0x08,	0xf6,	0x08,	0xe7,	0x08,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x38,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf6,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x34,	0xfb,	0x17,	0xf5,	0x00,	0x38,	0xe6,	0xff,	0x08,	0xf6,	0x08,	0xe7,	0x08,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe6,	0xff,	0x08,	0xf6,	0x08,	0xe6,	0x08,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe0,	0xff,	0xf8,	0xea,	0x47,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x43,	0x1f,	0xf2,	0xe0,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe5,	0xff,	0x08,	0xf6,	0x08,	0xe6,	0x08,
	0xe7,	0x1b,	0x17,	0xfb,	0xf5,	0x3a,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xea,	0x48,	0xe7,	0xf5,	0x1b,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfb,	0x17,	0xf5,	0x00,	0x3a,	0xe5,	0xff,	0x08,	0xf5,	0x08,	0xe5,	0x08,
	0xe7,	0x1c,	0x17,	0xfa,	0xf5,	0x3b,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xe9,	0x48,	0xe7,	0xf5,	0x1c,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfa,	0x18,	0xf5,	0x00,	0x3b,	0xe4,	0xff,	0x08,	0xf5,	0x08,	0xe5,	0x08,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3b,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe9,	0x49,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x45,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3b,	0xe4,	0xff,	0x08,	0xf5,	0x08,	0xe4,	0x08,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe8,	0x4a,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x46,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x08,	0xf5,	0x08,	0xe3,	0x08,
	0xe6,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe8,	0x4a,	0xe6,	0xf4,	0x1c,	0xea,	0x18,	0xea,	0x46,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x08,	0xf5,	0x08,	0xe3,	0x08,
	0xe6,	0x1d,	0x18,	0xfa,	0xf4,	0x3d,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe7,	0x4b,	0xe6,	0xf4,	0x1d,	0xea,	0x18,	0xea,	0x47,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x19,	0xf4,	0x00,	0x3d,	0xe3,	0xff,	0x08,	0xf4,	0x08,	0xe2,	0x08,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf7,	0xe7,	0x4c,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x48,	0x22,	0xf0,	0xdd,	0x39,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe2,	0xff,	0x08,	0xf4,	0x08,	0xe2,	0x08,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4d,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x49,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe1,	0xff,	0x08,	0xf4,	0x08,	0xe1,	0x08,
	0xe5,	0x1e,	0x19,	0xfa,	0xf3,	0x3f,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4e,	0xe5,	0xf4,	0x1e,	0xe9,	0x19,	0xe9,	0x4a,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x1a,	0xf3,	0x00,	0x3f,	0xe1,	0xff,	0x08,	0xf4,	0x08,	0xe1,	0x08,
	0xe4,	0x1e,	0x19,	0xfa,	0xf3,	0x40,	0xe9,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x19,	0xe9,	0x4b,	0x23,	0xf0,	0xdc,	0x3b,	0xfa,	0x1a,	0xf3,	0x00,	0x40,	0xe0,	0xff,	0x08,	0xf3,	0x08,	0xe0,	0x08,
	0xe4,	0x1e,	0x1a,	0xfa,	0xf2,	0x40,	0xe8,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x1a,	0xe8,	0x4b,	0x23,	0xef,	0xdc,	0x3c,	0xfa,	0x1a,	0xf2,	0x00,	0x40,	0xe0,	0xff,	0x08,	0xf3,	0x08,	0xe0,	0x08,
	0xe4,	0x1f,	0x1a,	0xf9,	0xf2,	0x41,	0xe8,	0x23,	0xdb,	0xff,	0xf6,	0xe4,	0x50,	0xe4,	0xf3,	0x1f,	0xe8,	0x1a,	0xe8,	0x4c,	0x23,	0xef,	0xdb,	0x3c,	0xf9,	0x1b,	0xf2,	0x00,	0x41,	0xdf,	0xff,	0x08,	0xf3,	0x08,	0xdf,	0x08,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xdb,	0xff,	0xf6,	0xe4,	0x51,	0xe3,	0xf3,	0x1f,	0xe7,	0x1a,	0xe8,	0x4d,	0x24,	0xef,	0xdb,	0x3d,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xdf,	0xff,	0x08,	0xf3,	0x08,	0xde,	0x08,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xda,	0xff,	0xf5,	0xe3,	0x52,	0xe3,	0xf2,	0x1f,	0xe7,	0x1a,	0xe8,	0x4e,	0x24,	0xef,	0xda,	0x3e,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xde,	0xff,	0x08,	0xf2,	0x08,	0xde,	0x08,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x43,	0xe7,	0x25,	0xda,	0xff,	0xf5,	0xe3,	0x53,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x4f,	0x25,	0xee,	0xda,	0x3e,	0xf9,	0x1c,	0xf1,	0x00,	0x43,	0xde,	0xff,	0x08,	0xf2,	0x08,	0xdd,	0x08,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe2,	0x54,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x50,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x08,	0xf2,	0x08,	0xdc,	0x08,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe1,	0x55,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x51,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x0c,	0xf2,	0x0c,	0xdb,	0x0c,
	0xe1,	0x20,	0x1b,	0xf9,	0xf1,	0x45,	0xe6,	0x25,	0xd8,	0xff,	0xf5,	0xe1,	0x55,	0xe1,	0xf2,	0x20,	0xe5,	0x1b,	0xe6,	0x51,	0x25,	0xee,	0xd8,	0x40,	0xf9,	0x1c,	0xf1,	0x00,	0x45,	0xdc,	0xff,	0x0c,	0xf1,	0x0c,	0xdb,	0x0c,
	0xe1,	0x21,	0x1b,	0xf9,	0xf0,	0x45,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1b,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x40,	0xf9,	0x1d,	0xf0,	0x00,	0x45,	0xdc,	0xff,	0x0c,	0xf1,	0x0c,	0xda,	0x0c,
	0xe1,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1c,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdc,	0xff,	0x0c,	0xf1,	0x0c,	0xd9,	0x0c,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdb,	0xff,	0x0c,	0xf1,	0x0c,	0xd9,	0x0c,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x0c,	0xf0,	0x0c,	0xd8,	0x0c,
	0xe0,	0x22,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x27,	0xd7,	0xff,	0xf4,	0xde,	0x58,	0xe0,	0xf1,	0x22,	0xe4,	0x1c,	0xe5,	0x54,	0x27,	0xec,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x0c,	0xf0,	0x0c,	0xd7,	0x0c,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf4,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x0c,	0xf0,	0x0c,	0xd6,	0x0c,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf3,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x0c,	0xef,	0x0c,	0xd6,	0x0c,
	0xdf,	0x22,	0x1d,	0xf7,	0xef,	0x49,	0xe4,	0x27,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xdf,	0xf0,	0x22,	0xe3,	0x1d,	0xe4,	0x56,	0x27,	0xec,	0xd5,	0x43,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xda,	0xff,	0x0c,	0xef,	0x0c,	0xd5,	0x0c,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x49,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x56,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xd9,	0xff,	0x0c,	0xef,	0x0c,	0xd4,	0x0c,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x4a,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdb,	0x5b,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x57,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x4a,	0xd9,	0xff,	0x0c,	0xef,	0x0c,	0xd3,	0x0c,
	0xde,	0x23,	0x1d,	0xf7,	0xee,	0x4a,	0xe3,	0x28,	0xd4,	0xff,	0xf3,	0xdb,	0x5c,	0xde,	0xef,	0x23,	0xe2,	0x1d,	0xe3,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4a,	0xd9,	0xff,	0x0c,	0xee,	0x0c,	0xd3,	0x0c,
	0xdd,	0x23,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x28,	0xd4,	0xff,	0xf3,	0xda,	0x5c,	0xdd,	0xef,	0x23,	0xe1,	0x1d,	0xe2,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x0c,	0xee,	0x0c,	0xd2,	0x0c,
	0xdd,	0x24,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xda,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1d,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x0c,	0xee,	0x0c,	0xd1,	0x0c,
	0xdd,	0x24,	0x1e,	0xf6,	0xee,	0x4c,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xd9,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1e,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf6,	0x1f,	0xee,	0x00,	0x4c,	0xd8,	0xff,	0x0c,	0xed,	0x0c,	0xd1,	0x0c,
	0xdc,	0x24,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x29,	0xd3,	0xff,	0xf2,	0xd8,	0x5e,	0xdc,	0xee,	0x24,	0xe0,	0x1e,	0xe1,	0x5a,	0x29,	0xea,	0xd3,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x0c,	0xed,	0x0c,	0xd0,	0x0c,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd8,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x0c,	0xed,	0x0c,	0xcf,	0x0c,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd7,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd7,	0xff,	0x0c,	0xed,	0x0c,	0xcf,	0x0c,
	0xdb,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe0,	0x2a,	0xd1,	0xff,	0xf2,	0xd7,	0x60,	0xdb,	0xee,	0x25,	0xdf,	0x1e,	0xe0,	0x5c,	0x2a,	0xe9,	0xd1,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd6,	0xff,	0x0c,	0xec,	0x0c,	0xce,	0x0c,
	0xdb,	0x25,	0x1f,	0xf5,	0xed,	0x4f,	0xe0,	0x2a,	0xd1,	0xff,	0xf1,	0xd6,	0x61,	0xdb,	0xee,	0x25,	0xdf,	0x1f,	0xe0,	0x5d,	0x2a,	0xe9,	0xd1,	0x49,	0xf5,	0x21,	0xed,	0x00,	0x4f,	0xd6,	0xff,	0x0c,	0xec,	0x0c,	0xcd,	0x0c,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x4f,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd6,	0x61,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5d,	0x2b,	0xe8,	0xd0,	0x49,	0xf5,	0x21,	0xec,	0x00,	0x4f,	0xd5,	0xff,	0x0c,	0xec,	0x0c,	0xcd,	0x0c,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd5,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x0c,	0xec,	0x0c,	0xcc,	0x0c,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd4,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x0e,	0xeb,	0x0e,	0xcb,	0x0e,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x51,	0xdf,	0x2b,	0xcf,	0xff,	0xf1,	0xd4,	0x63,	0xda,	0xed,	0x26,	0xdd,	0x1f,	0xdf,	0x5f,	0x2b,	0xe8,	0xcf,	0x4b,	0xf5,	0x21,	0xec,	0x00,	0x51,	0xd4,	0xff,	0x0e,	0xeb,	0x0e,	0xcb,	0x0e,
	0xd9,	0x26,	0x1f,	0xf5,	0xeb,	0x51,	0xde,	0x2b,	0xcf,	0xff,	0xf0,	0xd3,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x1f,	0xde,	0x5f,	0x2b,	0xe7,	0xcf,	0x4b,	0xf5,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x0e,	0xeb,	0x0e,	0xca,	0x0e,
	0xd9,	0x26,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xcf,	0xff,	0xf0,	0xd2,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x20,	0xde,	0x5f,	0x2c,	0xe7,	0xcf,	0x4b,	0xf4,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x0e,	0xea,	0x0e,	0xc9,	0x0e,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd2,	0x64,	0xd9,	0xec,	0x27,	0xdd,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4b,	0xf4,	0x22,	0xeb,	0x00,	0x51,	0xd3,	0xff,	0x0e,	0xea,	0x0e,	0xc9,	0x0e,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd1,	0x64,	0xd9,	0xec,	0x27,	0xdc,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x0e,	0xea,	0x0e,	0xc8,	0x0e,
	0xd8,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xec,	0x27,	0xdc,	0x20,	0xdd,	0x60,	0x2c,	0xe7,	0xcd,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x0e,	0xea,	0x0e,	0xc7,	0x0e,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xeb,	0x27,	0xdc,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4c,	0xf4,	0x22,	0xea,	0x00,	0x52,	0xd2,	0xff,	0x0e,	0xe9,	0x0e,	0xc7,	0x0e,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x53,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xcf,	0x65,	0xd8,	0xeb,	0x27,	0xdb,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4d,	0xf4,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x0e,	0xe9,	0x0e,	0xc6,	0x0e,
	0xd8,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdd,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd8,	0xeb,	0x27,	0xdb,	0x21,	0xdd,	0x61,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x0e,	0xe9,	0x0e,	0xc5,	0x0e,
	0xd7,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdc,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd7,	0xeb,	0x27,	0xdb,	0x21,	0xdc,	0x62,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd1,	0xff,	0x0e,	0xe8,	0x0e,	0xc4,	0x0e,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x0e,	0xe8,	0x0e,	0xc4,	0x0e,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x0e,	0xe8,	0x0e,	0xc3,	0x0e,
	0xd6,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdb,	0x2d,	0xcb,	0xff,	0xee,	0xcc,	0x67,	0xd6,	0xea,	0x28,	0xda,	0x21,	0xdb,	0x63,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x0e,	0xe7,	0x0e,	0xc2,	0x0e,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x54,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xda,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4e,	0xf2,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x0e,	0xe7,	0x0e,	0xc1,	0x0e,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xd9,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4f,	0xf2,	0x23,	0xe9,	0x00,	0x55,	0xd0,	0xff,	0x0e,	0xe7,	0x0e,	0xc1,	0x0e,
	0xd6,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xed,	0xca,	0x68,	0xd6,	0xe9,	0x28,	0xd9,	0x22,	0xdb,	0x64,	0x2e,	0xe4,	0xca,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x0e,	0xe6,	0x0e,	0xc0,	0x0e,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd9,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x0e,	0xe6,	0x0e,	0xbf,	0x0e,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd8,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x50,	0xf2,	0x23,	0xe8,	0x00,	0x56,	0xcf,	0xff,	0x0e,	0xe6,	0x0e,	0xbe,	0x0e,
	0xd5,	0x29,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc8,	0xff,	0xed,	0xc8,	0x6a,	0xd5,	0xe9,	0x29,	0xd8,	0x22,	0xda,	0x65,	0x2e,	0xe4,	0xc8,	0x50,	0xf2,	0x24,	0xe8,	0x00,	0x56,	0xce,	0xff,	0x0e,	0xe5,	0x0e,	0xbd,	0x0e,
	0xd5,	0x29,	0x23,	0xf1,	0xe7,	0x56,	0xda,	0x2f,	0xc8,	0xff,	0xec,	0xc7,	0x6a,	0xd5,	0xe8,	0x29,	0xd8,	0x23,	0xda,	0x65,	0x2f,	0xe3,	0xc8,	0x50,	0xf1,	0x24,	0xe7,	0x00,	0x56,	0xce,	0xff,	0x0e,	0xe5,	0x0e,	0xbd,	0x0e,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc7,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x0e,	0xe5,	0x0e,	0xbc,	0x0e,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc6,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x0e,	0xe4,	0x0e,	0xbb,	0x0e,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xeb,	0xc5,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x10,	0xe4,	0x10,	0xba,	0x10,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc4,	0x6b,	0xd4,	0xe8,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc6,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcc,	0xff,	0x10,	0xe4,	0x10,	0xba,	0x10,
	0xd4,	0x29,	0x23,	0xf1,	0xe6,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc3,	0x6b,	0xd4,	0xe7,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe2,	0xc6,	0x51,	0xf1,	0x24,	0xe6,	0x00,	0x57,	0xcc,	0xff,	0x10,	0xe3,	0x10,	0xb9,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xeb,	0xc3,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x10,	0xe3,	0x10,	0xb8,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xea,	0xc2,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x10,	0xe3,	0x10,	0xb7,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc5,	0xff,	0xea,	0xc1,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2e,	0xe2,	0xc5,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xcb,	0xff,	0x10,	0xe2,	0x10,	0xb6,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xc0,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x10,	0xe2,	0x10,	0xb5,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xbf,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x10,	0xe1,	0x10,	0xb4,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe1,	0x10,	0xb3,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe0,	0x10,	0xb2,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe0,	0x10,	0xb1,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbc,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x10,	0xdf,	0x10,	0xb0,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbb,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x10,	0xdf,	0x10,	0xb0,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xba,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x10,	0xdf,	0x10,	0xaf,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xb9,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x10,	0xde,	0x10,	0xae,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe7,	0xb8,	0x69,	0xd2,	0xe4,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xdf,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x10,	0xde,	0x10,	0xad,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb7,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x10,	0xdd,	0x10,	0xac,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb6,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x10,	0xdd,	0x10,	0xab,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe4,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe7,	0xb6,	0x68,	0xd1,	0xe4,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xdf,	0xbf,	0x4f,	0xee,	0x23,	0xe4,	0x00,	0x55,	0xc5,	0xff,	0x10,	0xdc,	0x10,	0xaa,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe6,	0xb5,	0x68,	0xd1,	0xe3,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbf,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc5,	0xff,	0x10,	0xdc,	0x10,	0xa9,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb4,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x10,	0xdb,	0x10,	0xa8,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb3,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x10,	0xdb,	0x10,	0xa7,	0x10, /* 4000K */

	0xfb, 0x16, 0x00, 0xff, 0xf6, 0x00, 0xff, 0x28, 0xec, 0xff, 0xfb, 0xf4, 0x3f, 0xfb, 0xf9, 0x16, 0xeb, 0x00, 0xff, 0x30, 0x28, 0xf5, 0xec, 0x00, 0xff, 0x11, 0xf6, 0x0c, 0x00, 0xe9, 0xff, 0x00, 0xfb, 0x00, 0xf4, 0x00, 	/*	6500K	*/	/*	BLF	Natural	Custom*/
	0xfb, 0x16, 0x00, 0xff, 0xf5, 0x00, 0xff, 0x28, 0xe8, 0xff, 0xfa, 0xf0, 0x3f, 0xfb, 0xf8, 0x16, 0xe8, 0x00, 0xff, 0x30, 0x28, 0xf4, 0xe8, 0x00, 0xff, 0x11, 0xf5, 0x0c, 0x00, 0xe6, 0xff, 0x00, 0xfa, 0x00, 0xf0, 0x00, 	/*	6300K	*/
	0xfb, 0x15, 0x00, 0xff, 0xf3, 0x00, 0xff, 0x28, 0xe4, 0xff, 0xf8, 0xeb, 0x3f, 0xfb, 0xf6, 0x15, 0xe3, 0x00, 0xff, 0x30, 0x28, 0xf2, 0xe4, 0x00, 0xff, 0x11, 0xf3, 0x0c, 0x00, 0xe1, 0xff, 0x00, 0xf8, 0x00, 0xeb, 0x00, 	/*	6100K	*/
	0xfb, 0x15, 0x00, 0xff, 0xf1, 0x00, 0xff, 0x28, 0xde, 0xff, 0xf6, 0xe5, 0x3f, 0xfb, 0xf4, 0x15, 0xdd, 0x00, 0xff, 0x30, 0x28, 0xf0, 0xde, 0x00, 0xff, 0x11, 0xf1, 0x0c, 0x00, 0xdb, 0xff, 0x00, 0xf6, 0x00, 0xe5, 0x00, 	/*	5900K	*/
	0xfb, 0x15, 0x00, 0xff, 0xef, 0x00, 0xff, 0x27, 0xd9, 0xff, 0xf4, 0xe0, 0x3f, 0xfb, 0xf2, 0x15, 0xd8, 0x00, 0xff, 0x30, 0x27, 0xee, 0xd9, 0x00, 0xff, 0x11, 0xef, 0x0b, 0x00, 0xd6, 0xff, 0x00, 0xf4, 0x00, 0xe0, 0x00, 	/*	5700K	*/
	0xfb, 0x15, 0x00, 0xff, 0xed, 0x00, 0xff, 0x27, 0xd4, 0xff, 0xf2, 0xDB, 0x3f, 0xfb, 0xf0, 0x15, 0xd3, 0x00, 0xff, 0x30, 0x27, 0xec, 0xd4, 0x00, 0xff, 0x11, 0xed, 0x0b, 0x00, 0xd2, 0xff, 0x00, 0xf2, 0x00, 0xDB, 0x00, 	/*	5500K	*/
	0xfb, 0x14, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x26, 0xc1, 0xff, 0xea, 0xc7, 0x3f, 0xfb, 0xe8, 0x14, 0xc0, 0x00, 0xff, 0x30, 0x26, 0xe4, 0xc1, 0x00, 0xff, 0x11, 0xe5, 0x0b, 0x00, 0xbe, 0xff, 0x00, 0xea, 0x00, 0xc7, 0x00, 	/*	4900K	*/
	0xfb, 0x13, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x24, 0xad, 0xff, 0xe1, 0xb3, 0x3f, 0xfb, 0xdf, 0x13, 0xad, 0x00, 0xff, 0x30, 0x24, 0xdc, 0xad, 0x00, 0xff, 0x11, 0xdd, 0x0b, 0x00, 0xab, 0xff, 0x00, 0xe1, 0x00, 0xb3, 0x00, 	/*	4300K	*/
	0xfb, 0x12, 0x00, 0xff, 0xd1, 0x00, 0xff, 0x22, 0x95, 0xff, 0xd5, 0x9a, 0x3f, 0xfb, 0xd3, 0x12, 0x95, 0x00, 0xff, 0x30, 0x22, 0xd0, 0x95, 0x00, 0xff, 0x11, 0xd1, 0x0a, 0x00, 0x93, 0xff, 0x00, 0xd5, 0x00, 0x9a, 0x00, 	/*	3700K	*/
	0xfb, 0x11, 0x00, 0xff, 0xc2, 0x00, 0xff, 0x20, 0x79, 0xff, 0xc6, 0x7d, 0x3f, 0xfb, 0xc4, 0x11, 0x79, 0x00, 0xff, 0x30, 0x20, 0xc1, 0x79, 0x00, 0xff, 0x11, 0xc2, 0x09, 0x00, 0x78, 0xff, 0x00, 0xc6, 0x00, 0x7d, 0x00, 	/*	3100K	*/
	0xfb, 0x0f, 0x00, 0xff, 0xa6, 0x00, 0xff, 0x1b, 0x4b, 0xff, 0xa9, 0x4d, 0x3f, 0xfb, 0xa8, 0x0f, 0x4a, 0x00, 0xff, 0x30, 0x1b, 0xa5, 0x4b, 0x00, 0xff, 0x11, 0xa6, 0x08, 0x00, 0x4a, 0xff, 0x00, 0xa9, 0x00, 0x4d, 0x00, 	/*	2300K	*/

	0xfb, 0x15, 0x00, 0xff, 0xf2, 0x00, 0xff, 0x28, 0xe2, 0xff, 0xf7, 0xe9, 0x3f, 0xfb, 0xf5, 0x15, 0xe1, 0x00, 0xff, 0x30, 0x28, 0xf1, 0xe2, 0x00, 0xff, 0x11, 0xf2, 0x0c, 0x00, 0xdf, 0xff, 0x00, 0xf7, 0x00, 0xe9, 0x00, /* 6000K */ /* BLF Natural Adaptive*/
	0xfb, 0x15, 0x00, 0xff, 0xf2, 0x00, 0xff, 0x28, 0xe1, 0xff, 0xf7, 0xe8, 0x3f, 0xfb, 0xf5, 0x15, 0xe0, 0x00, 0xff, 0x30, 0x28, 0xf1, 0xe1, 0x00, 0xff, 0x11, 0xf2, 0x0c, 0x00, 0xde, 0xff, 0x00, 0xf7, 0x00, 0xe8, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf2, 0x00, 0xff, 0x28, 0xe1, 0xff, 0xf7, 0xe8, 0x3f, 0xfb, 0xf5, 0x15, 0xe0, 0x00, 0xff, 0x30, 0x28, 0xf1, 0xe1, 0x00, 0xff, 0x11, 0xf2, 0x0c, 0x00, 0xde, 0xff, 0x00, 0xf7, 0x00, 0xe8, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf1, 0x00, 0xff, 0x28, 0xe0, 0xff, 0xf6, 0xe7, 0x3f, 0xfb, 0xf4, 0x15, 0xdf, 0x00, 0xff, 0x30, 0x28, 0xf0, 0xe0, 0x00, 0xff, 0x11, 0xf1, 0x0c, 0x00, 0xdd, 0xff, 0x00, 0xf6, 0x00, 0xe7, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf1, 0x00, 0xff, 0x28, 0xe0, 0xff, 0xf6, 0xe7, 0x3f, 0xfb, 0xf4, 0x15, 0xdf, 0x00, 0xff, 0x30, 0x28, 0xf0, 0xe0, 0x00, 0xff, 0x11, 0xf1, 0x0c, 0x00, 0xdd, 0xff, 0x00, 0xf6, 0x00, 0xe7, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf1, 0x00, 0xff, 0x28, 0xdf, 0xff, 0xf6, 0xe6, 0x3f, 0xfb, 0xf4, 0x15, 0xde, 0x00, 0xff, 0x30, 0x28, 0xf0, 0xdf, 0x00, 0xff, 0x11, 0xf1, 0x0c, 0x00, 0xdc, 0xff, 0x00, 0xf6, 0x00, 0xe6, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf1, 0x00, 0xff, 0x28, 0xdf, 0xff, 0xf6, 0xe6, 0x3f, 0xfb, 0xf4, 0x15, 0xde, 0x00, 0xff, 0x30, 0x28, 0xf0, 0xdf, 0x00, 0xff, 0x11, 0xf1, 0x0c, 0x00, 0xdc, 0xff, 0x00, 0xf6, 0x00, 0xe6, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf0, 0x00, 0xff, 0x27, 0xde, 0xff, 0xf5, 0xe5, 0x3f, 0xfb, 0xf3, 0x15, 0xdd, 0x00, 0xff, 0x30, 0x27, 0xef, 0xde, 0x00, 0xff, 0x11, 0xf0, 0x0c, 0x00, 0xdb, 0xff, 0x00, 0xf5, 0x00, 0xe5, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf0, 0x00, 0xff, 0x27, 0xde, 0xff, 0xf5, 0xe5, 0x3f, 0xfb, 0xf3, 0x15, 0xdd, 0x00, 0xff, 0x30, 0x27, 0xef, 0xde, 0x00, 0xff, 0x11, 0xf0, 0x0c, 0x00, 0xdb, 0xff, 0x00, 0xf5, 0x00, 0xe5, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf0, 0x00, 0xff, 0x27, 0xdd, 0xff, 0xf5, 0xe4, 0x3f, 0xfb, 0xf3, 0x15, 0xdc, 0x00, 0xff, 0x30, 0x27, 0xef, 0xdd, 0x00, 0xff, 0x11, 0xf0, 0x0c, 0x00, 0xda, 0xff, 0x00, 0xf5, 0x00, 0xe4, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf0, 0x00, 0xff, 0x27, 0xdc, 0xff, 0xf5, 0xe3, 0x3f, 0xfb, 0xf3, 0x15, 0xdb, 0x00, 0xff, 0x30, 0x27, 0xef, 0xdc, 0x00, 0xff, 0x11, 0xf0, 0x0c, 0x00, 0xd9, 0xff, 0x00, 0xf5, 0x00, 0xe3, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xf0, 0x00, 0xff, 0x27, 0xdc, 0xff, 0xf5, 0xe3, 0x3f, 0xfb, 0xf3, 0x15, 0xdb, 0x00, 0xff, 0x30, 0x27, 0xef, 0xdc, 0x00, 0xff, 0x11, 0xf0, 0x0c, 0x00, 0xd9, 0xff, 0x00, 0xf5, 0x00, 0xe3, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xef, 0x00, 0xff, 0x27, 0xdb, 0xff, 0xf4, 0xe2, 0x3f, 0xfb, 0xf2, 0x15, 0xda, 0x00, 0xff, 0x30, 0x27, 0xee, 0xdb, 0x00, 0xff, 0x11, 0xef, 0x0b, 0x00, 0xd8, 0xff, 0x00, 0xf4, 0x00, 0xe2, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xef, 0x00, 0xff, 0x27, 0xdb, 0xff, 0xf4, 0xe2, 0x3f, 0xfb, 0xf2, 0x15, 0xda, 0x00, 0xff, 0x30, 0x27, 0xee, 0xdb, 0x00, 0xff, 0x11, 0xef, 0x0b, 0x00, 0xd8, 0xff, 0x00, 0xf4, 0x00, 0xe2, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xef, 0x00, 0xff, 0x27, 0xda, 0xff, 0xf4, 0xe1, 0x3f, 0xfb, 0xf2, 0x15, 0xd9, 0x00, 0xff, 0x30, 0x27, 0xee, 0xda, 0x00, 0xff, 0x11, 0xef, 0x0b, 0x00, 0xd7, 0xff, 0x00, 0xf4, 0x00, 0xe1, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xef, 0x00, 0xff, 0x27, 0xda, 0xff, 0xf4, 0xe1, 0x3f, 0xfb, 0xf2, 0x15, 0xd9, 0x00, 0xff, 0x30, 0x27, 0xee, 0xda, 0x00, 0xff, 0x11, 0xef, 0x0b, 0x00, 0xd7, 0xff, 0x00, 0xf4, 0x00, 0xe1, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xee, 0x00, 0xff, 0x27, 0xd9, 0xff, 0xf3, 0xe0, 0x3f, 0xfb, 0xf1, 0x15, 0xd8, 0x00, 0xff, 0x30, 0x27, 0xed, 0xd9, 0x00, 0xff, 0x11, 0xee, 0x0b, 0x00, 0xd6, 0xff, 0x00, 0xf3, 0x00, 0xe0, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xee, 0x00, 0xff, 0x27, 0xd9, 0xff, 0xf3, 0xe0, 0x3f, 0xfb, 0xf1, 0x15, 0xd8, 0x00, 0xff, 0x30, 0x27, 0xed, 0xd9, 0x00, 0xff, 0x11, 0xee, 0x0b, 0x00, 0xd6, 0xff, 0x00, 0xf3, 0x00, 0xe0, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xee, 0x00, 0xff, 0x27, 0xd8, 0xff, 0xf3, 0xdf, 0x3f, 0xfb, 0xf1, 0x15, 0xd7, 0x00, 0xff, 0x30, 0x27, 0xed, 0xd8, 0x00, 0xff, 0x11, 0xee, 0x0b, 0x00, 0xd5, 0xff, 0x00, 0xf3, 0x00, 0xdf, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xee, 0x00, 0xff, 0x27, 0xd7, 0xff, 0xf3, 0xde, 0x3f, 0xfb, 0xf1, 0x15, 0xd6, 0x00, 0xff, 0x30, 0x27, 0xed, 0xd7, 0x00, 0xff, 0x11, 0xee, 0x0b, 0x00, 0xd4, 0xff, 0x00, 0xf3, 0x00, 0xde, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xed, 0x00, 0xff, 0x27, 0xd7, 0xff, 0xf2, 0xde, 0x3f, 0xfb, 0xf0, 0x15, 0xd6, 0x00, 0xff, 0x30, 0x27, 0xec, 0xd7, 0x00, 0xff, 0x11, 0xed, 0x0b, 0x00, 0xd4, 0xff, 0x00, 0xf2, 0x00, 0xde, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xed, 0x00, 0xff, 0x27, 0xd6, 0xff, 0xf2, 0xdd, 0x3f, 0xfb, 0xf0, 0x15, 0xd5, 0x00, 0xff, 0x30, 0x27, 0xec, 0xd6, 0x00, 0xff, 0x11, 0xed, 0x0b, 0x00, 0xd3, 0xff, 0x00, 0xf2, 0x00, 0xdd, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xed, 0x00, 0xff, 0x27, 0xd5, 0xff, 0xf2, 0xdc, 0x3f, 0xfb, 0xf0, 0x15, 0xd4, 0x00, 0xff, 0x30, 0x27, 0xec, 0xd5, 0x00, 0xff, 0x11, 0xed, 0x0b, 0x00, 0xd3, 0xff, 0x00, 0xf2, 0x00, 0xdc, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xed, 0x00, 0xff, 0x27, 0xd4, 0xff, 0xf2, 0xdb, 0x3f, 0xfb, 0xf0, 0x15, 0xd3, 0x00, 0xff, 0x30, 0x27, 0xec, 0xd4, 0x00, 0xff, 0x11, 0xed, 0x0b, 0x00, 0xd2, 0xff, 0x00, 0xf2, 0x00, 0xdb, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xec, 0x00, 0xff, 0x27, 0xd4, 0xff, 0xf1, 0xdb, 0x3f, 0xfb, 0xef, 0x15, 0xd3, 0x00, 0xff, 0x30, 0x27, 0xeb, 0xd4, 0x00, 0xff, 0x11, 0xec, 0x0b, 0x00, 0xd2, 0xff, 0x00, 0xf1, 0x00, 0xdb, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xec, 0x00, 0xff, 0x27, 0xd3, 0xff, 0xf1, 0xda, 0x3f, 0xfb, 0xef, 0x15, 0xd2, 0x00, 0xff, 0x30, 0x27, 0xeb, 0xd3, 0x00, 0xff, 0x11, 0xec, 0x0b, 0x00, 0xd1, 0xff, 0x00, 0xf1, 0x00, 0xda, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xec, 0x00, 0xff, 0x27, 0xd2, 0xff, 0xf1, 0xd9, 0x3f, 0xfb, 0xef, 0x15, 0xd1, 0x00, 0xff, 0x30, 0x27, 0xeb, 0xd2, 0x00, 0xff, 0x11, 0xec, 0x0b, 0x00, 0xd0, 0xff, 0x00, 0xf1, 0x00, 0xd9, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xec, 0x00, 0xff, 0x27, 0xd2, 0xff, 0xf1, 0xd9, 0x3f, 0xfb, 0xef, 0x15, 0xd1, 0x00, 0xff, 0x30, 0x27, 0xeb, 0xd2, 0x00, 0xff, 0x11, 0xec, 0x0b, 0x00, 0xd0, 0xff, 0x00, 0xf1, 0x00, 0xd9, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xeb, 0x00, 0xff, 0x27, 0xd1, 0xff, 0xf0, 0xd8, 0x3f, 0xfb, 0xee, 0x15, 0xd0, 0x00, 0xff, 0x30, 0x27, 0xea, 0xd1, 0x00, 0xff, 0x11, 0xeb, 0x0b, 0x00, 0xcf, 0xff, 0x00, 0xf0, 0x00, 0xd8, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xeb, 0x00, 0xff, 0x27, 0xd0, 0xff, 0xf0, 0xd7, 0x3f, 0xfb, 0xee, 0x15, 0xcf, 0x00, 0xff, 0x30, 0x27, 0xea, 0xd0, 0x00, 0xff, 0x11, 0xeb, 0x0b, 0x00, 0xce, 0xff, 0x00, 0xf0, 0x00, 0xd7, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xeb, 0x00, 0xff, 0x27, 0xcf, 0xff, 0xf0, 0xd6, 0x3f, 0xfb, 0xee, 0x15, 0xce, 0x00, 0xff, 0x30, 0x27, 0xea, 0xcf, 0x00, 0xff, 0x11, 0xeb, 0x0b, 0x00, 0xcd, 0xff, 0x00, 0xf0, 0x00, 0xd6, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xea, 0x00, 0xff, 0x26, 0xcf, 0xff, 0xef, 0xd6, 0x3f, 0xfb, 0xed, 0x15, 0xce, 0x00, 0xff, 0x30, 0x26, 0xe9, 0xcf, 0x00, 0xff, 0x11, 0xea, 0x0b, 0x00, 0xcd, 0xff, 0x00, 0xef, 0x00, 0xd6, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xea, 0x00, 0xff, 0x26, 0xce, 0xff, 0xef, 0xd5, 0x3f, 0xfb, 0xed, 0x15, 0xcd, 0x00, 0xff, 0x30, 0x26, 0xe9, 0xce, 0x00, 0xff, 0x11, 0xea, 0x0b, 0x00, 0xcc, 0xff, 0x00, 0xef, 0x00, 0xd5, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xea, 0x00, 0xff, 0x26, 0xcd, 0xff, 0xef, 0xd4, 0x3f, 0xfb, 0xed, 0x15, 0xcd, 0x00, 0xff, 0x30, 0x26, 0xe9, 0xcd, 0x00, 0xff, 0x11, 0xea, 0x0b, 0x00, 0xcb, 0xff, 0x00, 0xef, 0x00, 0xd4, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xea, 0x00, 0xff, 0x26, 0xcc, 0xff, 0xef, 0xd3, 0x3f, 0xfb, 0xed, 0x15, 0xcc, 0x00, 0xff, 0x30, 0x26, 0xe9, 0xcc, 0x00, 0xff, 0x11, 0xea, 0x0b, 0x00, 0xca, 0xff, 0x00, 0xef, 0x00, 0xd3, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xe9, 0x00, 0xff, 0x26, 0xcc, 0xff, 0xee, 0xd3, 0x3f, 0xfb, 0xec, 0x15, 0xcc, 0x00, 0xff, 0x30, 0x26, 0xe8, 0xcc, 0x00, 0xff, 0x11, 0xe9, 0x0b, 0x00, 0xca, 0xff, 0x00, 0xee, 0x00, 0xd3, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xe9, 0x00, 0xff, 0x26, 0xcb, 0xff, 0xee, 0xd2, 0x3f, 0xfb, 0xec, 0x15, 0xcb, 0x00, 0xff, 0x30, 0x26, 0xe8, 0xcb, 0x00, 0xff, 0x11, 0xe9, 0x0b, 0x00, 0xc9, 0xff, 0x00, 0xee, 0x00, 0xd2, 0x00,
	0xfb, 0x15, 0x00, 0xff, 0xe9, 0x00, 0xff, 0x26, 0xca, 0xff, 0xee, 0xd1, 0x3f, 0xfb, 0xec, 0x15, 0xca, 0x00, 0xff, 0x30, 0x26, 0xe8, 0xca, 0x00, 0xff, 0x11, 0xe9, 0x0b, 0x00, 0xc8, 0xff, 0x00, 0xee, 0x00, 0xd1, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x26, 0xca, 0xff, 0xed, 0xd1, 0x3f, 0xfb, 0xeb, 0x14, 0xca, 0x00, 0xff, 0x30, 0x26, 0xe7, 0xca, 0x00, 0xff, 0x11, 0xe8, 0x0b, 0x00, 0xc8, 0xff, 0x00, 0xed, 0x00, 0xd1, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x26, 0xc9, 0xff, 0xed, 0xd0, 0x3f, 0xfb, 0xeb, 0x14, 0xc9, 0x00, 0xff, 0x30, 0x26, 0xe7, 0xc9, 0x00, 0xff, 0x11, 0xe8, 0x0b, 0x00, 0xc7, 0xff, 0x00, 0xed, 0x00, 0xd0, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x26, 0xc9, 0xff, 0xed, 0xcf, 0x3f, 0xfb, 0xeb, 0x14, 0xc8, 0x00, 0xff, 0x30, 0x26, 0xe7, 0xc9, 0x00, 0xff, 0x11, 0xe8, 0x0b, 0x00, 0xc6, 0xff, 0x00, 0xed, 0x00, 0xcf, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe8, 0x00, 0xff, 0x26, 0xc9, 0xff, 0xed, 0xcf, 0x3f, 0xfb, 0xeb, 0x14, 0xc8, 0x00, 0xff, 0x30, 0x26, 0xe7, 0xc9, 0x00, 0xff, 0x11, 0xe8, 0x0b, 0x00, 0xc6, 0xff, 0x00, 0xed, 0x00, 0xcf, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x26, 0xc8, 0xff, 0xec, 0xce, 0x3f, 0xfb, 0xea, 0x14, 0xc7, 0x00, 0xff, 0x30, 0x26, 0xe6, 0xc8, 0x00, 0xff, 0x11, 0xe7, 0x0b, 0x00, 0xc5, 0xff, 0x00, 0xec, 0x00, 0xce, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x26, 0xc7, 0xff, 0xec, 0xcd, 0x3f, 0xfb, 0xea, 0x14, 0xc6, 0x00, 0xff, 0x30, 0x26, 0xe6, 0xc7, 0x00, 0xff, 0x11, 0xe7, 0x0b, 0x00, 0xc4, 0xff, 0x00, 0xec, 0x00, 0xcd, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x26, 0xc7, 0xff, 0xec, 0xcd, 0x3f, 0xfb, 0xea, 0x14, 0xc6, 0x00, 0xff, 0x30, 0x26, 0xe6, 0xc7, 0x00, 0xff, 0x11, 0xe7, 0x0b, 0x00, 0xc4, 0xff, 0x00, 0xec, 0x00, 0xcd, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe7, 0x00, 0xff, 0x26, 0xc6, 0xff, 0xec, 0xcc, 0x3f, 0xfb, 0xea, 0x14, 0xc5, 0x00, 0xff, 0x30, 0x26, 0xe6, 0xc6, 0x00, 0xff, 0x11, 0xe7, 0x0b, 0x00, 0xc3, 0xff, 0x00, 0xec, 0x00, 0xcc, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe6, 0x00, 0xff, 0x26, 0xc5, 0xff, 0xeb, 0xcb, 0x3f, 0xfb, 0xe9, 0x14, 0xc4, 0x00, 0xff, 0x30, 0x26, 0xe5, 0xc5, 0x00, 0xff, 0x11, 0xe6, 0x0b, 0x00, 0xc2, 0xff, 0x00, 0xeb, 0x00, 0xcb, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe6, 0x00, 0xff, 0x26, 0xc5, 0xff, 0xeb, 0xcb, 0x3f, 0xfb, 0xe9, 0x14, 0xc4, 0x00, 0xff, 0x30, 0x26, 0xe5, 0xc5, 0x00, 0xff, 0x11, 0xe6, 0x0b, 0x00, 0xc2, 0xff, 0x00, 0xeb, 0x00, 0xcb, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe6, 0x00, 0xff, 0x26, 0xc4, 0xff, 0xeb, 0xca, 0x3f, 0xfb, 0xe9, 0x14, 0xc3, 0x00, 0xff, 0x30, 0x26, 0xe5, 0xc4, 0x00, 0xff, 0x11, 0xe6, 0x0b, 0x00, 0xc1, 0xff, 0x00, 0xeb, 0x00, 0xca, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x26, 0xc3, 0xff, 0xea, 0xc9, 0x3f, 0xfb, 0xe8, 0x14, 0xc2, 0x00, 0xff, 0x30, 0x26, 0xe4, 0xc3, 0x00, 0xff, 0x11, 0xe5, 0x0b, 0x00, 0xc0, 0xff, 0x00, 0xea, 0x00, 0xc9, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x26, 0xc3, 0xff, 0xea, 0xc9, 0x3f, 0xfb, 0xe8, 0x14, 0xc2, 0x00, 0xff, 0x30, 0x26, 0xe4, 0xc3, 0x00, 0xff, 0x11, 0xe5, 0x0b, 0x00, 0xc0, 0xff, 0x00, 0xea, 0x00, 0xc9, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x26, 0xc2, 0xff, 0xea, 0xc8, 0x3f, 0xfb, 0xe8, 0x14, 0xc1, 0x00, 0xff, 0x30, 0x26, 0xe4, 0xc2, 0x00, 0xff, 0x11, 0xe5, 0x0b, 0x00, 0xbf, 0xff, 0x00, 0xea, 0x00, 0xc8, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe5, 0x00, 0xff, 0x26, 0xc1, 0xff, 0xea, 0xc7, 0x3f, 0xfb, 0xe8, 0x14, 0xc0, 0x00, 0xff, 0x30, 0x26, 0xe4, 0xc1, 0x00, 0xff, 0x11, 0xe5, 0x0b, 0x00, 0xbe, 0xff, 0x00, 0xea, 0x00, 0xc7, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe4, 0x00, 0xff, 0x25, 0xc1, 0xff, 0xe9, 0xc7, 0x3f, 0xfb, 0xe7, 0x14, 0xc0, 0x00, 0xff, 0x30, 0x25, 0xe4, 0xc1, 0x00, 0xff, 0x11, 0xe4, 0x0b, 0x00, 0xbe, 0xff, 0x00, 0xe9, 0x00, 0xc7, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe4, 0x00, 0xff, 0x25, 0xc0, 0xff, 0xe9, 0xc6, 0x3f, 0xfb, 0xe7, 0x14, 0xbf, 0x00, 0xff, 0x30, 0x25, 0xe4, 0xc0, 0x00, 0xff, 0x11, 0xe4, 0x0b, 0x00, 0xbd, 0xff, 0x00, 0xe9, 0x00, 0xc6, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe4, 0x00, 0xff, 0x25, 0xbf, 0xff, 0xe9, 0xc5, 0x3f, 0xfb, 0xe7, 0x14, 0xbe, 0x00, 0xff, 0x30, 0x25, 0xe4, 0xbf, 0x00, 0xff, 0x11, 0xe4, 0x0b, 0x00, 0xbd, 0xff, 0x00, 0xe9, 0x00, 0xc5, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe3, 0x00, 0xff, 0x25, 0xbe, 0xff, 0xe8, 0xc4, 0x3f, 0xfb, 0xe6, 0x14, 0xbd, 0x00, 0xff, 0x30, 0x25, 0xe3, 0xbe, 0x00, 0xff, 0x11, 0xe3, 0x0b, 0x00, 0xbc, 0xff, 0x00, 0xe8, 0x00, 0xc4, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe3, 0x00, 0xff, 0x25, 0xbe, 0xff, 0xe8, 0xc4, 0x3f, 0xfb, 0xe6, 0x14, 0xbd, 0x00, 0xff, 0x30, 0x25, 0xe3, 0xbe, 0x00, 0xff, 0x11, 0xe3, 0x0b, 0x00, 0xbc, 0xff, 0x00, 0xe8, 0x00, 0xc4, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe3, 0x00, 0xff, 0x25, 0xbd, 0xff, 0xe8, 0xc3, 0x3f, 0xfb, 0xe6, 0x14, 0xbc, 0x00, 0xff, 0x30, 0x25, 0xe3, 0xbd, 0x00, 0xff, 0x11, 0xe3, 0x0b, 0x00, 0xbb, 0xff, 0x00, 0xe8, 0x00, 0xc3, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe2, 0x00, 0xff, 0x25, 0xbc, 0xff, 0xe7, 0xc2, 0x3f, 0xfb, 0xe5, 0x14, 0xbb, 0x00, 0xff, 0x30, 0x25, 0xe2, 0xbc, 0x00, 0xff, 0x11, 0xe2, 0x0b, 0x00, 0xba, 0xff, 0x00, 0xe7, 0x00, 0xc2, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe2, 0x00, 0xff, 0x25, 0xbb, 0xff, 0xe7, 0xc1, 0x3f, 0xfb, 0xe5, 0x14, 0xba, 0x00, 0xff, 0x30, 0x25, 0xe2, 0xbb, 0x00, 0xff, 0x11, 0xe2, 0x0b, 0x00, 0xb9, 0xff, 0x00, 0xe7, 0x00, 0xc1, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe2, 0x00, 0xff, 0x25, 0xbb, 0xff, 0xe7, 0xc1, 0x3f, 0xfb, 0xe5, 0x14, 0xba, 0x00, 0xff, 0x30, 0x25, 0xe2, 0xbb, 0x00, 0xff, 0x11, 0xe2, 0x0b, 0x00, 0xb9, 0xff, 0x00, 0xe7, 0x00, 0xc1, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x25, 0xba, 0xff, 0xe6, 0xc0, 0x3f, 0xfb, 0xe4, 0x14, 0xb9, 0x00, 0xff, 0x30, 0x25, 0xe1, 0xba, 0x00, 0xff, 0x11, 0xe1, 0x0b, 0x00, 0xb8, 0xff, 0x00, 0xe6, 0x00, 0xc0, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x25, 0xb9, 0xff, 0xe6, 0xbf, 0x3f, 0xfb, 0xe4, 0x14, 0xb8, 0x00, 0xff, 0x30, 0x25, 0xe1, 0xb9, 0x00, 0xff, 0x11, 0xe1, 0x0b, 0x00, 0xb7, 0xff, 0x00, 0xe6, 0x00, 0xbf, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x25, 0xb8, 0xff, 0xe6, 0xbe, 0x3f, 0xfb, 0xe4, 0x14, 0xb7, 0x00, 0xff, 0x30, 0x25, 0xe1, 0xb8, 0x00, 0xff, 0x11, 0xe1, 0x0b, 0x00, 0xb6, 0xff, 0x00, 0xe6, 0x00, 0xbe, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x25, 0xb7, 0xff, 0xe5, 0xbd, 0x3f, 0xfb, 0xe3, 0x14, 0xb6, 0x00, 0xff, 0x30, 0x25, 0xe0, 0xb7, 0x00, 0xff, 0x11, 0xe1, 0x0b, 0x00, 0xb5, 0xff, 0x00, 0xe5, 0x00, 0xbd, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x25, 0xb7, 0xff, 0xe5, 0xbd, 0x3f, 0xfb, 0xe3, 0x14, 0xb6, 0x00, 0xff, 0x30, 0x25, 0xe0, 0xb7, 0x00, 0xff, 0x11, 0xe1, 0x0b, 0x00, 0xb5, 0xff, 0x00, 0xe5, 0x00, 0xbd, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe1, 0x00, 0xff, 0x25, 0xb6, 0xff, 0xe5, 0xbc, 0x3f, 0xfb, 0xe3, 0x14, 0xb5, 0x00, 0xff, 0x30, 0x25, 0xe0, 0xb6, 0x00, 0xff, 0x11, 0xe1, 0x0b, 0x00, 0xb4, 0xff, 0x00, 0xe5, 0x00, 0xbc, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe0, 0x00, 0xff, 0x25, 0xb5, 0xff, 0xe4, 0xbb, 0x3f, 0xfb, 0xe2, 0x14, 0xb4, 0x00, 0xff, 0x30, 0x25, 0xdf, 0xb5, 0x00, 0xff, 0x11, 0xe0, 0x0b, 0x00, 0xb3, 0xff, 0x00, 0xe4, 0x00, 0xbb, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe0, 0x00, 0xff, 0x25, 0xb4, 0xff, 0xe4, 0xba, 0x3f, 0xfb, 0xe2, 0x14, 0xb3, 0x00, 0xff, 0x30, 0x25, 0xdf, 0xb4, 0x00, 0xff, 0x11, 0xe0, 0x0b, 0x00, 0xb2, 0xff, 0x00, 0xe4, 0x00, 0xba, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xe0, 0x00, 0xff, 0x25, 0xb4, 0xff, 0xe4, 0xba, 0x3f, 0xfb, 0xe2, 0x14, 0xb3, 0x00, 0xff, 0x30, 0x25, 0xdf, 0xb4, 0x00, 0xff, 0x11, 0xe0, 0x0b, 0x00, 0xb2, 0xff, 0x00, 0xe4, 0x00, 0xba, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xdf, 0x00, 0xff, 0x24, 0xb3, 0xff, 0xe3, 0xb9, 0x3f, 0xfb, 0xe1, 0x14, 0xb2, 0x00, 0xff, 0x30, 0x24, 0xde, 0xb3, 0x00, 0xff, 0x11, 0xdf, 0x0b, 0x00, 0xb1, 0xff, 0x00, 0xe3, 0x00, 0xb9, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xdf, 0x00, 0xff, 0x24, 0xb2, 0xff, 0xe3, 0xb8, 0x3f, 0xfb, 0xe1, 0x14, 0xb2, 0x00, 0xff, 0x30, 0x24, 0xde, 0xb2, 0x00, 0xff, 0x11, 0xdf, 0x0b, 0x00, 0xb0, 0xff, 0x00, 0xe3, 0x00, 0xb8, 0x00,
	0xfb, 0x14, 0x00, 0xff, 0xdf, 0x00, 0xff, 0x24, 0xb1, 0xff, 0xe3, 0xb7, 0x3f, 0xfb, 0xe1, 0x14, 0xb1, 0x00, 0xff, 0x30, 0x24, 0xde, 0xb1, 0x00, 0xff, 0x11, 0xdf, 0x0b, 0x00, 0xaf, 0xff, 0x00, 0xe3, 0x00, 0xb7, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xde, 0x00, 0xff, 0x24, 0xb0, 0xff, 0xe2, 0xb6, 0x3f, 0xfb, 0xe0, 0x13, 0xb0, 0x00, 0xff, 0x30, 0x24, 0xdd, 0xb0, 0x00, 0xff, 0x11, 0xde, 0x0b, 0x00, 0xae, 0xff, 0x00, 0xe2, 0x00, 0xb6, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xde, 0x00, 0xff, 0x24, 0xaf, 0xff, 0xe2, 0xb5, 0x3f, 0xfb, 0xe0, 0x13, 0xaf, 0x00, 0xff, 0x30, 0x24, 0xdd, 0xaf, 0x00, 0xff, 0x11, 0xde, 0x0b, 0x00, 0xad, 0xff, 0x00, 0xe2, 0x00, 0xb5, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x24, 0xae, 0xff, 0xe1, 0xb4, 0x3f, 0xfb, 0xdf, 0x13, 0xae, 0x00, 0xff, 0x30, 0x24, 0xdc, 0xae, 0x00, 0xff, 0x11, 0xdd, 0x0b, 0x00, 0xac, 0xff, 0x00, 0xe1, 0x00, 0xb4, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xdd, 0x00, 0xff, 0x24, 0xad, 0xff, 0xe1, 0xb3, 0x3f, 0xfb, 0xdf, 0x13, 0xad, 0x00, 0xff, 0x30, 0x24, 0xdc, 0xad, 0x00, 0xff, 0x11, 0xdd, 0x0b, 0x00, 0xab, 0xff, 0x00, 0xe1, 0x00, 0xb3, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xdc, 0x00, 0xff, 0x24, 0xac, 0xff, 0xe0, 0xb2, 0x3f, 0xfb, 0xde, 0x13, 0xac, 0x00, 0xff, 0x30, 0x24, 0xdb, 0xac, 0x00, 0xff, 0x11, 0xdc, 0x0b, 0x00, 0xaa, 0xff, 0x00, 0xe0, 0x00, 0xb2, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xdc, 0x00, 0xff, 0x24, 0xab, 0xff, 0xe0, 0xb1, 0x3f, 0xfb, 0xde, 0x13, 0xab, 0x00, 0xff, 0x30, 0x24, 0xdb, 0xab, 0x00, 0xff, 0x11, 0xdc, 0x0b, 0x00, 0xa9, 0xff, 0x00, 0xe0, 0x00, 0xb1, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xdb, 0x00, 0xff, 0x24, 0xaa, 0xff, 0xdf, 0xb0, 0x3f, 0xfb, 0xdd, 0x13, 0xaa, 0x00, 0xff, 0x30, 0x24, 0xda, 0xaa, 0x00, 0xff, 0x11, 0xdb, 0x0a, 0x00, 0xa8, 0xff, 0x00, 0xdf, 0x00, 0xb0, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xdb, 0x00, 0xff, 0x24, 0xaa, 0xff, 0xdf, 0xb0, 0x3f, 0xfb, 0xdd, 0x13, 0xaa, 0x00, 0xff, 0x30, 0x24, 0xda, 0xaa, 0x00, 0xff, 0x11, 0xdb, 0x0a, 0x00, 0xa8, 0xff, 0x00, 0xdf, 0x00, 0xb0, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xdb, 0x00, 0xff, 0x24, 0xaa, 0xff, 0xdf, 0xaf, 0x3f, 0xfb, 0xdd, 0x13, 0xa9, 0x00, 0xff, 0x30, 0x24, 0xda, 0xaa, 0x00, 0xff, 0x11, 0xdb, 0x0a, 0x00, 0xa7, 0xff, 0x00, 0xdf, 0x00, 0xaf, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xda, 0x00, 0xff, 0x24, 0xa9, 0xff, 0xde, 0xae, 0x3f, 0xfb, 0xdc, 0x13, 0xa8, 0x00, 0xff, 0x30, 0x24, 0xd9, 0xa9, 0x00, 0xff, 0x11, 0xda, 0x0a, 0x00, 0xa6, 0xff, 0x00, 0xde, 0x00, 0xae, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xda, 0x00, 0xff, 0x24, 0xa8, 0xff, 0xde, 0xad, 0x3f, 0xfb, 0xdc, 0x13, 0xa7, 0x00, 0xff, 0x30, 0x24, 0xd9, 0xa8, 0x00, 0xff, 0x11, 0xda, 0x0a, 0x00, 0xa6, 0xff, 0x00, 0xde, 0x00, 0xad, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xd9, 0x00, 0xff, 0x24, 0xa7, 0xff, 0xdd, 0xac, 0x3f, 0xfb, 0xdb, 0x13, 0xa6, 0x00, 0xff, 0x30, 0x24, 0xd8, 0xa7, 0x00, 0xff, 0x11, 0xd9, 0x0a, 0x00, 0xa5, 0xff, 0x00, 0xdd, 0x00, 0xac, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xd9, 0x00, 0xff, 0x24, 0xa6, 0xff, 0xdd, 0xab, 0x3f, 0xfb, 0xdb, 0x13, 0xa5, 0x00, 0xff, 0x30, 0x24, 0xd8, 0xa6, 0x00, 0xff, 0x11, 0xd9, 0x0a, 0x00, 0xa4, 0xff, 0x00, 0xdd, 0x00, 0xab, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xd8, 0x00, 0xff, 0x23, 0xa5, 0xff, 0xdc, 0xaa, 0x3f, 0xfb, 0xda, 0x13, 0xa4, 0x00, 0xff, 0x30, 0x23, 0xd7, 0xa5, 0x00, 0xff, 0x11, 0xd8, 0x0a, 0x00, 0xa3, 0xff, 0x00, 0xdc, 0x00, 0xaa, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xd8, 0x00, 0xff, 0x23, 0xa4, 0xff, 0xdc, 0xa9, 0x3f, 0xfb, 0xda, 0x13, 0xa3, 0x00, 0xff, 0x30, 0x23, 0xd7, 0xa4, 0x00, 0xff, 0x11, 0xd8, 0x0a, 0x00, 0xa2, 0xff, 0x00, 0xdc, 0x00, 0xa9, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x23, 0xa3, 0xff, 0xdb, 0xa8, 0x3f, 0xfb, 0xd9, 0x13, 0xa2, 0x00, 0xff, 0x30, 0x23, 0xd6, 0xa3, 0x00, 0xff, 0x11, 0xd7, 0x0a, 0x00, 0xa1, 0xff, 0x00, 0xdb, 0x00, 0xa8, 0x00,
	0xfb, 0x13, 0x00, 0xff, 0xd7, 0x00, 0xff, 0x23, 0xa2, 0xff, 0xdb, 0xa7, 0x3f, 0xfb, 0xd9, 0x13, 0xa1, 0x00, 0xff, 0x30, 0x23, 0xd6, 0xa2, 0x00, 0xff, 0x11, 0xd7, 0x0a, 0x00, 0xa0, 0xff, 0x00, 0xdb, 0x00, 0xa7, 0x00, /* 4000K */

	0xdb,	0x2b,	0x24,	0xfa,	0xf5,	0x5d,	0xe0,	0x32,	0xdf,	0xff,	0xfc,	0xf6,	0x72,	0xdb,	0xf6,	0x2b,	0xf0,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xdf,	0x56,	0xfa,	0x25,	0xf5,	0x00,	0x5d,	0xe7,	0xff,	0x00,	0xfb,	0x00,	0xf4,	0x00, /*	6500K	*/ /* Night Dim Natural custom without black */
	0xda,	0x2b,	0x24,	0xf9,	0xf5,	0x5d,	0xe0,	0x32,	0xde,	0xff,	0xfb,	0xf3,	0x72,	0xda,	0xf6,	0x2b,	0xef,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xde,	0x56,	0xf9,	0x25,	0xf5,	0x00,	0x5d,	0xe6,	0xff,	0x00,	0xfa,	0x00,	0xf0,	0x00,
	0xda,	0x2b,	0x24,	0xf8,	0xf4,	0x5c,	0xe0,	0x31,	0xdc,	0xff,	0xfa,	0xef,	0x71,	0xda,	0xf5,	0x2b,	0xed,	0x24,	0xe0,	0x6b,	0x31,	0xef,	0xdc,	0x55,	0xf8,	0x25,	0xf4,	0x00,	0x5c,	0xe3,	0xff,	0x00,	0xf8,	0x00,	0xeb,	0x00,
	0xd9,	0x2b,	0x24,	0xf8,	0xf3,	0x5b,	0xe0,	0x31,	0xda,	0xff,	0xf8,	0xeb,	0x71,	0xd9,	0xf3,	0x2b,	0xeb,	0x24,	0xe0,	0x6b,	0x31,	0xed,	0xda,	0x55,	0xf8,	0x25,	0xf3,	0x00,	0x5b,	0xe1,	0xff,	0x00,	0xf6,	0x00,	0xe5,	0x00,
	0xd8,	0x2b,	0x23,	0xf7,	0xf2,	0x5b,	0xdf,	0x31,	0xd8,	0xff,	0xf7,	0xe7,	0x70,	0xd8,	0xf2,	0x2b,	0xe9,	0x23,	0xdf,	0x6b,	0x31,	0xec,	0xd8,	0x55,	0xf7,	0x25,	0xf2,	0x00,	0x5b,	0xde,	0xff,	0x00,	0xf4,	0x00,	0xe0,	0x00,
	0xd8,	0x2b,	0x23,	0xf6,	0xf0,	0x5a,	0xde,	0x31,	0xd6,	0xff,	0xf5,	0xe2,	0x6f,	0xd8,	0xf1,	0x2b,	0xe7,	0x23,	0xde,	0x6a,	0x31,	0xeb,	0xd6,	0x54,	0xf6,	0x25,	0xf0,	0x00,	0x5a,	0xdb,	0xff,	0x00,	0xf2,	0x00,	0xDB,	0x00,
	0xd6,	0x2a,	0x23,	0xf3,	0xeb,	0x58,	0xdb,	0x2f,	0xce,	0xff,	0xf0,	0xd3,	0x6d,	0xd6,	0xec,	0x2a,	0xde,	0x23,	0xdb,	0x67,	0x2f,	0xe6,	0xce,	0x52,	0xf3,	0x25,	0xeb,	0x00,	0x58,	0xd4,	0xff,	0x00,	0xea,	0x00,	0xc7,	0x00,
	0xd2,	0x29,	0x22,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x69,	0xd2,	0xe6,	0x29,	0xd3,	0x22,	0xd8,	0x65,	0x2e,	0xe0,	0xc3,	0x50,	0xf0,	0x23,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe1,	0x00,	0xb3,	0x00,
	0xd0,	0x27,	0x21,	0xec,	0xdf,	0x54,	0xd4,	0x2d,	0xb7,	0xff,	0xe0,	0xa4,	0x67,	0xd0,	0xdf,	0x27,	0xc7,	0x21,	0xd4,	0x62,	0x2d,	0xda,	0xb7,	0x4e,	0xec,	0x23,	0xdf,	0x00,	0x54,	0xbe,	0xff,	0x00,	0xd5,	0x00,	0x9a,	0x00,
	0xcc,	0x26,	0x20,	0xe8,	0xd6,	0x51,	0xd1,	0x2b,	0xaa,	0xff,	0xd3,	0x86,	0x63,	0xcc,	0xd6,	0x26,	0xb9,	0x20,	0xd1,	0x5f,	0x2b,	0xd2,	0xaa,	0x4c,	0xe8,	0x21,	0xd6,	0x00,	0x51,	0xb1,	0xff,	0x00,	0xc6,	0x00,	0x7d,	0x00,
	0xc2,	0x23,	0x1d,	0xdc,	0xc1,	0x4b,	0xc7,	0x27,	0x90,	0xff,	0xb8,	0x58,	0x5b,	0xc2,	0xc1,	0x23,	0x9e,	0x1d,	0xc7,	0x57,	0x27,	0xbe,	0x90,	0x45,	0xdc,	0x1f,	0xc1,	0x00,	0x4b,	0x97,	0xff,	0x00,	0xa9,	0x00,	0x4d,	0x00, /*	2300K	*/

	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x00,	0xf7,	0x00,	0xe9,	0x00, /* 6000K */ /* Night Dim Natural adaptive without black*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x00,	0xf7,	0x00,	0xe8,	0x00, /* Color Gamut 95%~80% & Gray only 0*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe2,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe7,	0xff,	0x00,	0xf7,	0x00,	0xe8,	0x00,
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe1,	0xff,	0xf8,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe1,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe6,	0xff,	0x00,	0xf6,	0x00,	0xe7,	0x00,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x38,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf6,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x34,	0xfb,	0x17,	0xf5,	0x00,	0x38,	0xe6,	0xff,	0x00,	0xf6,	0x00,	0xe7,	0x00,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe6,	0xff,	0x00,	0xf6,	0x00,	0xe6,	0x00,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe0,	0xff,	0xf8,	0xea,	0x47,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x43,	0x1f,	0xf2,	0xe0,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe5,	0xff,	0x00,	0xf6,	0x00,	0xe6,	0x00,
	0xe7,	0x1b,	0x17,	0xfb,	0xf5,	0x3a,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xea,	0x48,	0xe7,	0xf5,	0x1b,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfb,	0x17,	0xf5,	0x00,	0x3a,	0xe5,	0xff,	0x00,	0xf5,	0x00,	0xe5,	0x00,
	0xe7,	0x1c,	0x17,	0xfa,	0xf5,	0x3b,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xe9,	0x48,	0xe7,	0xf5,	0x1c,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfa,	0x18,	0xf5,	0x00,	0x3b,	0xe4,	0xff,	0x00,	0xf5,	0x00,	0xe5,	0x00,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3b,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe9,	0x49,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x45,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3b,	0xe4,	0xff,	0x00,	0xf5,	0x00,	0xe4,	0x00,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe8,	0x4a,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x46,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x00,	0xf5,	0x00,	0xe3,	0x00,
	0xe6,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe8,	0x4a,	0xe6,	0xf4,	0x1c,	0xea,	0x18,	0xea,	0x46,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x00,	0xf5,	0x00,	0xe3,	0x00,
	0xe6,	0x1d,	0x18,	0xfa,	0xf4,	0x3d,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe7,	0x4b,	0xe6,	0xf4,	0x1d,	0xea,	0x18,	0xea,	0x47,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x19,	0xf4,	0x00,	0x3d,	0xe3,	0xff,	0x00,	0xf4,	0x00,	0xe2,	0x00,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf7,	0xe7,	0x4c,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x48,	0x22,	0xf0,	0xdd,	0x39,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe2,	0xff,	0x00,	0xf4,	0x00,	0xe2,	0x00,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4d,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x49,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe1,	0xff,	0x00,	0xf4,	0x00,	0xe1,	0x00,
	0xe5,	0x1e,	0x19,	0xfa,	0xf3,	0x3f,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4e,	0xe5,	0xf4,	0x1e,	0xe9,	0x19,	0xe9,	0x4a,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x1a,	0xf3,	0x00,	0x3f,	0xe1,	0xff,	0x00,	0xf4,	0x00,	0xe1,	0x00,
	0xe4,	0x1e,	0x19,	0xfa,	0xf3,	0x40,	0xe9,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x19,	0xe9,	0x4b,	0x23,	0xf0,	0xdc,	0x3b,	0xfa,	0x1a,	0xf3,	0x00,	0x40,	0xe0,	0xff,	0x00,	0xf3,	0x00,	0xe0,	0x00,
	0xe4,	0x1e,	0x1a,	0xfa,	0xf2,	0x40,	0xe8,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x1a,	0xe8,	0x4b,	0x23,	0xef,	0xdc,	0x3c,	0xfa,	0x1a,	0xf2,	0x00,	0x40,	0xe0,	0xff,	0x00,	0xf3,	0x00,	0xe0,	0x00,
	0xe4,	0x1f,	0x1a,	0xf9,	0xf2,	0x41,	0xe8,	0x23,	0xdb,	0xff,	0xf6,	0xe4,	0x50,	0xe4,	0xf3,	0x1f,	0xe8,	0x1a,	0xe8,	0x4c,	0x23,	0xef,	0xdb,	0x3c,	0xf9,	0x1b,	0xf2,	0x00,	0x41,	0xdf,	0xff,	0x00,	0xf3,	0x00,	0xdf,	0x00,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xdb,	0xff,	0xf6,	0xe4,	0x51,	0xe3,	0xf3,	0x1f,	0xe7,	0x1a,	0xe8,	0x4d,	0x24,	0xef,	0xdb,	0x3d,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xdf,	0xff,	0x00,	0xf3,	0x00,	0xde,	0x00,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xda,	0xff,	0xf5,	0xe3,	0x52,	0xe3,	0xf2,	0x1f,	0xe7,	0x1a,	0xe8,	0x4e,	0x24,	0xef,	0xda,	0x3e,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xde,	0xff,	0x00,	0xf2,	0x00,	0xde,	0x00,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x43,	0xe7,	0x25,	0xda,	0xff,	0xf5,	0xe3,	0x53,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x4f,	0x25,	0xee,	0xda,	0x3e,	0xf9,	0x1c,	0xf1,	0x00,	0x43,	0xde,	0xff,	0x00,	0xf2,	0x00,	0xdd,	0x00,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe2,	0x54,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x50,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x00,	0xf2,	0x00,	0xdc,	0x00,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe1,	0x55,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x51,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x00,	0xf2,	0x00,	0xdb,	0x00,
	0xe1,	0x20,	0x1b,	0xf9,	0xf1,	0x45,	0xe6,	0x25,	0xd8,	0xff,	0xf5,	0xe1,	0x55,	0xe1,	0xf2,	0x20,	0xe5,	0x1b,	0xe6,	0x51,	0x25,	0xee,	0xd8,	0x40,	0xf9,	0x1c,	0xf1,	0x00,	0x45,	0xdc,	0xff,	0x00,	0xf1,	0x00,	0xdb,	0x00,
	0xe1,	0x21,	0x1b,	0xf9,	0xf0,	0x45,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1b,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x40,	0xf9,	0x1d,	0xf0,	0x00,	0x45,	0xdc,	0xff,	0x00,	0xf1,	0x00,	0xda,	0x00,
	0xe1,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1c,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdc,	0xff,	0x00,	0xf1,	0x00,	0xd9,	0x00,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdb,	0xff,	0x00,	0xf1,	0x00,	0xd9,	0x00,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x00,	0xf0,	0x00,	0xd8,	0x00,
	0xe0,	0x22,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x27,	0xd7,	0xff,	0xf4,	0xde,	0x58,	0xe0,	0xf1,	0x22,	0xe4,	0x1c,	0xe5,	0x54,	0x27,	0xec,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x00,	0xf0,	0x00,	0xd7,	0x00,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf4,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x00,	0xf0,	0x00,	0xd6,	0x00,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf3,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x00,	0xef,	0x00,	0xd6,	0x00,
	0xdf,	0x22,	0x1d,	0xf7,	0xef,	0x49,	0xe4,	0x27,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xdf,	0xf0,	0x22,	0xe3,	0x1d,	0xe4,	0x56,	0x27,	0xec,	0xd5,	0x43,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xda,	0xff,	0x00,	0xef,	0x00,	0xd5,	0x00,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x49,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x56,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xd9,	0xff,	0x00,	0xef,	0x00,	0xd4,	0x00,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x4a,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdb,	0x5b,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x57,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x4a,	0xd9,	0xff,	0x00,	0xef,	0x00,	0xd3,	0x00,
	0xde,	0x23,	0x1d,	0xf7,	0xee,	0x4a,	0xe3,	0x28,	0xd4,	0xff,	0xf3,	0xdb,	0x5c,	0xde,	0xef,	0x23,	0xe2,	0x1d,	0xe3,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4a,	0xd9,	0xff,	0x00,	0xee,	0x00,	0xd3,	0x00,
	0xdd,	0x23,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x28,	0xd4,	0xff,	0xf3,	0xda,	0x5c,	0xdd,	0xef,	0x23,	0xe1,	0x1d,	0xe2,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x00,	0xee,	0x00,	0xd2,	0x00,
	0xdd,	0x24,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xda,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1d,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x00,	0xee,	0x00,	0xd1,	0x00,
	0xdd,	0x24,	0x1e,	0xf6,	0xee,	0x4c,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xd9,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1e,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf6,	0x1f,	0xee,	0x00,	0x4c,	0xd8,	0xff,	0x00,	0xed,	0x00,	0xd1,	0x00,
	0xdc,	0x24,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x29,	0xd3,	0xff,	0xf2,	0xd8,	0x5e,	0xdc,	0xee,	0x24,	0xe0,	0x1e,	0xe1,	0x5a,	0x29,	0xea,	0xd3,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x00,	0xed,	0x00,	0xd0,	0x00,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd8,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x00,	0xed,	0x00,	0xcf,	0x00,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd7,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd7,	0xff,	0x00,	0xed,	0x00,	0xcf,	0x00,
	0xdb,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe0,	0x2a,	0xd1,	0xff,	0xf2,	0xd7,	0x60,	0xdb,	0xee,	0x25,	0xdf,	0x1e,	0xe0,	0x5c,	0x2a,	0xe9,	0xd1,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd6,	0xff,	0x00,	0xec,	0x00,	0xce,	0x00,
	0xdb,	0x25,	0x1f,	0xf5,	0xed,	0x4f,	0xe0,	0x2a,	0xd1,	0xff,	0xf1,	0xd6,	0x61,	0xdb,	0xee,	0x25,	0xdf,	0x1f,	0xe0,	0x5d,	0x2a,	0xe9,	0xd1,	0x49,	0xf5,	0x21,	0xed,	0x00,	0x4f,	0xd6,	0xff,	0x00,	0xec,	0x00,	0xcd,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x4f,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd6,	0x61,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5d,	0x2b,	0xe8,	0xd0,	0x49,	0xf5,	0x21,	0xec,	0x00,	0x4f,	0xd5,	0xff,	0x00,	0xec,	0x00,	0xcd,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd5,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x00,	0xec,	0x00,	0xcc,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd4,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x00,	0xeb,	0x00,	0xcb,	0x00,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x51,	0xdf,	0x2b,	0xcf,	0xff,	0xf1,	0xd4,	0x63,	0xda,	0xed,	0x26,	0xdd,	0x1f,	0xdf,	0x5f,	0x2b,	0xe8,	0xcf,	0x4b,	0xf5,	0x21,	0xec,	0x00,	0x51,	0xd4,	0xff,	0x00,	0xeb,	0x00,	0xcb,	0x00,
	0xd9,	0x26,	0x1f,	0xf5,	0xeb,	0x51,	0xde,	0x2b,	0xcf,	0xff,	0xf0,	0xd3,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x1f,	0xde,	0x5f,	0x2b,	0xe7,	0xcf,	0x4b,	0xf5,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x00,	0xeb,	0x00,	0xca,	0x00,
	0xd9,	0x26,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xcf,	0xff,	0xf0,	0xd2,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x20,	0xde,	0x5f,	0x2c,	0xe7,	0xcf,	0x4b,	0xf4,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x00,	0xea,	0x00,	0xc9,	0x00,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd2,	0x64,	0xd9,	0xec,	0x27,	0xdd,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4b,	0xf4,	0x22,	0xeb,	0x00,	0x51,	0xd3,	0xff,	0x00,	0xea,	0x00,	0xc9,	0x00,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd1,	0x64,	0xd9,	0xec,	0x27,	0xdc,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x00,	0xea,	0x00,	0xc8,	0x00,
	0xd8,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xec,	0x27,	0xdc,	0x20,	0xdd,	0x60,	0x2c,	0xe7,	0xcd,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x00,	0xea,	0x00,	0xc7,	0x00,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xeb,	0x27,	0xdc,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4c,	0xf4,	0x22,	0xea,	0x00,	0x52,	0xd2,	0xff,	0x00,	0xe9,	0x00,	0xc7,	0x00,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x53,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xcf,	0x65,	0xd8,	0xeb,	0x27,	0xdb,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4d,	0xf4,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x00,	0xe9,	0x00,	0xc6,	0x00,
	0xd8,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdd,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd8,	0xeb,	0x27,	0xdb,	0x21,	0xdd,	0x61,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x00,	0xe9,	0x00,	0xc5,	0x00,
	0xd7,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdc,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd7,	0xeb,	0x27,	0xdb,	0x21,	0xdc,	0x62,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd1,	0xff,	0x00,	0xe8,	0x00,	0xc4,	0x00,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x00,	0xe8,	0x00,	0xc4,	0x00,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x00,	0xe8,	0x00,	0xc3,	0x00,
	0xd6,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdb,	0x2d,	0xcb,	0xff,	0xee,	0xcc,	0x67,	0xd6,	0xea,	0x28,	0xda,	0x21,	0xdb,	0x63,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x00,	0xe7,	0x00,	0xc2,	0x00,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x54,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xda,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4e,	0xf2,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x00,	0xe7,	0x00,	0xc1,	0x00,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xd9,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4f,	0xf2,	0x23,	0xe9,	0x00,	0x55,	0xd0,	0xff,	0x00,	0xe7,	0x00,	0xc1,	0x00,
	0xd6,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xed,	0xca,	0x68,	0xd6,	0xe9,	0x28,	0xd9,	0x22,	0xdb,	0x64,	0x2e,	0xe4,	0xca,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x00,	0xe6,	0x00,	0xc0,	0x00,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd9,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x00,	0xe6,	0x00,	0xbf,	0x00,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd8,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x50,	0xf2,	0x23,	0xe8,	0x00,	0x56,	0xcf,	0xff,	0x00,	0xe6,	0x00,	0xbe,	0x00,
	0xd5,	0x29,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc8,	0xff,	0xed,	0xc8,	0x6a,	0xd5,	0xe9,	0x29,	0xd8,	0x22,	0xda,	0x65,	0x2e,	0xe4,	0xc8,	0x50,	0xf2,	0x24,	0xe8,	0x00,	0x56,	0xce,	0xff,	0x00,	0xe5,	0x00,	0xbd,	0x00,
	0xd5,	0x29,	0x23,	0xf1,	0xe7,	0x56,	0xda,	0x2f,	0xc8,	0xff,	0xec,	0xc7,	0x6a,	0xd5,	0xe8,	0x29,	0xd8,	0x23,	0xda,	0x65,	0x2f,	0xe3,	0xc8,	0x50,	0xf1,	0x24,	0xe7,	0x00,	0x56,	0xce,	0xff,	0x00,	0xe5,	0x00,	0xbd,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc7,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x00,	0xe5,	0x00,	0xbc,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc6,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x00,	0xe4,	0x00,	0xbb,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xeb,	0xc5,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x00,	0xe4,	0x00,	0xba,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc4,	0x6b,	0xd4,	0xe8,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc6,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcc,	0xff,	0x00,	0xe4,	0x00,	0xba,	0x00,
	0xd4,	0x29,	0x23,	0xf1,	0xe6,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc3,	0x6b,	0xd4,	0xe7,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe2,	0xc6,	0x51,	0xf1,	0x24,	0xe6,	0x00,	0x57,	0xcc,	0xff,	0x00,	0xe3,	0x00,	0xb9,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xeb,	0xc3,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x00,	0xe3,	0x00,	0xb8,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xea,	0xc2,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x00,	0xe3,	0x00,	0xb7,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc5,	0xff,	0xea,	0xc1,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2e,	0xe2,	0xc5,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xcb,	0xff,	0x00,	0xe2,	0x00,	0xb6,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xc0,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x00,	0xe2,	0x00,	0xb5,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xbf,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x00,	0xe1,	0x00,	0xb4,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe1,	0x00,	0xb3,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe0,	0x00,	0xb2,	0x00,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x00,	0xe0,	0x00,	0xb1,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbc,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x00,	0xdf,	0x00,	0xb0,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbb,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x00,	0xdf,	0x00,	0xb0,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xba,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x00,	0xdf,	0x00,	0xaf,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xb9,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x00,	0xde,	0x00,	0xae,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe7,	0xb8,	0x69,	0xd2,	0xe4,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xdf,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x00,	0xde,	0x00,	0xad,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb7,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x00,	0xdd,	0x00,	0xac,	0x00,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb6,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x00,	0xdd,	0x00,	0xab,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe4,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe7,	0xb6,	0x68,	0xd1,	0xe4,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xdf,	0xbf,	0x4f,	0xee,	0x23,	0xe4,	0x00,	0x55,	0xc5,	0xff,	0x00,	0xdc,	0x00,	0xaa,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe6,	0xb5,	0x68,	0xd1,	0xe3,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbf,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc5,	0xff,	0x00,	0xdc,	0x00,	0xa9,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb4,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x00,	0xdb,	0x00,	0xa8,	0x00,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb3,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x00,	0xdb,	0x00,	0xa7,	0x00, /* 4000K */

	0xdb,	0x2b,	0x24,	0xfa,	0xf5,	0x5d,	0xe0,	0x32,	0xdf,	0xff,	0xfc,	0xf6,	0x72,	0xdb,	0xf6,	0x2b,	0xf0,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xdf,	0x56,	0xfa,	0x25,	0xf5,	0x00,	0x5d,	0xe7,	0xff,	0x10,	0xfb,	0x10,	0xf4,	0x10, /* 6500K */ /* Night Dim Natural Custom*/
	0xda,	0x2b,	0x24,	0xf9,	0xf5,	0x5d,	0xe0,	0x32,	0xde,	0xff,	0xfb,	0xf3,	0x72,	0xda,	0xf6,	0x2b,	0xef,	0x24,	0xe0,	0x6c,	0x32,	0xf0,	0xde,	0x56,	0xf9,	0x25,	0xf5,	0x00,	0x5d,	0xe6,	0xff,	0x10,	0xfa,	0x10,	0xf0,	0x10,
	0xda,	0x2b,	0x24,	0xf8,	0xf4,	0x5c,	0xe0,	0x31,	0xdc,	0xff,	0xfa,	0xef,	0x71,	0xda,	0xf5,	0x2b,	0xed,	0x24,	0xe0,	0x6b,	0x31,	0xef,	0xdc,	0x55,	0xf8,	0x25,	0xf4,	0x00,	0x5c,	0xe3,	0xff,	0x10,	0xf8,	0x10,	0xeb,	0x10,
	0xd9,	0x2b,	0x24,	0xf8,	0xf3,	0x5b,	0xe0,	0x31,	0xda,	0xff,	0xf8,	0xeb,	0x71,	0xd9,	0xf3,	0x2b,	0xeb,	0x24,	0xe0,	0x6b,	0x31,	0xed,	0xda,	0x55,	0xf8,	0x25,	0xf3,	0x00,	0x5b,	0xe1,	0xff,	0x10,	0xf6,	0x10,	0xe5,	0x10,
	0xd8,	0x2b,	0x23,	0xf7,	0xf2,	0x5b,	0xdf,	0x31,	0xd8,	0xff,	0xf7,	0xe7,	0x70,	0xd8,	0xf2,	0x2b,	0xe9,	0x23,	0xdf,	0x6b,	0x31,	0xec,	0xd8,	0x55,	0xf7,	0x25,	0xf2,	0x00,	0x5b,	0xde,	0xff,	0x10,	0xf4,	0x10,	0xe0,	0x10,
	0xd8,	0x2b,	0x23,	0xf6,	0xf0,	0x5a,	0xde,	0x31,	0xd6,	0xff,	0xf5,	0xe2,	0x6f,	0xd8,	0xf1,	0x2b,	0xe7,	0x23,	0xde,	0x6a,	0x31,	0xeb,	0xd6,	0x54,	0xf6,	0x25,	0xf0,	0x00,	0x5a,	0xdb,	0xff,	0x10,	0xf2,	0x10,	0xDB,	0x10,
	0xd6,	0x2a,	0x23,	0xf3,	0xeb,	0x58,	0xdb,	0x2f,	0xce,	0xff,	0xf0,	0xd3,	0x6d,	0xd6,	0xec,	0x2a,	0xde,	0x23,	0xdb,	0x67,	0x2f,	0xe6,	0xce,	0x52,	0xf3,	0x25,	0xeb,	0x00,	0x58,	0xd4,	0xff,	0x10,	0xea,	0x10,	0xc7,	0x10,
	0xd2,	0x29,	0x22,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x69,	0xd2,	0xe6,	0x29,	0xd3,	0x22,	0xd8,	0x65,	0x2e,	0xe0,	0xc3,	0x50,	0xf0,	0x23,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe1,	0x10,	0xb3,	0x10,
	0xd0,	0x27,	0x21,	0xec,	0xdf,	0x54,	0xd4,	0x2d,	0xb7,	0xff,	0xe0,	0xa4,	0x67,	0xd0,	0xdf,	0x27,	0xc7,	0x21,	0xd4,	0x62,	0x2d,	0xda,	0xb7,	0x4e,	0xec,	0x23,	0xdf,	0x00,	0x54,	0xbe,	0xff,	0x10,	0xd5,	0x10,	0x9a,	0x10,
	0xcc,	0x26,	0x20,	0xe8,	0xd6,	0x51,	0xd1,	0x2b,	0xaa,	0xff,	0xd3,	0x86,	0x63,	0xcc,	0xd6,	0x26,	0xb9,	0x20,	0xd1,	0x5f,	0x2b,	0xd2,	0xaa,	0x4c,	0xe8,	0x21,	0xd6,	0x00,	0x51,	0xb1,	0xff,	0x10,	0xc6,	0x10,	0x7d,	0x10,
	0xc2,	0x23,	0x1d,	0xdc,	0xc1,	0x4b,	0xc7,	0x27,	0x90,	0xff,	0xb8,	0x58,	0x5b,	0xc2,	0xc1,	0x23,	0x9e,	0x1d,	0xc7,	0x57,	0x27,	0xbe,	0x90,	0x45,	0xdc,	0x1f,	0xc1,	0x00,	0x4b,	0x97,	0xff,	0x10,	0xa9,	0x10,	0x4d,	0x10,

	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x05,	0xf7,	0x05,	0xe9,	0x05, /* 6000K */ /* Night Dim Natural Adaptive*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x37,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xed,	0x44,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x40,	0x1e,	0xf3,	0xe2,	0x33,	0xfb,	0x16,	0xf6,	0x00,	0x37,	0xe7,	0xff,	0x08,	0xf7,	0x08,	0xe8,	0x08, /* Color Gamut 95%~80% & Gray 5 to 16*/
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe2,	0xff,	0xf9,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe2,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe7,	0xff,	0x08,	0xf7,	0x08,	0xe8,	0x08,
	0xe9,	0x1a,	0x16,	0xfb,	0xf6,	0x38,	0xec,	0x1e,	0xe1,	0xff,	0xf8,	0xec,	0x45,	0xe9,	0xf6,	0x1a,	0xed,	0x16,	0xec,	0x41,	0x1e,	0xf3,	0xe1,	0x34,	0xfb,	0x16,	0xf6,	0x00,	0x38,	0xe6,	0xff,	0x08,	0xf6,	0x08,	0xe7,	0x08,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x38,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf6,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x34,	0xfb,	0x17,	0xf5,	0x00,	0x38,	0xe6,	0xff,	0x08,	0xf6,	0x08,	0xe7,	0x08,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe1,	0xff,	0xf8,	0xeb,	0x46,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x42,	0x1f,	0xf2,	0xe1,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe6,	0xff,	0x08,	0xf6,	0x08,	0xe6,	0x08,
	0xe8,	0x1b,	0x17,	0xfb,	0xf5,	0x39,	0xeb,	0x1f,	0xe0,	0xff,	0xf8,	0xea,	0x47,	0xe8,	0xf5,	0x1b,	0xec,	0x17,	0xeb,	0x43,	0x1f,	0xf2,	0xe0,	0x35,	0xfb,	0x17,	0xf5,	0x00,	0x39,	0xe5,	0xff,	0x08,	0xf6,	0x08,	0xe6,	0x08,
	0xe7,	0x1b,	0x17,	0xfb,	0xf5,	0x3a,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xea,	0x48,	0xe7,	0xf5,	0x1b,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfb,	0x17,	0xf5,	0x00,	0x3a,	0xe5,	0xff,	0x08,	0xf5,	0x08,	0xe5,	0x08,
	0xe7,	0x1c,	0x17,	0xfa,	0xf5,	0x3b,	0xeb,	0x20,	0xe0,	0xff,	0xf8,	0xe9,	0x48,	0xe7,	0xf5,	0x1c,	0xeb,	0x17,	0xeb,	0x44,	0x20,	0xf2,	0xe0,	0x36,	0xfa,	0x18,	0xf5,	0x00,	0x3b,	0xe4,	0xff,	0x08,	0xf5,	0x08,	0xe5,	0x08,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3b,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe9,	0x49,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x45,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3b,	0xe4,	0xff,	0x08,	0xf5,	0x08,	0xe4,	0x08,
	0xe7,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x20,	0xdf,	0xff,	0xf7,	0xe8,	0x4a,	0xe7,	0xf5,	0x1c,	0xeb,	0x18,	0xea,	0x46,	0x20,	0xf1,	0xdf,	0x37,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x08,	0xf5,	0x08,	0xe3,	0x08,
	0xe6,	0x1c,	0x18,	0xfa,	0xf4,	0x3c,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe8,	0x4a,	0xe6,	0xf4,	0x1c,	0xea,	0x18,	0xea,	0x46,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x18,	0xf4,	0x00,	0x3c,	0xe3,	0xff,	0x08,	0xf5,	0x08,	0xe3,	0x08,
	0xe6,	0x1d,	0x18,	0xfa,	0xf4,	0x3d,	0xea,	0x21,	0xde,	0xff,	0xf7,	0xe7,	0x4b,	0xe6,	0xf4,	0x1d,	0xea,	0x18,	0xea,	0x47,	0x21,	0xf1,	0xde,	0x38,	0xfa,	0x19,	0xf4,	0x00,	0x3d,	0xe3,	0xff,	0x08,	0xf4,	0x08,	0xe2,	0x08,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf7,	0xe7,	0x4c,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x48,	0x22,	0xf0,	0xdd,	0x39,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe2,	0xff,	0x08,	0xf4,	0x08,	0xe2,	0x08,
	0xe5,	0x1d,	0x19,	0xfa,	0xf3,	0x3e,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4d,	0xe5,	0xf4,	0x1d,	0xe9,	0x19,	0xe9,	0x49,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x19,	0xf3,	0x00,	0x3e,	0xe1,	0xff,	0x08,	0xf4,	0x08,	0xe1,	0x08,
	0xe5,	0x1e,	0x19,	0xfa,	0xf3,	0x3f,	0xe9,	0x22,	0xdd,	0xff,	0xf6,	0xe6,	0x4e,	0xe5,	0xf4,	0x1e,	0xe9,	0x19,	0xe9,	0x4a,	0x22,	0xf0,	0xdd,	0x3a,	0xfa,	0x1a,	0xf3,	0x00,	0x3f,	0xe1,	0xff,	0x08,	0xf4,	0x08,	0xe1,	0x08,
	0xe4,	0x1e,	0x19,	0xfa,	0xf3,	0x40,	0xe9,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x19,	0xe9,	0x4b,	0x23,	0xf0,	0xdc,	0x3b,	0xfa,	0x1a,	0xf3,	0x00,	0x40,	0xe0,	0xff,	0x08,	0xf3,	0x08,	0xe0,	0x08,
	0xe4,	0x1e,	0x1a,	0xfa,	0xf2,	0x40,	0xe8,	0x23,	0xdc,	0xff,	0xf6,	0xe5,	0x4f,	0xe4,	0xf3,	0x1e,	0xe8,	0x1a,	0xe8,	0x4b,	0x23,	0xef,	0xdc,	0x3c,	0xfa,	0x1a,	0xf2,	0x00,	0x40,	0xe0,	0xff,	0x08,	0xf3,	0x08,	0xe0,	0x08,
	0xe4,	0x1f,	0x1a,	0xf9,	0xf2,	0x41,	0xe8,	0x23,	0xdb,	0xff,	0xf6,	0xe4,	0x50,	0xe4,	0xf3,	0x1f,	0xe8,	0x1a,	0xe8,	0x4c,	0x23,	0xef,	0xdb,	0x3c,	0xf9,	0x1b,	0xf2,	0x00,	0x41,	0xdf,	0xff,	0x08,	0xf3,	0x08,	0xdf,	0x08,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xdb,	0xff,	0xf6,	0xe4,	0x51,	0xe3,	0xf3,	0x1f,	0xe7,	0x1a,	0xe8,	0x4d,	0x24,	0xef,	0xdb,	0x3d,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xdf,	0xff,	0x08,	0xf3,	0x08,	0xde,	0x08,
	0xe3,	0x1f,	0x1a,	0xf9,	0xf2,	0x42,	0xe8,	0x24,	0xda,	0xff,	0xf5,	0xe3,	0x52,	0xe3,	0xf2,	0x1f,	0xe7,	0x1a,	0xe8,	0x4e,	0x24,	0xef,	0xda,	0x3e,	0xf9,	0x1b,	0xf2,	0x00,	0x42,	0xde,	0xff,	0x08,	0xf2,	0x08,	0xde,	0x08,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x43,	0xe7,	0x25,	0xda,	0xff,	0xf5,	0xe3,	0x53,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x4f,	0x25,	0xee,	0xda,	0x3e,	0xf9,	0x1c,	0xf1,	0x00,	0x43,	0xde,	0xff,	0x08,	0xf2,	0x08,	0xdd,	0x08,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe2,	0x54,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x50,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x08,	0xf2,	0x08,	0xdc,	0x08,
	0xe2,	0x20,	0x1b,	0xf9,	0xf1,	0x44,	0xe7,	0x25,	0xd9,	0xff,	0xf5,	0xe1,	0x55,	0xe2,	0xf2,	0x20,	0xe6,	0x1b,	0xe7,	0x51,	0x25,	0xee,	0xd9,	0x3f,	0xf9,	0x1c,	0xf1,	0x00,	0x44,	0xdd,	0xff,	0x0c,	0xf2,	0x0c,	0xdb,	0x0c,
	0xe1,	0x20,	0x1b,	0xf9,	0xf1,	0x45,	0xe6,	0x25,	0xd8,	0xff,	0xf5,	0xe1,	0x55,	0xe1,	0xf2,	0x20,	0xe5,	0x1b,	0xe6,	0x51,	0x25,	0xee,	0xd8,	0x40,	0xf9,	0x1c,	0xf1,	0x00,	0x45,	0xdc,	0xff,	0x0c,	0xf1,	0x0c,	0xdb,	0x0c,
	0xe1,	0x21,	0x1b,	0xf9,	0xf0,	0x45,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1b,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x40,	0xf9,	0x1d,	0xf0,	0x00,	0x45,	0xdc,	0xff,	0x0c,	0xf1,	0x0c,	0xda,	0x0c,
	0xe1,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe6,	0x26,	0xd8,	0xff,	0xf4,	0xe0,	0x56,	0xe1,	0xf1,	0x21,	0xe5,	0x1c,	0xe6,	0x52,	0x26,	0xed,	0xd8,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdc,	0xff,	0x0c,	0xf1,	0x0c,	0xd9,	0x0c,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x46,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x41,	0xf8,	0x1d,	0xf0,	0x00,	0x46,	0xdb,	0xff,	0x0c,	0xf1,	0x0c,	0xd9,	0x0c,
	0xe0,	0x21,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x26,	0xd7,	0xff,	0xf4,	0xdf,	0x57,	0xe0,	0xf1,	0x21,	0xe4,	0x1c,	0xe5,	0x53,	0x26,	0xed,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x0c,	0xf0,	0x0c,	0xd8,	0x0c,
	0xe0,	0x22,	0x1c,	0xf8,	0xf0,	0x47,	0xe5,	0x27,	0xd7,	0xff,	0xf4,	0xde,	0x58,	0xe0,	0xf1,	0x22,	0xe4,	0x1c,	0xe5,	0x54,	0x27,	0xec,	0xd7,	0x42,	0xf8,	0x1d,	0xf0,	0x00,	0x47,	0xdb,	0xff,	0x0c,	0xf0,	0x0c,	0xd7,	0x0c,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf4,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x0c,	0xf0,	0x0c,	0xd6,	0x0c,
	0xdf,	0x22,	0x1c,	0xf8,	0xef,	0x48,	0xe4,	0x27,	0xd6,	0xff,	0xf3,	0xdd,	0x59,	0xdf,	0xf0,	0x22,	0xe3,	0x1c,	0xe4,	0x55,	0x27,	0xec,	0xd6,	0x43,	0xf8,	0x1e,	0xef,	0x00,	0x48,	0xda,	0xff,	0x0c,	0xef,	0x0c,	0xd6,	0x0c,
	0xdf,	0x22,	0x1d,	0xf7,	0xef,	0x49,	0xe4,	0x27,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xdf,	0xf0,	0x22,	0xe3,	0x1d,	0xe4,	0x56,	0x27,	0xec,	0xd5,	0x43,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xda,	0xff,	0x0c,	0xef,	0x0c,	0xd5,	0x0c,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x49,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdc,	0x5a,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x56,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x49,	0xd9,	0xff,	0x0c,	0xef,	0x0c,	0xd4,	0x0c,
	0xde,	0x23,	0x1d,	0xf7,	0xef,	0x4a,	0xe3,	0x28,	0xd5,	0xff,	0xf3,	0xdb,	0x5b,	0xde,	0xf0,	0x23,	0xe2,	0x1d,	0xe3,	0x57,	0x28,	0xeb,	0xd5,	0x44,	0xf7,	0x1e,	0xef,	0x00,	0x4a,	0xd9,	0xff,	0x0c,	0xef,	0x0c,	0xd3,	0x0c,
	0xde,	0x23,	0x1d,	0xf7,	0xee,	0x4a,	0xe3,	0x28,	0xd4,	0xff,	0xf3,	0xdb,	0x5c,	0xde,	0xef,	0x23,	0xe2,	0x1d,	0xe3,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4a,	0xd9,	0xff,	0x0c,	0xee,	0x0c,	0xd3,	0x0c,
	0xdd,	0x23,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x28,	0xd4,	0xff,	0xf3,	0xda,	0x5c,	0xdd,	0xef,	0x23,	0xe1,	0x1d,	0xe2,	0x58,	0x28,	0xeb,	0xd4,	0x45,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x0c,	0xee,	0x0c,	0xd2,	0x0c,
	0xdd,	0x24,	0x1d,	0xf7,	0xee,	0x4b,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xda,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1d,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf7,	0x1f,	0xee,	0x00,	0x4b,	0xd8,	0xff,	0x0c,	0xee,	0x0c,	0xd1,	0x0c,
	0xdd,	0x24,	0x1e,	0xf6,	0xee,	0x4c,	0xe2,	0x29,	0xd3,	0xff,	0xf2,	0xd9,	0x5d,	0xdd,	0xef,	0x24,	0xe1,	0x1e,	0xe2,	0x59,	0x29,	0xea,	0xd3,	0x46,	0xf6,	0x1f,	0xee,	0x00,	0x4c,	0xd8,	0xff,	0x0c,	0xed,	0x0c,	0xd1,	0x0c,
	0xdc,	0x24,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x29,	0xd3,	0xff,	0xf2,	0xd8,	0x5e,	0xdc,	0xee,	0x24,	0xe0,	0x1e,	0xe1,	0x5a,	0x29,	0xea,	0xd3,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x0c,	0xed,	0x0c,	0xd0,	0x0c,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4d,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd8,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x47,	0xf6,	0x20,	0xed,	0x00,	0x4d,	0xd7,	0xff,	0x0c,	0xed,	0x0c,	0xcf,	0x0c,
	0xdc,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe1,	0x2a,	0xd2,	0xff,	0xf2,	0xd7,	0x5f,	0xdc,	0xee,	0x25,	0xe0,	0x1e,	0xe1,	0x5b,	0x2a,	0xe9,	0xd2,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd7,	0xff,	0x0c,	0xed,	0x0c,	0xcf,	0x0c,
	0xdb,	0x25,	0x1e,	0xf6,	0xed,	0x4e,	0xe0,	0x2a,	0xd1,	0xff,	0xf2,	0xd7,	0x60,	0xdb,	0xee,	0x25,	0xdf,	0x1e,	0xe0,	0x5c,	0x2a,	0xe9,	0xd1,	0x48,	0xf6,	0x20,	0xed,	0x00,	0x4e,	0xd6,	0xff,	0x0c,	0xec,	0x0c,	0xce,	0x0c,
	0xdb,	0x25,	0x1f,	0xf5,	0xed,	0x4f,	0xe0,	0x2a,	0xd1,	0xff,	0xf1,	0xd6,	0x61,	0xdb,	0xee,	0x25,	0xdf,	0x1f,	0xe0,	0x5d,	0x2a,	0xe9,	0xd1,	0x49,	0xf5,	0x21,	0xed,	0x00,	0x4f,	0xd6,	0xff,	0x0c,	0xec,	0x0c,	0xcd,	0x0c,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x4f,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd6,	0x61,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5d,	0x2b,	0xe8,	0xd0,	0x49,	0xf5,	0x21,	0xec,	0x00,	0x4f,	0xd5,	0xff,	0x0c,	0xec,	0x0c,	0xcd,	0x0c,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd5,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x0c,	0xec,	0x0c,	0xcc,	0x0c,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x50,	0xdf,	0x2b,	0xd0,	0xff,	0xf1,	0xd4,	0x62,	0xda,	0xed,	0x26,	0xde,	0x1f,	0xdf,	0x5e,	0x2b,	0xe8,	0xd0,	0x4a,	0xf5,	0x21,	0xec,	0x00,	0x50,	0xd5,	0xff,	0x0e,	0xeb,	0x0e,	0xcb,	0x0e,
	0xda,	0x26,	0x1f,	0xf5,	0xec,	0x51,	0xdf,	0x2b,	0xcf,	0xff,	0xf1,	0xd4,	0x63,	0xda,	0xed,	0x26,	0xdd,	0x1f,	0xdf,	0x5f,	0x2b,	0xe8,	0xcf,	0x4b,	0xf5,	0x21,	0xec,	0x00,	0x51,	0xd4,	0xff,	0x0e,	0xeb,	0x0e,	0xcb,	0x0e,
	0xd9,	0x26,	0x1f,	0xf5,	0xeb,	0x51,	0xde,	0x2b,	0xcf,	0xff,	0xf0,	0xd3,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x1f,	0xde,	0x5f,	0x2b,	0xe7,	0xcf,	0x4b,	0xf5,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x0e,	0xeb,	0x0e,	0xca,	0x0e,
	0xd9,	0x26,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xcf,	0xff,	0xf0,	0xd2,	0x63,	0xd9,	0xec,	0x26,	0xdd,	0x20,	0xde,	0x5f,	0x2c,	0xe7,	0xcf,	0x4b,	0xf4,	0x21,	0xeb,	0x00,	0x51,	0xd4,	0xff,	0x0e,	0xea,	0x0e,	0xc9,	0x0e,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x51,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd2,	0x64,	0xd9,	0xec,	0x27,	0xdd,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4b,	0xf4,	0x22,	0xeb,	0x00,	0x51,	0xd3,	0xff,	0x0e,	0xea,	0x0e,	0xc9,	0x0e,
	0xd9,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xde,	0x2c,	0xce,	0xff,	0xf0,	0xd1,	0x64,	0xd9,	0xec,	0x27,	0xdc,	0x20,	0xde,	0x60,	0x2c,	0xe7,	0xce,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x0e,	0xea,	0x0e,	0xc8,	0x0e,
	0xd8,	0x27,	0x20,	0xf4,	0xeb,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xec,	0x27,	0xdc,	0x20,	0xdd,	0x60,	0x2c,	0xe7,	0xcd,	0x4c,	0xf4,	0x22,	0xeb,	0x00,	0x52,	0xd3,	0xff,	0x0e,	0xea,	0x0e,	0xc7,	0x0e,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x52,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xd0,	0x65,	0xd8,	0xeb,	0x27,	0xdc,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4c,	0xf4,	0x22,	0xea,	0x00,	0x52,	0xd2,	0xff,	0x0e,	0xe9,	0x0e,	0xc7,	0x0e,
	0xd8,	0x27,	0x20,	0xf4,	0xea,	0x53,	0xdd,	0x2c,	0xcd,	0xff,	0xef,	0xcf,	0x65,	0xd8,	0xeb,	0x27,	0xdb,	0x20,	0xdd,	0x61,	0x2c,	0xe6,	0xcd,	0x4d,	0xf4,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x0e,	0xe9,	0x0e,	0xc6,	0x0e,
	0xd8,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdd,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd8,	0xeb,	0x27,	0xdb,	0x21,	0xdd,	0x61,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd2,	0xff,	0x0e,	0xe9,	0x0e,	0xc5,	0x0e,
	0xd7,	0x27,	0x21,	0xf3,	0xea,	0x53,	0xdc,	0x2d,	0xcc,	0xff,	0xef,	0xce,	0x66,	0xd7,	0xeb,	0x27,	0xdb,	0x21,	0xdc,	0x62,	0x2d,	0xe6,	0xcc,	0x4d,	0xf3,	0x22,	0xea,	0x00,	0x53,	0xd1,	0xff,	0x0e,	0xe8,	0x0e,	0xc4,	0x0e,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x0e,	0xe8,	0x0e,	0xc4,	0x0e,
	0xd7,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdc,	0x2d,	0xcb,	0xff,	0xee,	0xcd,	0x67,	0xd7,	0xea,	0x28,	0xda,	0x21,	0xdc,	0x62,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd1,	0xff,	0x0e,	0xe8,	0x0e,	0xc3,	0x0e,
	0xd6,	0x28,	0x21,	0xf3,	0xe9,	0x54,	0xdb,	0x2d,	0xcb,	0xff,	0xee,	0xcc,	0x67,	0xd6,	0xea,	0x28,	0xda,	0x21,	0xdb,	0x63,	0x2d,	0xe5,	0xcb,	0x4e,	0xf3,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x0e,	0xe7,	0x0e,	0xc2,	0x0e,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x54,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xda,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4e,	0xf2,	0x23,	0xe9,	0x00,	0x54,	0xd0,	0xff,	0x0e,	0xe7,	0x0e,	0xc1,	0x0e,
	0xd6,	0x28,	0x22,	0xf2,	0xe9,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xee,	0xcb,	0x68,	0xd6,	0xea,	0x28,	0xd9,	0x22,	0xdb,	0x63,	0x2e,	0xe5,	0xca,	0x4f,	0xf2,	0x23,	0xe9,	0x00,	0x55,	0xd0,	0xff,	0x0e,	0xe7,	0x0e,	0xc1,	0x0e,
	0xd6,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xdb,	0x2e,	0xca,	0xff,	0xed,	0xca,	0x68,	0xd6,	0xe9,	0x28,	0xd9,	0x22,	0xdb,	0x64,	0x2e,	0xe4,	0xca,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x0e,	0xe6,	0x0e,	0xc0,	0x0e,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x55,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd9,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x4f,	0xf2,	0x23,	0xe8,	0x00,	0x55,	0xcf,	0xff,	0x0e,	0xe6,	0x0e,	0xbf,	0x0e,
	0xd5,	0x28,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc9,	0xff,	0xed,	0xc9,	0x69,	0xd5,	0xe9,	0x28,	0xd8,	0x22,	0xda,	0x64,	0x2e,	0xe4,	0xc9,	0x50,	0xf2,	0x23,	0xe8,	0x00,	0x56,	0xcf,	0xff,	0x0e,	0xe6,	0x0e,	0xbe,	0x0e,
	0xd5,	0x29,	0x22,	0xf2,	0xe8,	0x56,	0xda,	0x2e,	0xc8,	0xff,	0xed,	0xc8,	0x6a,	0xd5,	0xe9,	0x29,	0xd8,	0x22,	0xda,	0x65,	0x2e,	0xe4,	0xc8,	0x50,	0xf2,	0x24,	0xe8,	0x00,	0x56,	0xce,	0xff,	0x0e,	0xe5,	0x0e,	0xbd,	0x0e,
	0xd5,	0x29,	0x23,	0xf1,	0xe7,	0x56,	0xda,	0x2f,	0xc8,	0xff,	0xec,	0xc7,	0x6a,	0xd5,	0xe8,	0x29,	0xd8,	0x23,	0xda,	0x65,	0x2f,	0xe3,	0xc8,	0x50,	0xf1,	0x24,	0xe7,	0x00,	0x56,	0xce,	0xff,	0x0e,	0xe5,	0x0e,	0xbd,	0x0e,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc7,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x0e,	0xe5,	0x0e,	0xbc,	0x0e,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xec,	0xc6,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x0e,	0xe4,	0x0e,	0xbb,	0x0e,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc7,	0xff,	0xeb,	0xc5,	0x6b,	0xd4,	0xe8,	0x29,	0xd7,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc7,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcd,	0xff,	0x10,	0xe4,	0x10,	0xba,	0x10,
	0xd4,	0x29,	0x23,	0xf1,	0xe7,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc4,	0x6b,	0xd4,	0xe8,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe3,	0xc6,	0x51,	0xf1,	0x24,	0xe7,	0x00,	0x57,	0xcc,	0xff,	0x10,	0xe4,	0x10,	0xba,	0x10,
	0xd4,	0x29,	0x23,	0xf1,	0xe6,	0x57,	0xd9,	0x2f,	0xc6,	0xff,	0xeb,	0xc3,	0x6b,	0xd4,	0xe7,	0x29,	0xd6,	0x23,	0xd9,	0x66,	0x2f,	0xe2,	0xc6,	0x51,	0xf1,	0x24,	0xe6,	0x00,	0x57,	0xcc,	0xff,	0x10,	0xe3,	0x10,	0xb9,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xeb,	0xc3,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x10,	0xe3,	0x10,	0xb8,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x57,	0xd8,	0x2f,	0xc5,	0xff,	0xea,	0xc2,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2f,	0xe2,	0xc5,	0x51,	0xf0,	0x24,	0xe6,	0x00,	0x57,	0xcb,	0xff,	0x10,	0xe3,	0x10,	0xb7,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc5,	0xff,	0xea,	0xc1,	0x6a,	0xd3,	0xe7,	0x29,	0xd5,	0x23,	0xd8,	0x65,	0x2e,	0xe2,	0xc5,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xcb,	0xff,	0x10,	0xe2,	0x10,	0xb6,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xc0,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x10,	0xe2,	0x10,	0xb5,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe6,	0x56,	0xd8,	0x2e,	0xc4,	0xff,	0xea,	0xbf,	0x6a,	0xd3,	0xe6,	0x29,	0xd4,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc4,	0x50,	0xf0,	0x24,	0xe6,	0x00,	0x56,	0xca,	0xff,	0x10,	0xe1,	0x10,	0xb4,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbe,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe1,	0x10,	0xb3,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe0,	0x10,	0xb2,	0x10,
	0xd3,	0x29,	0x23,	0xf0,	0xe5,	0x56,	0xd8,	0x2e,	0xc3,	0xff,	0xe9,	0xbd,	0x6a,	0xd3,	0xe6,	0x29,	0xd3,	0x23,	0xd8,	0x65,	0x2e,	0xe1,	0xc3,	0x50,	0xf0,	0x24,	0xe5,	0x00,	0x56,	0xc9,	0xff,	0x10,	0xe0,	0x10,	0xb1,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbc,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x10,	0xdf,	0x10,	0xb0,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe5,	0x56,	0xd7,	0x2e,	0xc2,	0xff,	0xe8,	0xbb,	0x69,	0xd2,	0xe5,	0x28,	0xd2,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc2,	0x50,	0xef,	0x23,	0xe5,	0x00,	0x56,	0xc8,	0xff,	0x10,	0xdf,	0x10,	0xb0,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xba,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x10,	0xdf,	0x10,	0xaf,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe8,	0xb9,	0x69,	0xd2,	0xe5,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xe0,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x10,	0xde,	0x10,	0xae,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x56,	0xd7,	0x2e,	0xc1,	0xff,	0xe7,	0xb8,	0x69,	0xd2,	0xe4,	0x28,	0xd1,	0x22,	0xd7,	0x64,	0x2e,	0xdf,	0xc1,	0x50,	0xef,	0x23,	0xe4,	0x00,	0x56,	0xc7,	0xff,	0x10,	0xde,	0x10,	0xad,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb7,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x10,	0xdd,	0x10,	0xac,	0x10,
	0xd2,	0x28,	0x22,	0xef,	0xe4,	0x55,	0xd7,	0x2d,	0xc0,	0xff,	0xe7,	0xb6,	0x69,	0xd2,	0xe4,	0x28,	0xd0,	0x22,	0xd7,	0x64,	0x2d,	0xdf,	0xc0,	0x4f,	0xef,	0x23,	0xe4,	0x00,	0x55,	0xc6,	0xff,	0x10,	0xdd,	0x10,	0xab,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe4,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe7,	0xb6,	0x68,	0xd1,	0xe4,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xdf,	0xbf,	0x4f,	0xee,	0x23,	0xe4,	0x00,	0x55,	0xc5,	0xff,	0x10,	0xdc,	0x10,	0xaa,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbf,	0xff,	0xe6,	0xb5,	0x68,	0xd1,	0xe3,	0x28,	0xcf,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbf,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc5,	0xff,	0x10,	0xdc,	0x10,	0xa9,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb4,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x10,	0xdb,	0x10,	0xa8,	0x10,
	0xd1,	0x28,	0x22,	0xee,	0xe3,	0x55,	0xd6,	0x2d,	0xbe,	0xff,	0xe6,	0xb3,	0x68,	0xd1,	0xe3,	0x28,	0xce,	0x22,	0xd6,	0x63,	0x2d,	0xde,	0xbe,	0x4f,	0xee,	0x23,	0xe3,	0x00,	0x55,	0xc4,	0xff,	0x10,	0xdb,	0x10,	0xa7,	0x10, /* 4000K */
};

static char color_lens_data[] = {
	//Blue
	0xcc,	0x00,	0x33,	0xcc,	0xcc,	0x33,	0xcc,	0x00,	0xff,	0xcc,	0xcc,	0xff,	0x00,	0xcc,	0xcc,	0x00,	0xff,	0x33,	0xcc,	0x00,	0x00,	0xcc,	0xff,	0x33,	0xcc,	0x00,	0xcc,	0x00,	0x33,	0xff,	0xcc,	0x00,	0xcc,	0x00,	0xff,	0x33,	/*	20%	*/
	0xbf,	0x00,	0x40,	0xbf,	0xbf,	0x40,	0xbf,	0x00,	0xff,	0xbf,	0xbf,	0xff,	0x00,	0xbf,	0xbf,	0x00,	0xff,	0x40,	0xbf,	0x00,	0x00,	0xbf,	0xff,	0x40,	0xbf,	0x00,	0xbf,	0x00,	0x40,	0xff,	0xbf,	0x00,	0xbf,	0x00,	0xff,	0x40,	/*	25%	*/
	0xb2,	0x00,	0x4d,	0xb2,	0xb2,	0x4d,	0xb2,	0x00,	0xff,	0xb2,	0xb2,	0xff,	0x00,	0xb2,	0xb2,	0x00,	0xff,	0x4d,	0xb2,	0x00,	0x00,	0xb2,	0xff,	0x4d,	0xb2,	0x00,	0xb2,	0x00,	0x4d,	0xff,	0xb2,	0x00,	0xb2,	0x00,	0xff,	0x4d,	/*	30%	*/
	0xa6,	0x00,	0x59,	0xa6,	0xa6,	0x59,	0xa6,	0x00,	0xff,	0xa6,	0xa6,	0xff,	0x00,	0xa6,	0xa6,	0x00,	0xff,	0x59,	0xa6,	0x00,	0x00,	0xa6,	0xff,	0x59,	0xa6,	0x00,	0xa6,	0x00,	0x59,	0xff,	0xa6,	0x00,	0xa6,	0x00,	0xff,	0x59,	/*	35%	*/
	0x99,	0x00,	0x66,	0x99,	0x99,	0x66,	0x99,	0x00,	0xff,	0x99,	0x99,	0xff,	0x00,	0x99,	0x99,	0x00,	0xff,	0x66,	0x99,	0x00,	0x00,	0x99,	0xff,	0x66,	0x99,	0x00,	0x99,	0x00,	0x66,	0xff,	0x99,	0x00,	0x99,	0x00,	0xff,	0x66,	/*	40%	*/
	0x8c,	0x00,	0x73,	0x8c,	0x8c,	0x73,	0x8c,	0x00,	0xff,	0x8c,	0x8c,	0xff,	0x00,	0x8c,	0x8c,	0x00,	0xff,	0x73,	0x8c,	0x00,	0x00,	0x8c,	0xff,	0x73,	0x8c,	0x00,	0x8c,	0x00,	0x73,	0xff,	0x8c,	0x00,	0x8c,	0x00,	0xff,	0x73,	/*	45%	*/
	0x7f,	0x00,	0x80,	0x7f,	0x7f,	0x80,	0x7f,	0x00,	0xff,	0x7f,	0x7f,	0xff,	0x00,	0x7f,	0x7f,	0x00,	0xff,	0x80,	0x7f,	0x00,	0x00,	0x7f,	0xff,	0x80,	0x7f,	0x00,	0x7f,	0x00,	0x80,	0xff,	0x7f,	0x00,	0x7f,	0x00,	0xff,	0x80,	/*	50%	*/
	0x73,	0x00,	0x8c,	0x73,	0x73,	0x8c,	0x73,	0x00,	0xff,	0x73,	0x73,	0xff,	0x00,	0x73,	0x73,	0x00,	0xff,	0x8c,	0x73,	0x00,	0x00,	0x73,	0xff,	0x8c,	0x73,	0x00,	0x73,	0x00,	0x8c,	0xff,	0x73,	0x00,	0x73,	0x00,	0xff,	0x8c,	/*	55%	*/
	0x66,	0x00,	0x99,	0x66,	0x66,	0x99,	0x66,	0x00,	0xff,	0x66,	0x66,	0xff,	0x00,	0x66,	0x66,	0x00,	0xff,	0x99,	0x66,	0x00,	0x00,	0x66,	0xff,	0x99,	0x66,	0x00,	0x66,	0x00,	0x99,	0xff,	0x66,	0x00,	0x66,	0x00,	0xff,	0x99,	/*	60%	*/

	//Azure
	0xcc,	0x19,	0x33,	0xcc,	0xe5,	0x33,	0xcc,	0x19,	0xff,	0xcc,	0xe5,	0xff,	0x00,	0xcc,	0xe5,	0x19,	0xff,	0x33,	0xcc,	0x00,	0x19,	0xe5,	0xff,	0x33,	0xcc,	0x00,	0xe5,	0x19,	0x33,	0xff,	0xcc,	0x00,	0xe5,	0x19,	0xff,	0x33,	/*	20%	*/
	0xbf,	0x20,	0x40,	0xbf,	0xdf,	0x40,	0xbf,	0x20,	0xff,	0xbf,	0xdf,	0xff,	0x00,	0xbf,	0xdf,	0x20,	0xff,	0x40,	0xbf,	0x00,	0x20,	0xdf,	0xff,	0x40,	0xbf,	0x00,	0xdf,	0x20,	0x40,	0xff,	0xbf,	0x00,	0xdf,	0x20,	0xff,	0x40,	/*	25%	*/
	0xb2,	0x26,	0x4d,	0xb2,	0xd8,	0x4d,	0xb2,	0x26,	0xff,	0xb2,	0xd8,	0xff,	0x00,	0xb2,	0xd8,	0x26,	0xff,	0x4d,	0xb2,	0x00,	0x26,	0xd8,	0xff,	0x4d,	0xb2,	0x00,	0xd8,	0x26,	0x4d,	0xff,	0xb2,	0x00,	0xd8,	0x26,	0xff,	0x4d,	/*	30%	*/
	0xa6,	0x2c,	0x59,	0xa6,	0xd2,	0x59,	0xa6,	0x2c,	0xff,	0xa6,	0xd2,	0xff,	0x00,	0xa6,	0xd2,	0x2c,	0xff,	0x59,	0xa6,	0x00,	0x2c,	0xd2,	0xff,	0x59,	0xa6,	0x00,	0xd2,	0x2c,	0x59,	0xff,	0xa6,	0x00,	0xd2,	0x2c,	0xff,	0x59,	/*	35%	*/
	0x99,	0x33,	0x66,	0x99,	0xcc,	0x66,	0x99,	0x33,	0xff,	0x99,	0xcc,	0xff,	0x00,	0x99,	0xcc,	0x33,	0xff,	0x66,	0x99,	0x00,	0x33,	0xcc,	0xff,	0x66,	0x99,	0x00,	0xcc,	0x33,	0x66,	0xff,	0x99,	0x00,	0xcc,	0x33,	0xff,	0x66,	/*	40%	*/
	0x8c,	0x39,	0x73,	0x8c,	0xc5,	0x73,	0x8c,	0x39,	0xff,	0x8c,	0xc5,	0xff,	0x00,	0x8c,	0xc5,	0x39,	0xff,	0x73,	0x8c,	0x00,	0x39,	0xc5,	0xff,	0x73,	0x8c,	0x00,	0xc5,	0x39,	0x73,	0xff,	0x8c,	0x00,	0xc5,	0x39,	0xff,	0x73,	/*	45%	*/
	0x7f,	0x40,	0x80,	0x7f,	0xbf,	0x80,	0x7f,	0x40,	0xff,	0x7f,	0xbf,	0xff,	0x00,	0x7f,	0xbf,	0x40,	0xff,	0x80,	0x7f,	0x00,	0x40,	0xbf,	0xff,	0x80,	0x7f,	0x00,	0xbf,	0x40,	0x80,	0xff,	0x7f,	0x00,	0xbf,	0x40,	0xff,	0x80,	/*	50%	*/
	0x73,	0x46,	0x8c,	0x73,	0xb9,	0x8c,	0x73,	0x46,	0xff,	0x73,	0xb9,	0xff,	0x00,	0x73,	0xb9,	0x46,	0xff,	0x8c,	0x73,	0x00,	0x46,	0xb9,	0xff,	0x8c,	0x73,	0x00,	0xb9,	0x46,	0x8c,	0xff,	0x73,	0x00,	0xb9,	0x46,	0xff,	0x8c,	/*	55%	*/
	0x66,	0x4c,	0x99,	0x66,	0xb2,	0x99,	0x66,	0x4c,	0xff,	0x66,	0xb2,	0xff,	0x00,	0x66,	0xb2,	0x4c,	0xff,	0x99,	0x66,	0x00,	0x4c,	0xb2,	0xff,	0x99,	0x66,	0x00,	0xb2,	0x4c,	0x99,	0xff,	0x66,	0x00,	0xb2,	0x4c,	0xff,	0x99,	/*	60%	*/

	//Cyan
	0xcc,	0x33,	0x33,	0xcc,	0xff,	0x33,	0xcc,	0x33,	0xff,	0xcc,	0xff,	0xff,	0x00,	0xcc,	0xff,	0x33,	0xff,	0x33,	0xcc,	0x00,	0x33,	0xff,	0xff,	0x33,	0xcc,	0x00,	0xff,	0x33,	0x33,	0xff,	0xcc,	0x00,	0xff,	0x33,	0xff,	0x33,	/*	20%	*/
	0xbf,	0x40,	0x40,	0xbf,	0xff,	0x40,	0xbf,	0x40,	0xff,	0xbf,	0xff,	0xff,	0x00,	0xbf,	0xff,	0x40,	0xff,	0x40,	0xbf,	0x00,	0x40,	0xff,	0xff,	0x40,	0xbf,	0x00,	0xff,	0x40,	0x40,	0xff,	0xbf,	0x00,	0xff,	0x40,	0xff,	0x40,	/*	25%	*/
	0xb2,	0x4d,	0x4d,	0xb2,	0xff,	0x4d,	0xb2,	0x4d,	0xff,	0xb2,	0xff,	0xff,	0x00,	0xb2,	0xff,	0x4d,	0xff,	0x4d,	0xb2,	0x00,	0x4d,	0xff,	0xff,	0x4d,	0xb2,	0x00,	0xff,	0x4d,	0x4d,	0xff,	0xb2,	0x00,	0xff,	0x4d,	0xff,	0x4d,	/*	30%	*/
	0xa6,	0x59,	0x59,	0xa6,	0xff,	0x59,	0xa6,	0x59,	0xff,	0xa6,	0xff,	0xff,	0x00,	0xa6,	0xff,	0x59,	0xff,	0x59,	0xa6,	0x00,	0x59,	0xff,	0xff,	0x59,	0xa6,	0x00,	0xff,	0x59,	0x59,	0xff,	0xa6,	0x00,	0xff,	0x59,	0xff,	0x59,	/*	35%	*/
	0x99,	0x66,	0x66,	0x99,	0xff,	0x66,	0x99,	0x66,	0xff,	0x99,	0xff,	0xff,	0x00,	0x99,	0xff,	0x66,	0xff,	0x66,	0x99,	0x00,	0x66,	0xff,	0xff,	0x66,	0x99,	0x00,	0xff,	0x66,	0x66,	0xff,	0x99,	0x00,	0xff,	0x66,	0xff,	0x66,	/*	40%	*/
	0x8c,	0x73,	0x73,	0x8c,	0xff,	0x73,	0x8c,	0x73,	0xff,	0x8c,	0xff,	0xff,	0x00,	0x8c,	0xff,	0x73,	0xff,	0x73,	0x8c,	0x00,	0x73,	0xff,	0xff,	0x73,	0x8c,	0x00,	0xff,	0x73,	0x73,	0xff,	0x8c,	0x00,	0xff,	0x73,	0xff,	0x73,	/*	45%	*/
	0x7f,	0x80,	0x80,	0x7f,	0xff,	0x80,	0x7f,	0x80,	0xff,	0x7f,	0xff,	0xff,	0x00,	0x7f,	0xff,	0x80,	0xff,	0x80,	0x7f,	0x00,	0x80,	0xff,	0xff,	0x80,	0x7f,	0x00,	0xff,	0x80,	0x80,	0xff,	0x7f,	0x00,	0xff,	0x80,	0xff,	0x80,	/*	50%	*/
	0x73,	0x8c,	0x8c,	0x73,	0xff,	0x8c,	0x73,	0x8c,	0xff,	0x73,	0xff,	0xff,	0x00,	0x73,	0xff,	0x8c,	0xff,	0x8c,	0x73,	0x00,	0x8c,	0xff,	0xff,	0x8c,	0x73,	0x00,	0xff,	0x8c,	0x8c,	0xff,	0x73,	0x00,	0xff,	0x8c,	0xff,	0x8c,	/*	55%	*/
	0x66,	0x99,	0x99,	0x66,	0xff,	0x99,	0x66,	0x99,	0xff,	0x66,	0xff,	0xff,	0x00,	0x66,	0xff,	0x99,	0xff,	0x99,	0x66,	0x00,	0x99,	0xff,	0xff,	0x99,	0x66,	0x00,	0xff,	0x99,	0x99,	0xff,	0x66,	0x00,	0xff,	0x99,	0xff,	0x99,	/*	60%	*/

	//Spring green
	0xcc,	0x33,	0x19,	0xcc,	0xff,	0x19,	0xcc,	0x33,	0xe5,	0xcc,	0xff,	0xe5,	0x00,	0xcc,	0xff,	0x33,	0xe5,	0x19,	0xcc,	0x00,	0x33,	0xff,	0xe5,	0x19,	0xcc,	0x00,	0xff,	0x33,	0x19,	0xe5,	0xcc,	0x00,	0xff,	0x33,	0xe5,	0x19,	/*	20%	*/
	0xbf,	0x40,	0x20,	0xbf,	0xff,	0x20,	0xbf,	0x40,	0xdf,	0xbf,	0xff,	0xdf,	0x00,	0xbf,	0xff,	0x40,	0xdf,	0x20,	0xbf,	0x00,	0x40,	0xff,	0xdf,	0x20,	0xbf,	0x00,	0xff,	0x40,	0x20,	0xdf,	0xbf,	0x00,	0xff,	0x40,	0xdf,	0x20,	/*	25%	*/
	0xb2,	0x4d,	0x26,	0xb2,	0xff,	0x26,	0xb2,	0x4d,	0xd8,	0xb2,	0xff,	0xd8,	0x00,	0xb2,	0xff,	0x4d,	0xd8,	0x26,	0xb2,	0x00,	0x4d,	0xff,	0xd8,	0x26,	0xb2,	0x00,	0xff,	0x4d,	0x26,	0xd8,	0xb2,	0x00,	0xff,	0x4d,	0xd8,	0x26,	/*	30%	*/
	0xa6,	0x59,	0x2c,	0xa6,	0xff,	0x2c,	0xa6,	0x59,	0xd2,	0xa6,	0xff,	0xd2,	0x00,	0xa6,	0xff,	0x59,	0xd2,	0x2c,	0xa6,	0x00,	0x59,	0xff,	0xd2,	0x2c,	0xa6,	0x00,	0xff,	0x59,	0x2c,	0xd2,	0xa6,	0x00,	0xff,	0x59,	0xd2,	0x2c,	/*	35%	*/
	0x99,	0x66,	0x33,	0x99,	0xff,	0x33,	0x99,	0x66,	0xcc,	0x99,	0xff,	0xcc,	0x00,	0x99,	0xff,	0x66,	0xcc,	0x33,	0x99,	0x00,	0x66,	0xff,	0xcc,	0x33,	0x99,	0x00,	0xff,	0x66,	0x33,	0xcc,	0x99,	0x00,	0xff,	0x66,	0xcc,	0x33,	/*	40%	*/
	0x8c,	0x73,	0x39,	0x8c,	0xff,	0x39,	0x8c,	0x73,	0xc5,	0x8c,	0xff,	0xc5,	0x00,	0x8c,	0xff,	0x73,	0xc5,	0x39,	0x8c,	0x00,	0x73,	0xff,	0xc5,	0x39,	0x8c,	0x00,	0xff,	0x73,	0x39,	0xc5,	0x8c,	0x00,	0xff,	0x73,	0xc5,	0x39,	/*	45%	*/
	0x7f,	0x80,	0x40,	0x7f,	0xff,	0x40,	0x7f,	0x80,	0xbf,	0x7f,	0xff,	0xbf,	0x00,	0x7f,	0xff,	0x80,	0xbf,	0x40,	0x7f,	0x00,	0x80,	0xff,	0xbf,	0x40,	0x7f,	0x00,	0xff,	0x80,	0x40,	0xbf,	0x7f,	0x00,	0xff,	0x80,	0xbf,	0x40,	/*	50%	*/
	0x73,	0x8c,	0x46,	0x73,	0xff,	0x46,	0x73,	0x8c,	0xb9,	0x73,	0xff,	0xb9,	0x00,	0x73,	0xff,	0x8c,	0xb9,	0x46,	0x73,	0x00,	0x8c,	0xff,	0xb9,	0x46,	0x73,	0x00,	0xff,	0x8c,	0x46,	0xb9,	0x73,	0x00,	0xff,	0x8c,	0xb9,	0x46,	/*	55%	*/
	0x66,	0x99,	0x4c,	0x66,	0xff,	0x4c,	0x66,	0x99,	0xb2,	0x66,	0xff,	0xb2,	0x00,	0x66,	0xff,	0x99,	0xb2,	0x4c,	0x66,	0x00,	0x99,	0xff,	0xb2,	0x4c,	0x66,	0x00,	0xff,	0x99,	0x4c,	0xb2,	0x66,	0x00,	0xff,	0x99,	0xb2,	0x4c,	/*	60%	*/

	//Green
	0xcc,	0x33,	0x00,	0xcc,	0xff,	0x00,	0xcc,	0x33,	0xcc,	0xcc,	0xff,	0xcc,	0x00,	0xcc,	0xff,	0x33,	0xcc,	0x00,	0xcc,	0x00,	0x33,	0xff,	0xcc,	0x00,	0xcc,	0x00,	0xff,	0x33,	0x00,	0xcc,	0xcc,	0x00,	0xff,	0x33,	0xcc,	0x00,	/*	20%	*/
	0xbf,	0x40,	0x00,	0xbf,	0xff,	0x00,	0xbf,	0x40,	0xbf,	0xbf,	0xff,	0xbf,	0x00,	0xbf,	0xff,	0x40,	0xbf,	0x00,	0xbf,	0x00,	0x40,	0xff,	0xbf,	0x00,	0xbf,	0x00,	0xff,	0x40,	0x00,	0xbf,	0xbf,	0x00,	0xff,	0x40,	0xbf,	0x00,	/*	25%	*/
	0xb2,	0x4d,	0x00,	0xb2,	0xff,	0x00,	0xb2,	0x4d,	0xb2,	0xb2,	0xff,	0xb2,	0x00,	0xb2,	0xff,	0x4d,	0xb2,	0x00,	0xb2,	0x00,	0x4d,	0xff,	0xb2,	0x00,	0xb2,	0x00,	0xff,	0x4d,	0x00,	0xb2,	0xb2,	0x00,	0xff,	0x4d,	0xb2,	0x00,	/*	30%	*/
	0xa6,	0x59,	0x00,	0xa6,	0xff,	0x00,	0xa6,	0x59,	0xa6,	0xa6,	0xff,	0xa6,	0x00,	0xa6,	0xff,	0x59,	0xa6,	0x00,	0xa6,	0x00,	0x59,	0xff,	0xa6,	0x00,	0xa6,	0x00,	0xff,	0x59,	0x00,	0xa6,	0xa6,	0x00,	0xff,	0x59,	0xa6,	0x00,	/*	35%	*/
	0x99,	0x66,	0x00,	0x99,	0xff,	0x00,	0x99,	0x66,	0x99,	0x99,	0xff,	0x99,	0x00,	0x99,	0xff,	0x66,	0x99,	0x00,	0x99,	0x00,	0x66,	0xff,	0x99,	0x00,	0x99,	0x00,	0xff,	0x66,	0x00,	0x99,	0x99,	0x00,	0xff,	0x66,	0x99,	0x00,	/*	40%	*/
	0x8c,	0x73,	0x00,	0x8c,	0xff,	0x00,	0x8c,	0x73,	0x8c,	0x8c,	0xff,	0x8c,	0x00,	0x8c,	0xff,	0x73,	0x8c,	0x00,	0x8c,	0x00,	0x73,	0xff,	0x8c,	0x00,	0x8c,	0x00,	0xff,	0x73,	0x00,	0x8c,	0x8c,	0x00,	0xff,	0x73,	0x8c,	0x00,	/*	45%	*/
	0x7f,	0x80,	0x00,	0x7f,	0xff,	0x00,	0x7f,	0x80,	0x7f,	0x7f,	0xff,	0x7f,	0x00,	0x7f,	0xff,	0x80,	0x7f,	0x00,	0x7f,	0x00,	0x80,	0xff,	0x7f,	0x00,	0x7f,	0x00,	0xff,	0x80,	0x00,	0x7f,	0x7f,	0x00,	0xff,	0x80,	0x7f,	0x00,	/*	50%	*/
	0x73,	0x8c,	0x00,	0x73,	0xff,	0x00,	0x73,	0x8c,	0x73,	0x73,	0xff,	0x73,	0x00,	0x73,	0xff,	0x8c,	0x73,	0x00,	0x73,	0x00,	0x8c,	0xff,	0x73,	0x00,	0x73,	0x00,	0xff,	0x8c,	0x00,	0x73,	0x73,	0x00,	0xff,	0x8c,	0x73,	0x00,	/*	55%	*/
	0x66,	0x99,	0x00,	0x66,	0xff,	0x00,	0x66,	0x99,	0x66,	0x66,	0xff,	0x66,	0x00,	0x66,	0xff,	0x99,	0x66,	0x00,	0x66,	0x00,	0x99,	0xff,	0x66,	0x00,	0x66,	0x00,	0xff,	0x99,	0x00,	0x66,	0x66,	0x00,	0xff,	0x99,	0x66,	0x00,	/*	60%	*/

	//Chartreuse Green
	0xe5,	0x33,	0x00,	0xe5,	0xff,	0x00,	0xe5,	0x33,	0xcc,	0xe5,	0xff,	0xcc,	0x19,	0xe5,	0xff,	0x33,	0xcc,	0x00,	0xe5,	0x19,	0x33,	0xff,	0xcc,	0x00,	0xe5,	0x19,	0xff,	0x33,	0x00,	0xcc,	0xe5,	0x19,	0xff,	0x33,	0xcc,	0x00,	/*	20%	*/
	0xdf,	0x40,	0x00,	0xdf,	0xff,	0x00,	0xdf,	0x40,	0xbf,	0xdf,	0xff,	0xbf,	0x20,	0xdf,	0xff,	0x40,	0xbf,	0x00,	0xdf,	0x20,	0x40,	0xff,	0xbf,	0x00,	0xdf,	0x20,	0xff,	0x40,	0x00,	0xbf,	0xdf,	0x20,	0xff,	0x40,	0xbf,	0x00,	/*	25%	*/
	0xd8,	0x4d,	0x00,	0xd8,	0xff,	0x00,	0xd8,	0x4d,	0xb2,	0xd8,	0xff,	0xb2,	0x26,	0xd8,	0xff,	0x4d,	0xb2,	0x00,	0xd8,	0x26,	0x4d,	0xff,	0xb2,	0x00,	0xd8,	0x26,	0xff,	0x4d,	0x00,	0xb2,	0xd8,	0x26,	0xff,	0x4d,	0xb2,	0x00,	/*	30%	*/
	0xd2,	0x59,	0x00,	0xd2,	0xff,	0x00,	0xd2,	0x59,	0xa6,	0xd2,	0xff,	0xa6,	0x2c,	0xd2,	0xff,	0x59,	0xa6,	0x00,	0xd2,	0x2c,	0x59,	0xff,	0xa6,	0x00,	0xd2,	0x2c,	0xff,	0x59,	0x00,	0xa6,	0xd2,	0x2c,	0xff,	0x59,	0xa6,	0x00,	/*	35%	*/
	0xcc,	0x66,	0x00,	0xcc,	0xff,	0x00,	0xcc,	0x66,	0x99,	0xcc,	0xff,	0x99,	0x33,	0xcc,	0xff,	0x66,	0x99,	0x00,	0xcc,	0x33,	0x66,	0xff,	0x99,	0x00,	0xcc,	0x33,	0xff,	0x66,	0x00,	0x99,	0xcc,	0x33,	0xff,	0x66,	0x99,	0x00,	/*	40%	*/
	0xc5,	0x73,	0x00,	0xc5,	0xff,	0x00,	0xc5,	0x73,	0x8c,	0xc5,	0xff,	0x8c,	0x39,	0xc5,	0xff,	0x73,	0x8c,	0x00,	0xc5,	0x39,	0x73,	0xff,	0x8c,	0x00,	0xc5,	0x39,	0xff,	0x73,	0x00,	0x8c,	0xc5,	0x39,	0xff,	0x73,	0x8c,	0x00,	/*	45%	*/
	0xbf,	0x80,	0x00,	0xbf,	0xff,	0x00,	0xbf,	0x80,	0x7f,	0xbf,	0xff,	0x7f,	0x40,	0xbf,	0xff,	0x80,	0x7f,	0x00,	0xbf,	0x40,	0x80,	0xff,	0x7f,	0x00,	0xbf,	0x40,	0xff,	0x80,	0x00,	0x7f,	0xbf,	0x40,	0xff,	0x80,	0x7f,	0x00,	/*	50%	*/
	0xb9,	0x8c,	0x00,	0xb9,	0xff,	0x00,	0xb9,	0x8c,	0x73,	0xb9,	0xff,	0x73,	0x46,	0xb9,	0xff,	0x8c,	0x73,	0x00,	0xb9,	0x46,	0x8c,	0xff,	0x73,	0x00,	0xb9,	0x46,	0xff,	0x8c,	0x00,	0x73,	0xb9,	0x46,	0xff,	0x8c,	0x73,	0x00,	/*	55%	*/
	0xb2,	0x99,	0x00,	0xb2,	0xff,	0x00,	0xb2,	0x99,	0x66,	0xb2,	0xff,	0x66,	0x4c,	0xb2,	0xff,	0x99,	0x66,	0x00,	0xb2,	0x4c,	0x99,	0xff,	0x66,	0x00,	0xb2,	0x4c,	0xff,	0x99,	0x00,	0x66,	0xb2,	0x4c,	0xff,	0x99,	0x66,	0x00,	/*	60%	*/

	//Yellow
	0xff,	0x33,	0x00,	0xff,	0xff,	0x00,	0xff,	0x33,	0xcc,	0xff,	0xff,	0xcc,	0x33,	0xff,	0xff,	0x33,	0xcc,	0x00,	0xff,	0x33,	0x33,	0xff,	0xcc,	0x00,	0xff,	0x33,	0xff,	0x33,	0x00,	0xcc,	0xff,	0x33,	0xff,	0x33,	0xcc,	0x00,	/*	20%	*/
	0xff,	0x40,	0x00,	0xff,	0xff,	0x00,	0xff,	0x40,	0xbf,	0xff,	0xff,	0xbf,	0x40,	0xff,	0xff,	0x40,	0xbf,	0x00,	0xff,	0x40,	0x40,	0xff,	0xbf,	0x00,	0xff,	0x40,	0xff,	0x40,	0x00,	0xbf,	0xff,	0x40,	0xff,	0x40,	0xbf,	0x00,	/*	25%	*/
	0xff,	0x4d,	0x00,	0xff,	0xff,	0x00,	0xff,	0x4d,	0xb2,	0xff,	0xff,	0xb2,	0x4d,	0xff,	0xff,	0x4d,	0xb2,	0x00,	0xff,	0x4d,	0x4d,	0xff,	0xb2,	0x00,	0xff,	0x4d,	0xff,	0x4d,	0x00,	0xb2,	0xff,	0x4d,	0xff,	0x4d,	0xb2,	0x00,	/*	30%	*/
	0xff,	0x59,	0x00,	0xff,	0xff,	0x00,	0xff,	0x59,	0xa6,	0xff,	0xff,	0xa6,	0x59,	0xff,	0xff,	0x59,	0xa6,	0x00,	0xff,	0x59,	0x59,	0xff,	0xa6,	0x00,	0xff,	0x59,	0xff,	0x59,	0x00,	0xa6,	0xff,	0x59,	0xff,	0x59,	0xa6,	0x00,	/*	35%	*/
	0xff,	0x66,	0x00,	0xff,	0xff,	0x00,	0xff,	0x66,	0x99,	0xff,	0xff,	0x99,	0x66,	0xff,	0xff,	0x66,	0x99,	0x00,	0xff,	0x66,	0x66,	0xff,	0x99,	0x00,	0xff,	0x66,	0xff,	0x66,	0x00,	0x99,	0xff,	0x66,	0xff,	0x66,	0x99,	0x00,	/*	40%	*/
	0xff,	0x73,	0x00,	0xff,	0xff,	0x00,	0xff,	0x73,	0x8c,	0xff,	0xff,	0x8c,	0x73,	0xff,	0xff,	0x73,	0x8c,	0x00,	0xff,	0x73,	0x73,	0xff,	0x8c,	0x00,	0xff,	0x73,	0xff,	0x73,	0x00,	0x8c,	0xff,	0x73,	0xff,	0x73,	0x8c,	0x00,	/*	45%	*/
	0xff,	0x80,	0x00,	0xff,	0xff,	0x00,	0xff,	0x80,	0x7f,	0xff,	0xff,	0x7f,	0x80,	0xff,	0xff,	0x80,	0x7f,	0x00,	0xff,	0x80,	0x80,	0xff,	0x7f,	0x00,	0xff,	0x80,	0xff,	0x80,	0x00,	0x7f,	0xff,	0x80,	0xff,	0x80,	0x7f,	0x00,	/*	50%	*/
	0xff,	0x8c,	0x00,	0xff,	0xff,	0x00,	0xff,	0x8c,	0x73,	0xff,	0xff,	0x73,	0x8c,	0xff,	0xff,	0x8c,	0x73,	0x00,	0xff,	0x8c,	0x8c,	0xff,	0x73,	0x00,	0xff,	0x8c,	0xff,	0x8c,	0x00,	0x73,	0xff,	0x8c,	0xff,	0x8c,	0x73,	0x00,	/*	55%	*/
	0xff,	0x99,	0x00,	0xff,	0xff,	0x00,	0xff,	0x99,	0x66,	0xff,	0xff,	0x66,	0x99,	0xff,	0xff,	0x99,	0x66,	0x00,	0xff,	0x99,	0x99,	0xff,	0x66,	0x00,	0xff,	0x99,	0xff,	0x99,	0x00,	0x66,	0xff,	0x99,	0xff,	0x99,	0x66,	0x00,	/*	60%	*/

	//Orange
	0xff,	0x19,	0x00,	0xff,	0xe5,	0x00,	0xff,	0x19,	0xcc,	0xff,	0xe5,	0xcc,	0x33,	0xff,	0xe5,	0x19,	0xcc,	0x00,	0xff,	0x33,	0x19,	0xe5,	0xcc,	0x00,	0xff,	0x33,	0xe5,	0x19,	0x00,	0xcc,	0xff,	0x33,	0xe5,	0x19,	0xcc,	0x00,	/*	20%	*/
	0xff,	0x20,	0x00,	0xff,	0xdf,	0x00,	0xff,	0x20,	0xbf,	0xff,	0xdf,	0xbf,	0x40,	0xff,	0xdf,	0x20,	0xbf,	0x00,	0xff,	0x40,	0x20,	0xdf,	0xbf,	0x00,	0xff,	0x40,	0xdf,	0x20,	0x00,	0xbf,	0xff,	0x40,	0xdf,	0x20,	0xbf,	0x00,	/*	25%	*/
	0xff,	0x26,	0x00,	0xff,	0xd8,	0x00,	0xff,	0x26,	0xb2,	0xff,	0xd8,	0xb2,	0x4d,	0xff,	0xd8,	0x26,	0xb2,	0x00,	0xff,	0x4d,	0x26,	0xd8,	0xb2,	0x00,	0xff,	0x4d,	0xd8,	0x26,	0x00,	0xb2,	0xff,	0x4d,	0xd8,	0x26,	0xb2,	0x00,	/*	30%	*/
	0xff,	0x2c,	0x00,	0xff,	0xd2,	0x00,	0xff,	0x2c,	0xa6,	0xff,	0xd2,	0xa6,	0x59,	0xff,	0xd2,	0x2c,	0xa6,	0x00,	0xff,	0x59,	0x2c,	0xd2,	0xa6,	0x00,	0xff,	0x59,	0xd2,	0x2c,	0x00,	0xa6,	0xff,	0x59,	0xd2,	0x2c,	0xa6,	0x00,	/*	35%	*/
	0xff,	0x33,	0x00,	0xff,	0xcc,	0x00,	0xff,	0x33,	0x99,	0xff,	0xcc,	0x99,	0x66,	0xff,	0xcc,	0x33,	0x99,	0x00,	0xff,	0x66,	0x33,	0xcc,	0x99,	0x00,	0xff,	0x66,	0xcc,	0x33,	0x00,	0x99,	0xff,	0x66,	0xcc,	0x33,	0x99,	0x00,	/*	40%	*/
	0xff,	0x39,	0x00,	0xff,	0xc5,	0x00,	0xff,	0x39,	0x8c,	0xff,	0xc5,	0x8c,	0x73,	0xff,	0xc5,	0x39,	0x8c,	0x00,	0xff,	0x73,	0x39,	0xc5,	0x8c,	0x00,	0xff,	0x73,	0xc5,	0x39,	0x00,	0x8c,	0xff,	0x73,	0xc5,	0x39,	0x8c,	0x00,	/*	45%	*/
	0xff,	0x40,	0x00,	0xff,	0xbf,	0x00,	0xff,	0x40,	0x7f,	0xff,	0xbf,	0x7f,	0x80,	0xff,	0xbf,	0x40,	0x7f,	0x00,	0xff,	0x80,	0x40,	0xbf,	0x7f,	0x00,	0xff,	0x80,	0xbf,	0x40,	0x00,	0x7f,	0xff,	0x80,	0xbf,	0x40,	0x7f,	0x00,	/*	50%	*/
	0xff,	0x46,	0x00,	0xff,	0xb9,	0x00,	0xff,	0x46,	0x73,	0xff,	0xb9,	0x73,	0x8c,	0xff,	0xb9,	0x46,	0x73,	0x00,	0xff,	0x8c,	0x46,	0xb9,	0x73,	0x00,	0xff,	0x8c,	0xb9,	0x46,	0x00,	0x73,	0xff,	0x8c,	0xb9,	0x46,	0x73,	0x00,	/*	55%	*/
	0xff,	0x4c,	0x00,	0xff,	0xb2,	0x00,	0xff,	0x4c,	0x66,	0xff,	0xb2,	0x66,	0x99,	0xff,	0xb2,	0x4c,	0x66,	0x00,	0xff,	0x99,	0x4c,	0xb2,	0x66,	0x00,	0xff,	0x99,	0xb2,	0x4c,	0x00,	0x66,	0xff,	0x99,	0xb2,	0x4c,	0x66,	0x00,	/*	60%	*/

	//Red
	0xff,	0x00,	0x00,	0xff,	0xcc,	0x00,	0xff,	0x00,	0xcc,	0xff,	0xcc,	0xcc,	0x33,	0xff,	0xcc,	0x00,	0xcc,	0x00,	0xff,	0x33,	0x00,	0xcc,	0xcc,	0x00,	0xff,	0x33,	0xcc,	0x00,	0x00,	0xcc,	0xff,	0x33,	0xcc,	0x00,	0xcc,	0x00,	/*	20%	*/
	0xff,	0x00,	0x00,	0xff,	0xbf,	0x00,	0xff,	0x00,	0xbf,	0xff,	0xbf,	0xbf,	0x40,	0xff,	0xbf,	0x00,	0xbf,	0x00,	0xff,	0x40,	0x00,	0xbf,	0xbf,	0x00,	0xff,	0x40,	0xbf,	0x00,	0x00,	0xbf,	0xff,	0x40,	0xbf,	0x00,	0xbf,	0x00,	/*	25%	*/
	0xff,	0x00,	0x00,	0xff,	0xb2,	0x00,	0xff,	0x00,	0xb2,	0xff,	0xb2,	0xb2,	0x4d,	0xff,	0xb2,	0x00,	0xb2,	0x00,	0xff,	0x4d,	0x00,	0xb2,	0xb2,	0x00,	0xff,	0x4d,	0xb2,	0x00,	0x00,	0xb2,	0xff,	0x4d,	0xb2,	0x00,	0xb2,	0x00,	/*	30%	*/
	0xff,	0x00,	0x00,	0xff,	0xa6,	0x00,	0xff,	0x00,	0xa6,	0xff,	0xa6,	0xa6,	0x59,	0xff,	0xa6,	0x00,	0xa6,	0x00,	0xff,	0x59,	0x00,	0xa6,	0xa6,	0x00,	0xff,	0x59,	0xa6,	0x00,	0x00,	0xa6,	0xff,	0x59,	0xa6,	0x00,	0xa6,	0x00,	/*	35%	*/
	0xff,	0x00,	0x00,	0xff,	0x99,	0x00,	0xff,	0x00,	0x99,	0xff,	0x99,	0x99,	0x66,	0xff,	0x99,	0x00,	0x99,	0x00,	0xff,	0x66,	0x00,	0x99,	0x99,	0x00,	0xff,	0x66,	0x99,	0x00,	0x00,	0x99,	0xff,	0x66,	0x99,	0x00,	0x99,	0x00,	/*	40%	*/
	0xff,	0x00,	0x00,	0xff,	0x8c,	0x00,	0xff,	0x00,	0x8c,	0xff,	0x8c,	0x8c,	0x73,	0xff,	0x8c,	0x00,	0x8c,	0x00,	0xff,	0x73,	0x00,	0x8c,	0x8c,	0x00,	0xff,	0x73,	0x8c,	0x00,	0x00,	0x8c,	0xff,	0x73,	0x8c,	0x00,	0x8c,	0x00,	/*	45%	*/
	0xff,	0x00,	0x00,	0xff,	0x7f,	0x00,	0xff,	0x00,	0x7f,	0xff,	0x7f,	0x7f,	0x80,	0xff,	0x7f,	0x00,	0x7f,	0x00,	0xff,	0x80,	0x00,	0x7f,	0x7f,	0x00,	0xff,	0x80,	0x7f,	0x00,	0x00,	0x7f,	0xff,	0x80,	0x7f,	0x00,	0x7f,	0x00,	/*	50%	*/
	0xff,	0x00,	0x00,	0xff,	0x73,	0x00,	0xff,	0x00,	0x73,	0xff,	0x73,	0x73,	0x8c,	0xff,	0x73,	0x00,	0x73,	0x00,	0xff,	0x8c,	0x00,	0x73,	0x73,	0x00,	0xff,	0x8c,	0x73,	0x00,	0x00,	0x73,	0xff,	0x8c,	0x73,	0x00,	0x73,	0x00,	/*	55%	*/
	0xff,	0x00,	0x00,	0xff,	0x66,	0x00,	0xff,	0x00,	0x66,	0xff,	0x66,	0x66,	0x99,	0xff,	0x66,	0x00,	0x66,	0x00,	0xff,	0x99,	0x00,	0x66,	0x66,	0x00,	0xff,	0x99,	0x66,	0x00,	0x00,	0x66,	0xff,	0x99,	0x66,	0x00,	0x66,	0x00,	/*	60%	*/

	//Rose
	0xff,	0x00,	0x19,	0xff,	0xcc,	0x19,	0xff,	0x00,	0xe5,	0xff,	0xcc,	0xe5,	0x33,	0xff,	0xcc,	0x00,	0xe5,	0x19,	0xff,	0x33,	0x00,	0xcc,	0xe5,	0x19,	0xff,	0x33,	0xcc,	0x00,	0x19,	0xe5,	0xff,	0x33,	0xcc,	0x00,	0xe5,	0x19,	/*	20%	*/
	0xff,	0x00,	0x20,	0xff,	0xbf,	0x20,	0xff,	0x00,	0xdf,	0xff,	0xbf,	0xdf,	0x40,	0xff,	0xbf,	0x00,	0xdf,	0x20,	0xff,	0x40,	0x00,	0xbf,	0xdf,	0x20,	0xff,	0x40,	0xbf,	0x00,	0x20,	0xdf,	0xff,	0x40,	0xbf,	0x00,	0xdf,	0x20,	/*	25%	*/
	0xff,	0x00,	0x26,	0xff,	0xb2,	0x26,	0xff,	0x00,	0xd8,	0xff,	0xb2,	0xd8,	0x4d,	0xff,	0xb2,	0x00,	0xd8,	0x26,	0xff,	0x4d,	0x00,	0xb2,	0xd8,	0x26,	0xff,	0x4d,	0xb2,	0x00,	0x26,	0xd8,	0xff,	0x4d,	0xb2,	0x00,	0xd8,	0x26,	/*	30%	*/
	0xff,	0x00,	0x2c,	0xff,	0xa6,	0x2c,	0xff,	0x00,	0xd2,	0xff,	0xa6,	0xd2,	0x59,	0xff,	0xa6,	0x00,	0xd2,	0x2c,	0xff,	0x59,	0x00,	0xa6,	0xd2,	0x2c,	0xff,	0x59,	0xa6,	0x00,	0x2c,	0xd2,	0xff,	0x59,	0xa6,	0x00,	0xd2,	0x2c,	/*	35%	*/
	0xff,	0x00,	0x33,	0xff,	0x99,	0x33,	0xff,	0x00,	0xcc,	0xff,	0x99,	0xcc,	0x66,	0xff,	0x99,	0x00,	0xcc,	0x33,	0xff,	0x66,	0x00,	0x99,	0xcc,	0x33,	0xff,	0x66,	0x99,	0x00,	0x33,	0xcc,	0xff,	0x66,	0x99,	0x00,	0xcc,	0x33,	/*	40%	*/
	0xff,	0x00,	0x39,	0xff,	0x8c,	0x39,	0xff,	0x00,	0xc5,	0xff,	0x8c,	0xc5,	0x73,	0xff,	0x8c,	0x00,	0xc5,	0x39,	0xff,	0x73,	0x00,	0x8c,	0xc5,	0x39,	0xff,	0x73,	0x8c,	0x00,	0x39,	0xc5,	0xff,	0x73,	0x8c,	0x00,	0xc5,	0x39,	/*	45%	*/
	0xff,	0x00,	0x40,	0xff,	0x7f,	0x40,	0xff,	0x00,	0xbf,	0xff,	0x7f,	0xbf,	0x80,	0xff,	0x7f,	0x00,	0xbf,	0x40,	0xff,	0x80,	0x00,	0x7f,	0xbf,	0x40,	0xff,	0x80,	0x7f,	0x00,	0x40,	0xbf,	0xff,	0x80,	0x7f,	0x00,	0xbf,	0x40,	/*	50%	*/
	0xff,	0x00,	0x46,	0xff,	0x73,	0x46,	0xff,	0x00,	0xb9,	0xff,	0x73,	0xb9,	0x8c,	0xff,	0x73,	0x00,	0xb9,	0x46,	0xff,	0x8c,	0x00,	0x73,	0xb9,	0x46,	0xff,	0x8c,	0x73,	0x00,	0x46,	0xb9,	0xff,	0x8c,	0x73,	0x00,	0xb9,	0x46,	/*	55%	*/
	0xff,	0x00,	0x4c,	0xff,	0x66,	0x4c,	0xff,	0x00,	0xb2,	0xff,	0x66,	0xb2,	0x99,	0xff,	0x66,	0x00,	0xb2,	0x4c,	0xff,	0x99,	0x00,	0x66,	0xb2,	0x4c,	0xff,	0x99,	0x66,	0x00,	0x4c,	0xb2,	0xff,	0x99,	0x66,	0x00,	0xb2,	0x4c,	/*	60%	*/

	//Magenta
	0xff,	0x00,	0x33,	0xff,	0xcc,	0x33,	0xff,	0x00,	0xff,	0xff,	0xcc,	0xff,	0x33,	0xff,	0xcc,	0x00,	0xff,	0x33,	0xff,	0x33,	0x00,	0xcc,	0xff,	0x33,	0xff,	0x33,	0xcc,	0x00,	0x33,	0xff,	0xff,	0x33,	0xcc,	0x00,	0xff,	0x33,	/*	20%	*/
	0xff,	0x00,	0x40,	0xff,	0xbf,	0x40,	0xff,	0x00,	0xff,	0xff,	0xbf,	0xff,	0x40,	0xff,	0xbf,	0x00,	0xff,	0x40,	0xff,	0x40,	0x00,	0xbf,	0xff,	0x40,	0xff,	0x40,	0xbf,	0x00,	0x40,	0xff,	0xff,	0x40,	0xbf,	0x00,	0xff,	0x40,	/*	25%	*/
	0xff,	0x00,	0x4d,	0xff,	0xb2,	0x4d,	0xff,	0x00,	0xff,	0xff,	0xb2,	0xff,	0x4d,	0xff,	0xb2,	0x00,	0xff,	0x4d,	0xff,	0x4d,	0x00,	0xb2,	0xff,	0x4d,	0xff,	0x4d,	0xb2,	0x00,	0x4d,	0xff,	0xff,	0x4d,	0xb2,	0x00,	0xff,	0x4d,	/*	30%	*/
	0xff,	0x00,	0x59,	0xff,	0xa6,	0x59,	0xff,	0x00,	0xff,	0xff,	0xa6,	0xff,	0x59,	0xff,	0xa6,	0x00,	0xff,	0x59,	0xff,	0x59,	0x00,	0xa6,	0xff,	0x59,	0xff,	0x59,	0xa6,	0x00,	0x59,	0xff,	0xff,	0x59,	0xa6,	0x00,	0xff,	0x59,	/*	35%	*/
	0xff,	0x00,	0x66,	0xff,	0x99,	0x66,	0xff,	0x00,	0xff,	0xff,	0x99,	0xff,	0x66,	0xff,	0x99,	0x00,	0xff,	0x66,	0xff,	0x66,	0x00,	0x99,	0xff,	0x66,	0xff,	0x66,	0x99,	0x00,	0x66,	0xff,	0xff,	0x66,	0x99,	0x00,	0xff,	0x66,	/*	40%	*/
	0xff,	0x00,	0x73,	0xff,	0x8c,	0x73,	0xff,	0x00,	0xff,	0xff,	0x8c,	0xff,	0x73,	0xff,	0x8c,	0x00,	0xff,	0x73,	0xff,	0x73,	0x00,	0x8c,	0xff,	0x73,	0xff,	0x73,	0x8c,	0x00,	0x73,	0xff,	0xff,	0x73,	0x8c,	0x00,	0xff,	0x73,	/*	45%	*/
	0xff,	0x00,	0x80,	0xff,	0x7f,	0x80,	0xff,	0x00,	0xff,	0xff,	0x7f,	0xff,	0x80,	0xff,	0x7f,	0x00,	0xff,	0x80,	0xff,	0x80,	0x00,	0x7f,	0xff,	0x80,	0xff,	0x80,	0x7f,	0x00,	0x80,	0xff,	0xff,	0x80,	0x7f,	0x00,	0xff,	0x80,	/*	50%	*/
	0xff,	0x00,	0x8c,	0xff,	0x73,	0x8c,	0xff,	0x00,	0xff,	0xff,	0x73,	0xff,	0x8c,	0xff,	0x73,	0x00,	0xff,	0x8c,	0xff,	0x8c,	0x00,	0x73,	0xff,	0x8c,	0xff,	0x8c,	0x73,	0x00,	0x8c,	0xff,	0xff,	0x8c,	0x73,	0x00,	0xff,	0x8c,	/*	55%	*/
	0xff,	0x00,	0x99,	0xff,	0x66,	0x99,	0xff,	0x00,	0xff,	0xff,	0x66,	0xff,	0x99,	0xff,	0x66,	0x00,	0xff,	0x99,	0xff,	0x99,	0x00,	0x66,	0xff,	0x99,	0xff,	0x99,	0x66,	0x00,	0x99,	0xff,	0xff,	0x99,	0x66,	0x00,	0xff,	0x99,	/*	60%	*/

	//Violet
	0xe5,	0x00,	0x33,	0xe5,	0xcc,	0x33,	0xe5,	0x00,	0xff,	0xe5,	0xcc,	0xff,	0x19,	0xe5,	0xcc,	0x00,	0xff,	0x33,	0xe5,	0x19,	0x00,	0xcc,	0xff,	0x33,	0xe5,	0x19,	0xcc,	0x00,	0x33,	0xff,	0xe5,	0x19,	0xcc,	0x00,	0xff,	0x33,	/*	20%	*/
	0xdf,	0x00,	0x40,	0xdf,	0xbf,	0x40,	0xdf,	0x00,	0xff,	0xdf,	0xbf,	0xff,	0x20,	0xdf,	0xbf,	0x00,	0xff,	0x40,	0xdf,	0x20,	0x00,	0xbf,	0xff,	0x40,	0xdf,	0x20,	0xbf,	0x00,	0x40,	0xff,	0xdf,	0x20,	0xbf,	0x00,	0xff,	0x40,	/*	25%	*/
	0xd8,	0x00,	0x4d,	0xd8,	0xb2,	0x4d,	0xd8,	0x00,	0xff,	0xd8,	0xb2,	0xff,	0x26,	0xd8,	0xb2,	0x00,	0xff,	0x4d,	0xd8,	0x26,	0x00,	0xb2,	0xff,	0x4d,	0xd8,	0x26,	0xb2,	0x00,	0x4d,	0xff,	0xd8,	0x26,	0xb2,	0x00,	0xff,	0x4d,	/*	30%	*/
	0xd2,	0x00,	0x59,	0xd2,	0xa6,	0x59,	0xd2,	0x00,	0xff,	0xd2,	0xa6,	0xff,	0x2c,	0xd2,	0xa6,	0x00,	0xff,	0x59,	0xd2,	0x2c,	0x00,	0xa6,	0xff,	0x59,	0xd2,	0x2c,	0xa6,	0x00,	0x59,	0xff,	0xd2,	0x2c,	0xa6,	0x00,	0xff,	0x59,	/*	35%	*/
	0xcc,	0x00,	0x66,	0xcc,	0x99,	0x66,	0xcc,	0x00,	0xff,	0xcc,	0x99,	0xff,	0x33,	0xcc,	0x99,	0x00,	0xff,	0x66,	0xcc,	0x33,	0x00,	0x99,	0xff,	0x66,	0xcc,	0x33,	0x99,	0x00,	0x66,	0xff,	0xcc,	0x33,	0x99,	0x00,	0xff,	0x66,	/*	40%	*/
	0xc5,	0x00,	0x73,	0xc5,	0x8c,	0x73,	0xc5,	0x00,	0xff,	0xc5,	0x8c,	0xff,	0x39,	0xc5,	0x8c,	0x00,	0xff,	0x73,	0xc5,	0x39,	0x00,	0x8c,	0xff,	0x73,	0xc5,	0x39,	0x8c,	0x00,	0x73,	0xff,	0xc5,	0x39,	0x8c,	0x00,	0xff,	0x73,	/*	45%	*/
	0xbf,	0x00,	0x80,	0xbf,	0x7f,	0x80,	0xbf,	0x00,	0xff,	0xbf,	0x7f,	0xff,	0x40,	0xbf,	0x7f,	0x00,	0xff,	0x80,	0xbf,	0x40,	0x00,	0x7f,	0xff,	0x80,	0xbf,	0x40,	0x7f,	0x00,	0x80,	0xff,	0xbf,	0x40,	0x7f,	0x00,	0xff,	0x80,	/*	50%	*/
	0xb9,	0x00,	0x8c,	0xb9,	0x73,	0x8c,	0xb9,	0x00,	0xff,	0xb9,	0x73,	0xff,	0x46,	0xb9,	0x73,	0x00,	0xff,	0x8c,	0xb9,	0x46,	0x00,	0x73,	0xff,	0x8c,	0xb9,	0x46,	0x73,	0x00,	0x8c,	0xff,	0xb9,	0x46,	0x73,	0x00,	0xff,	0x8c,	/*	55%	*/
	0xb2,	0x00,	0x99,	0xb2,	0x66,	0x99,	0xb2,	0x00,	0xff,	0xb2,	0x66,	0xff,	0x4c,	0xb2,	0x66,	0x00,	0xff,	0x99,	0xb2,	0x4c,	0x00,	0x66,	0xff,	0x99,	0xb2,	0x4c,	0x66,	0x00,	0x99,	0xff,	0xb2,	0x4c,	0x66,	0x00,	0xff,	0x99,	/*	60%	*/
};

static char BYPASS_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char BYPASS_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char BYPASS_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //nove
	0x00, //mask 0 0000
	0x00, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0x00, //trans_on trans_block 0 000 0000
	0x00, //trans_slope
	0x00, //trans_interval
	//end
};

static char NEGATIVE_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0x00, //ascr_skin_Wr
	0x00, //ascr_skin_Wg
	0x00, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0x00, //ascr_Wr
	0xff, //ascr_Kr
	0x00, //ascr_Wg
	0xff, //ascr_Kg
	0x00, //ascr_Wb
	0xff, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char NEGATIVE_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char NEGATIVE_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char GRAYSCALE_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0x4c, //ascr_skin_Rr
	0x4c, //ascr_skin_Rg
	0x4c, //ascr_skin_Rb
	0xe2, //ascr_skin_Yr
	0xe2, //ascr_skin_Yg
	0xe2, //ascr_skin_Yb
	0x69, //ascr_skin_Mr
	0x69, //ascr_skin_Mg
	0x69, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0xb3, //ascr_Cr
	0x4c, //ascr_Rr
	0xb3, //ascr_Cg
	0x4c, //ascr_Rg
	0xb3, //ascr_Cb
	0x4c, //ascr_Rb
	0x69, //ascr_Mr
	0x96, //ascr_Gr
	0x69, //ascr_Mg
	0x96, //ascr_Gg
	0x69, //ascr_Mb
	0x96, //ascr_Gb
	0xe2, //ascr_Yr
	0x1d, //ascr_Br
	0xe2, //ascr_Yg
	0x1d, //ascr_Bg
	0xe2, //ascr_Yb
	0x1d, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char GRAYSCALE_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char GRAYSCALE_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char GRAYSCALE_NEGATIVE_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0x4c, //ascr_skin_Rr
	0x4c, //ascr_skin_Rg
	0x4c, //ascr_skin_Rb
	0xe2, //ascr_skin_Yr
	0xe2, //ascr_skin_Yg
	0xe2, //ascr_skin_Yb
	0x69, //ascr_skin_Mr
	0x69, //ascr_skin_Mg
	0x69, //ascr_skin_Mb
	0x00, //ascr_skin_Wr
	0x00, //ascr_skin_Wg
	0x00, //ascr_skin_Wb
	0xb3, //ascr_Cr
	0x4c, //ascr_Rr
	0xb3, //ascr_Cg
	0x4c, //ascr_Rg
	0xb3, //ascr_Cb
	0x4c, //ascr_Rb
	0x69, //ascr_Mr
	0x96, //ascr_Gr
	0x69, //ascr_Mg
	0x96, //ascr_Gg
	0x69, //ascr_Mb
	0x96, //ascr_Gb
	0xe2, //ascr_Yr
	0x1d, //ascr_Br
	0xe2, //ascr_Yg
	0x1d, //ascr_Bg
	0xe2, //ascr_Yb
	0x1d, //ascr_Bb
	0x00, //ascr_Wr
	0xff, //ascr_Kr
	0x00, //ascr_Wg
	0xff, //ascr_Kg
	0x00, //ascr_Wb
	0xff, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char GRAYSCALE_NEGATIVE_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char GRAYSCALE_NEGATIVE_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char COLOR_BLIND_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char COLOR_BLIND_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char COLOR_BLIND_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char NIGHT_MODE_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char NIGHT_MODE_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char NIGHT_MODE_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x06, //trans_slope
	0x01, //trans_interval
	//end
};

static char COLOR_LENS_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char COLOR_LENS_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char COLOR_LENS_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char HBM_CE_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x01,	 //iove_on
  0x08,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HBM_CE_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x10, //slce_on cadrx_en 0000 0000
	0x07, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x07, // iFLATNESS_GAIN1[6:0]
	0x02, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x05, // iFLATNESS_SLOPE_NUMER[7:0]
	0x07, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HBM_CE_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x03, //nove
	0xff, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x08, //trans_slope
	0x01, //trans_interval
	//end
};

static char HBM_CE_MDNIE1_1[] = {
	//start @5000 lux
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x01,	 //iove_on
  0x08,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HBM_CE_MDNIE1_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x10, //slce_on cadrx_en 0000 0000
	0x07, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x07, // iFLATNESS_GAIN1[6:0]
	0x02, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x05, // iFLATNESS_SLOPE_NUMER[7:0]
	0x07, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HBM_CE_MDNIE1_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x03, //nove
	0xff, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_on
	0xff, //trans_on trans_block 0 000 0000
	0x08, //trans_slope
	0x01, //trans_interval
	//end
};

static char HBM_CE_MDNIE2_1[] = {
	//start @10000
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x01,	 //iove_on
  0x14,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};


static char HBM_CE_MDNIE2_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x10, //slce_on cadrx_en 0000 0000
	0x13, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x13, // iFLATNESS_GAIN1[6:0]
	0x05, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x0E, // iFLATNESS_SLOPE_NUMER[7:0]
	0x13, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HBM_CE_MDNIE2_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x03, //nove
	0xff, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_on
	0xff, //trans_on trans_block 0 000 0000
	0x08, //trans_slope
	0x01, //trans_interval
	//end
};

static char HBM_CE_MDNIE3_1[] = {
	//start @50000
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x01,	 //iove_on
  0x3C,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HBM_CE_MDNIE3_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x10, //slce_on cadrx_en 0000 0000
	0x38, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x38, // iFLATNESS_GAIN1[6:0]
	0x10, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x28, // iFLATNESS_SLOPE_NUMER[7:0]
	0x38, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HBM_CE_MDNIE3_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x03, //nove
	0xff, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_on
	0xff, //trans_on trans_block 0 000 0000
	0x08, //trans_slope
	0x01, //trans_interval
	//end
};


static char HBM_CE_D65_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x30, //ascr_skin_Rg
	0x30, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xf0, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x01,	 //iove_on
  0x3C,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_ma
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_ma
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_ma
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_ma
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pi
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x08,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x00, // iOVE_TRANS_PATTERN_EN
  0x00, // iOVE_TRANS_PATTERN_W[6:0]
  0x00, // iOVE_TRANS_HISTO_EN
  0x00, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HBM_CE_D65_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x40,
	0x1F, //gamut_r2
	0xC5,
	0x1F, //gamut_r3
	0xFA,
	0x1F, //gamut_g1
	0xEC,
	0x04, //gamut_g2
	0x1A,
	0x1F, //gamut_g3
	0xF9,
	0x1F, //gamut_b1
	0xEC,
	0x1F, //gamut_b2
	0xBE,
	0x04, //gamut_b3
	0x55,
	0x10, //slce_on cadrx_en 0000 0000
	0x1c, //lce_gain 000 0000
	0x15, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x70, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x40,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x11, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x04, //lce_large_w
	0x06, //lce_med_w
	0x06, //lce_small_w
	0x06, //lce_lg_flicker Avg pixel_cnt 000
	0x00, //lce_lg_avg_th
	0x0a, //lce_lg_pixel_th
	0x06, //lce_lg_pixel_cnt_th 23
	0xae,
	0x00,
	0x20, //lce_lg_mix_weight 7
	0x10, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x40,
	0x00, //cadrx_ui_illum_offset2
	0x50,
	0x00, //cadrx_ui_illum_offset3
	0x60,
	0x00, //cadrx_ui_illum_offset4
	0x70,
	0x00, //cadrx_ui_illum_slope1
	0x80,
	0x00, //cadrx_ui_illum_slope2
	0x80,
	0x00, //cadrx_ui_illum_slope3
	0x80,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x40,
	0x01, //cadrx_ui_ref_offset2
	0x80,
	0x01, //cadrx_ui_ref_offset3
	0x80,
	0x01, //cadrx_ui_ref_offset4
	0x80,
	0x02, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6e, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x00, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x00, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x00, // iAOLCE_S_DOWN_IN[7:0]
	0x00, // iAOLCE_S_3LINE_START[7:0]
	0x00, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x00, // iAOLCE_S_CURVE_GAIN[6:0]
	0x00, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x00, // iAOLCE_CLIP_BCR[7:0]
	0x00, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x00, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x00, // iFLATNESS_SEL iFLATNESS_EN
	0x00, // iFLATNESS_TH[5:0]
	0x00, // iFLATNESS_GAMMA_TH[7:0]
	0x00, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0x00, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HBM_CE_D65_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x03, //nove
	0xfc, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x08, //trans_slope
	0x01, //trans_interval
	//end
};

static char RGB_SENSOR_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char RGB_SENSOR_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char RGB_SENSOR_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char SCREEN_CURTAIN_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0x00, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0x00, //ascr_skin_Yr
	0x00, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0x00, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0x00, //ascr_skin_Mb
	0x00, //ascr_skin_Wr
	0x00, //ascr_skin_Wg
	0x00, //ascr_skin_Wb
	0x00, //ascr_Cr
	0x00, //ascr_Rr
	0x00, //ascr_Cg
	0x00, //ascr_Rg
	0x00, //ascr_Cb
	0x00, //ascr_Rb
	0x00, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0x00, //ascr_Gg
	0x00, //ascr_Mb
	0x00, //ascr_Gb
	0x00, //ascr_Yr
	0x00, //ascr_Br
	0x00, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0x00, //ascr_Bb
	0x00, //ascr_Wr
	0x00, //ascr_Kr
	0x00, //ascr_Wg
	0x00, //ascr_Kg
	0x00, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char SCREEN_CURTAIN_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char SCREEN_CURTAIN_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char LIGHT_NOTIFICATION_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x60, //ascr_skin_Rg
	0x13, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xf9, //ascr_skin_Yg
	0x13, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x60, //ascr_skin_Mg
	0xac, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xf9, //ascr_skin_Wg
	0xac, //ascr_skin_Wb
	0x66, //ascr_Cr
	0xff, //ascr_Rr
	0xf9, //ascr_Cg
	0x60, //ascr_Rg
	0xac, //ascr_Cb
	0x13, //ascr_Rb
	0xff, //ascr_Mr
	0x66, //ascr_Gr
	0x60, //ascr_Mg
	0xf9, //ascr_Gg
	0xac, //ascr_Mb
	0x13, //ascr_Gb
	0xff, //ascr_Yr
	0x66, //ascr_Br
	0xf9, //ascr_Yg
	0x60, //ascr_Bg
	0x13, //ascr_Yb
	0xac, //ascr_Bb
	0xff, //ascr_Wr
	0x66, //ascr_Kr
	0xf9, //ascr_Wg
	0x60, //ascr_Kg
	0xac, //ascr_Wb
	0x13, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char LIGHT_NOTIFICATION_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char LIGHT_NOTIFICATION_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char HDR_VIDEO_1_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char HDR_VIDEO_1_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x00,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char HDR_VIDEO_1_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char HDR_VIDEO_2_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char HDR_VIDEO_2_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x00,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char HDR_VIDEO_2_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char HDR_VIDEO_3_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char HDR_VIDEO_3_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char HDR_VIDEO_3_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char HDR_VIDEO_4_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char HDR_VIDEO_4_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x80,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char HDR_VIDEO_4_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char HDR_VIDEO_5_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char HDR_VIDEO_5_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x80,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char HDR_VIDEO_5_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char VIDEO_ENHANCER_D65_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
  0xFF,	 //ascr_skin_Rr
  0x3c,	 //ascr_skin_Rg
  0x38,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFF,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x00,	 //ascr_skin_Mg
  0xFF,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x55,	 //ascr_Cr
  0xf8,	 //ascr_Rr
  0xFC,	 //ascr_Cg
  0x20,	 //ascr_Rg
  0xF7,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xF5,	 //ascr_Mr
  0x42,	 //ascr_Gr
  0x35,	 //ascr_Mg
  0xf9,	 //ascr_Gg
  0xF2,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFC,	 //ascr_Yr
  0x31,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x28,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF0,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x08, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0xe4,
	0x01, //ascr_gamma_y2
	0x96,
	0x02, //ascr_gamma_y3
	0x16,
	0x02, //ascr_gamma_y4
	0x96,
	0x03, //ascr_gamma_y5
	0x16,
	0x03, //ascr_gamma_y6
	0x96,
	0x04, //ascr_gamma_y7
	0x16,
	0x04, //ascr_gamma_y8
	0x96,
	0x05, //ascr_gamma_y9
	0x16,
	0x05, //ascr_gamma_y10
	0x96,
	0x06, //ascr_gamma_y11
	0x16,
	0x06, //ascr_gamma_y12
	0x96,
	0x06, //ascr_gamma_y13
	0xf8,
	0x07, //ascr_gamma_y14
	0x50,
	0x07, //ascr_gamma_y15
	0xa8,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char VIDEO_ENHANCER_D65_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x11, //slce_on cadrx_en 0000 0000
	0x08, //lce_gain 000 0000
	0x18, //lce_color_gain 00 0000
	0x00, //lce_min_ref_offset
	0xff,
	0xa0, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x40,
	0x01, //lce_ref_gain 9
	0x00,
	0x66, //lce_block_size h v 0000 0000
	0x05, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x40,
	0x04, //lce_large_w
	0x06, //lce_med_w
	0x06, //lce_small_w
	0x04, //lce_lg_flicker Avg pixel_cnt 000
	0x00, //lce_lg_avg_th
	0x0a, //lce_lg_pixel_th
	0x06, //lce_lg_pixel_cnt_th 23
	0xae,
	0x00,
	0x00, //lce_lg_mix_weight 7
	0x1b, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0xd0,
	0x00, //cadrx_ui_illum_offset2
	0xc0,
	0x00, //cadrx_ui_illum_offset3
	0xb0,
	0x00, //cadrx_ui_illum_offset4
	0xa0,
	0x07, //cadrx_ui_illum_slope1
	0x80,
	0x07, //cadrx_ui_illum_slope2
	0x80,
	0x07, //cadrx_ui_illum_slope3
	0x80,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x60,
	0x01, //cadrx_ui_ref_offset2
	0x50,
	0x01, //cadrx_ui_ref_offset3
	0x40,
	0x01, //cadrx_ui_ref_offset4
	0x30,
	0x07, //cadrx_ui_ref_slope1
	0x80,
	0x07, //cadrx_ui_ref_slope2
	0x80,
	0x07, //cadrx_ui_ref_slope3
	0x80,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x01, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0x84,
	0x3c, //le_p
	0x28, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x40,
	0xff, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x80,
	0x01, //le_luminance_slope 10
	0x00,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x00, //reduce_halo_pos
	0x6e, //neg_bi_min
	0x82, //neg_bi_max
	0xe6, //pos_bi_min
	0xff, //pos_bi_max
	0x00, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x00, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x00, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x11, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x08, // iFLATNESS_GAIN1[6:0]
	0x08, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x08, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x03, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x20,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char VIDEO_ENHANCER_D65_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xfc, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char VIDEO_ENHANCER_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char VIDEO_ENHANCER_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x11, //slce_on cadrx_en 0000 0000
	0x08, //lce_gain 000 0000
	0x18, //lce_color_gain 00 0000
	0x00, //lce_min_ref_offset
	0xff,
	0xa0, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x40,
	0x01, //lce_ref_gain 9
	0x00,
	0x66, //lce_block_size h v 0000 0000
	0x05, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x40,
	0x04, //lce_large_w
	0x06, //lce_med_w
	0x06, //lce_small_w
	0x04, //lce_lg_flicker Avg pixel_cnt 000
	0x00, //lce_lg_avg_th
	0x0a, //lce_lg_pixel_th
	0x06, //lce_lg_pixel_cnt_th 23
	0xae,
	0x00,
	0x00, //lce_lg_mix_weight 7
	0x1b, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0xd0,
	0x00, //cadrx_ui_illum_offset2
	0xc0,
	0x00, //cadrx_ui_illum_offset3
	0xb0,
	0x00, //cadrx_ui_illum_offset4
	0xa0,
	0x07, //cadrx_ui_illum_slope1
	0x80,
	0x07, //cadrx_ui_illum_slope2
	0x80,
	0x07, //cadrx_ui_illum_slope3
	0x80,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x60,
	0x01, //cadrx_ui_ref_offset2
	0x50,
	0x01, //cadrx_ui_ref_offset3
	0x40,
	0x01, //cadrx_ui_ref_offset4
	0x30,
	0x07, //cadrx_ui_ref_slope1
	0x80,
	0x07, //cadrx_ui_ref_slope2
	0x80,
	0x07, //cadrx_ui_ref_slope3
	0x80,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x01, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0x84,
	0x3c, //le_p
	0x28, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x40,
	0xff, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x80,
	0x01, //le_luminance_slope 10
	0x00,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x00, //reduce_halo_pos
	0x6e, //neg_bi_min
	0x82, //neg_bi_max
	0xe6, //pos_bi_min
	0xff, //pos_bi_max
	0x00, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x00, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x00, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x11, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x08, // iFLATNESS_GAIN1[6:0]
	0x08, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x08, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x03, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x20,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char VIDEO_ENHANCER_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xFF, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};


static unsigned char VIDEO_ENHANCER_THIRD_D65_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
  0xFF,	 //ascr_skin_Rr
  0x3c,	 //ascr_skin_Rg
  0x38,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFF,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x00,	 //ascr_skin_Mg
  0xFF,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x55,	 //ascr_Cr
  0xf8,	 //ascr_Rr
  0xFC,	 //ascr_Cg
  0x20,	 //ascr_Rg
  0xF7,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xF5,	 //ascr_Mr
  0x42,	 //ascr_Gr
  0x35,	 //ascr_Mg
  0xf9,	 //ascr_Gg
  0xF2,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFC,	 //ascr_Yr
  0x31,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x28,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF0,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x08, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0xe4,
	0x01, //ascr_gamma_y2
	0x96,
	0x02, //ascr_gamma_y3
	0x16,
	0x02, //ascr_gamma_y4
	0x96,
	0x03, //ascr_gamma_y5
	0x16,
	0x03, //ascr_gamma_y6
	0x96,
	0x04, //ascr_gamma_y7
	0x16,
	0x04, //ascr_gamma_y8
	0x96,
	0x05, //ascr_gamma_y9
	0x16,
	0x05, //ascr_gamma_y10
	0x96,
	0x06, //ascr_gamma_y11
	0x16,
	0x06, //ascr_gamma_y12
	0x96,
	0x06, //ascr_gamma_y13
	0xf8,
	0x07, //ascr_gamma_y14
	0x50,
	0x07, //ascr_gamma_y15
	0xa8,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char VIDEO_ENHANCER_THIRD_D65_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x11, //slce_on cadrx_en 0000 0000
	0x01, //lce_gain 000 0000
	0x18, //lce_color_gain 00 0000
	0x00, //lce_min_ref_offset
	0xff,
	0xa0, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x40,
	0x01, //lce_ref_gain 9
	0x00,
	0x66, //lce_block_size h v 0000 0000
	0x05, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x40,
	0x04, //lce_large_w
	0x06, //lce_med_w
	0x06, //lce_small_w
	0x04, //lce_lg_flicker Avg pixel_cnt 000
	0x00, //lce_lg_avg_th
	0x0a, //lce_lg_pixel_th
	0x06, //lce_lg_pixel_cnt_th 23
	0xae,
	0x00,
	0x00, //lce_lg_mix_weight 7
	0x1b, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0xd0,
	0x00, //cadrx_ui_illum_offset2
	0xc0,
	0x00, //cadrx_ui_illum_offset3
	0xb0,
	0x00, //cadrx_ui_illum_offset4
	0xa0,
	0x07, //cadrx_ui_illum_slope1
	0x80,
	0x07, //cadrx_ui_illum_slope2
	0x80,
	0x07, //cadrx_ui_illum_slope3
	0x80,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x60,
	0x01, //cadrx_ui_ref_offset2
	0x50,
	0x01, //cadrx_ui_ref_offset3
	0x40,
	0x01, //cadrx_ui_ref_offset4
	0x30,
	0x07, //cadrx_ui_ref_slope1
	0x80,
	0x07, //cadrx_ui_ref_slope2
	0x80,
	0x07, //cadrx_ui_ref_slope3
	0x80,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x01, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0x84,
	0x3c, //le_p
	0x28, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x40,
	0xff, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x80,
	0x01, //le_luminance_slope 10
	0x00,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x00, //reduce_halo_pos
	0x6e, //neg_bi_min
	0x82, //neg_bi_max
	0xe6, //pos_bi_min
	0xff, //pos_bi_max
	0x00, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x00, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x00, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x11, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x01, // iFLATNESS_GAIN1[6:0]
	0x01, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x01, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x03, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x20,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x0b, //curve_y_1
	0x15, //curve_y_2
	0x1e, //curve_y_3
	0x27, //curve_y_4
	0x2f, //curve_y_5
	0x38, //curve_y_6
	0x40, //curve_y_7
	0x49, //curve_y_8
	0x51, //curve_y_9
	0x59, //curve_y_10
	0x61, //curve_y_11
	0x69, //curve_y_12
	0x71, //curve_y_13
	0x79, //curve_y_14
	0x81, //curve_y_15
	0x88, //curve_y_16
	0x8e, //curve_y_17
	0x95, //curve_y_18
	0x9c, //curve_y_19
	0xa3, //curve_y_20
	0xaa, //curve_y_21
	0xb1, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char VIDEO_ENHANCER_THIRD_D65_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xfc, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static unsigned char VIDEO_ENHANCER_THIRD_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static unsigned char VIDEO_ENHANCER_THIRD_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x11, //slce_on cadrx_en 0000 0000
	0x01, //lce_gain 000 0000
	0x18, //lce_color_gain 00 0000
	0x00, //lce_min_ref_offset
	0xff,
	0xa0, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x40,
	0x01, //lce_ref_gain 9
	0x00,
	0x66, //lce_block_size h v 0000 0000
	0x05, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x40,
	0x04, //lce_large_w
	0x06, //lce_med_w
	0x06, //lce_small_w
	0x04, //lce_lg_flicker Avg pixel_cnt 000
	0x00, //lce_lg_avg_th
	0x0a, //lce_lg_pixel_th
	0x06, //lce_lg_pixel_cnt_th 23
	0xae,
	0x00,
	0x00, //lce_lg_mix_weight 7
	0x1b, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0xd0,
	0x00, //cadrx_ui_illum_offset2
	0xc0,
	0x00, //cadrx_ui_illum_offset3
	0xb0,
	0x00, //cadrx_ui_illum_offset4
	0xa0,
	0x07, //cadrx_ui_illum_slope1
	0x80,
	0x07, //cadrx_ui_illum_slope2
	0x80,
	0x07, //cadrx_ui_illum_slope3
	0x80,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x60,
	0x01, //cadrx_ui_ref_offset2
	0x50,
	0x01, //cadrx_ui_ref_offset3
	0x40,
	0x01, //cadrx_ui_ref_offset4
	0x30,
	0x07, //cadrx_ui_ref_slope1
	0x80,
	0x07, //cadrx_ui_ref_slope2
	0x80,
	0x07, //cadrx_ui_ref_slope3
	0x80,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x01, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0x84,
	0x3c, //le_p
	0x28, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x40,
	0xff, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x80,
	0x01, //le_luminance_slope 10
	0x00,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x00, //reduce_halo_pos
	0x6e, //neg_bi_min
	0x82, //neg_bi_max
	0xe6, //pos_bi_min
	0xff, //pos_bi_max
	0x00, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x00, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x00, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x11, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x01, // iFLATNESS_GAIN1[6:0]
	0x01, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x01, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x03, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x20,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x0b, //curve_y_1
	0x15, //curve_y_2
	0x1e, //curve_y_3
	0x27, //curve_y_4
	0x2f, //curve_y_5
	0x38, //curve_y_6
	0x40, //curve_y_7
	0x49, //curve_y_8
	0x51, //curve_y_9
	0x59, //curve_y_10
	0x61, //curve_y_11
	0x69, //curve_y_12
	0x71, //curve_y_13
	0x79, //curve_y_14
	0x81, //curve_y_15
	0x88, //curve_y_16
	0x8e, //curve_y_17
	0x95, //curve_y_18
	0x9c, //curve_y_19
	0xa3, //curve_y_20
	0xaa, //curve_y_21
	0xb1, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static unsigned char VIDEO_ENHANCER_THIRD_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xFF, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char UI_DYNAMIC_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFB,	 //ascr_skin_Rr
  0x16,	 //ascr_skin_Rg
  0x00,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFA,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x29,	 //ascr_skin_Mg
  0xF7,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x3F,	 //ascr_Cr
  0xFB,	 //ascr_Rr
  0xFD,	 //ascr_Cg
  0x16,	 //ascr_Rg
  0xF6,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x30,	 //ascr_Gr
  0x29,	 //ascr_Mg
  0xF9,	 //ascr_Gg
  0xF7,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x32,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x24,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF4,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char UI_DYNAMIC_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char UI_DYNAMIC_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char UI_STANDARD_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x4e, //ascr_skin_Rg
	0x2e, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfa, //ascr_skin_Yg
	0x45, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x5d, //ascr_skin_Mg
	0xf5, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xf5, //ascr_Cg
	0x4e, //ascr_Rg
	0xf5, //ascr_Cb
	0x2e, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x5d, //ascr_Mg
	0xf1, //ascr_Gg
	0xf5, //ascr_Mb
	0x33, //ascr_Gb
	0xfa, //ascr_Yr
	0x38, //ascr_Br
	0xfa, //ascr_Yg
	0x1e, //ascr_Bg
	0x45, //ascr_Yb
	0xf2, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char UI_STANDARD_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x02, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x18,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char UI_STANDARD_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char UI_NATURAL_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xe1, //ascr_skin_Rr
	0x3d, //ascr_skin_Rg
	0x27, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfb, //ascr_skin_Yg
	0x57, //ascr_skin_Yb
	0xe6, //ascr_skin_Mr
	0x46, //ascr_skin_Mg
	0xf0, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x8f, //ascr_Cr
	0xe1, //ascr_Rr
	0xf8, //ascr_Cg
	0x3d, //ascr_Rg
	0xf5, //ascr_Cb
	0x27, //ascr_Rb
	0xe6, //ascr_Mr
	0x86, //ascr_Gr
	0x46, //ascr_Mg
	0xf5, //ascr_Gg
	0xf0, //ascr_Mb
	0x4f, //ascr_Gb
	0xfa, //ascr_Yr
	0x37, //ascr_Br
	0xfb, //ascr_Yg
	0x1f, //ascr_Bg
	0x57, //ascr_Yb
	0xed, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char UI_NATURAL_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char UI_NATURAL_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char UI_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char UI_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char UI_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char VIDEO_DYNAMIC_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFB,	 //ascr_skin_Rr
  0x16,	 //ascr_skin_Rg
  0x00,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFA,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x29,	 //ascr_skin_Mg
  0xF7,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x3F,	 //ascr_Cr
  0xFB,	 //ascr_Rr
  0xFD,	 //ascr_Cg
  0x16,	 //ascr_Rg
  0xF6,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x30,	 //ascr_Gr
  0x29,	 //ascr_Mg
  0xF9,	 //ascr_Gg
  0xF7,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x32,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x24,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF4,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char VIDEO_DYNAMIC_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char VIDEO_DYNAMIC_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char VIDEO_STANDARD_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x4e, //ascr_skin_Rg
	0x2e, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfa, //ascr_skin_Yg
	0x45, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x5d, //ascr_skin_Mg
	0xf5, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xf5, //ascr_Cg
	0x4e, //ascr_Rg
	0xf5, //ascr_Cb
	0x2e, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x5d, //ascr_Mg
	0xf1, //ascr_Gg
	0xf5, //ascr_Mb
	0x33, //ascr_Gb
	0xfa, //ascr_Yr
	0x38, //ascr_Br
	0xfa, //ascr_Yg
	0x1e, //ascr_Bg
	0x45, //ascr_Yb
	0xf2, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char VIDEO_STANDARD_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x06, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x18,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char VIDEO_STANDARD_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char VIDEO_NATURAL_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xe1, //ascr_skin_Rr
	0x3d, //ascr_skin_Rg
	0x27, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfb, //ascr_skin_Yg
	0x57, //ascr_skin_Yb
	0xe6, //ascr_skin_Mr
	0x46, //ascr_skin_Mg
	0xf0, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x8f, //ascr_Cr
	0xe1, //ascr_Rr
	0xf8, //ascr_Cg
	0x3d, //ascr_Rg
	0xf5, //ascr_Cb
	0x27, //ascr_Rb
	0xe6, //ascr_Mr
	0x86, //ascr_Gr
	0x46, //ascr_Mg
	0xf5, //ascr_Gg
	0xf0, //ascr_Mb
	0x4f, //ascr_Gb
	0xfa, //ascr_Yr
	0x37, //ascr_Br
	0xfb, //ascr_Yg
	0x1f, //ascr_Bg
	0x57, //ascr_Yb
	0xed, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char VIDEO_NATURAL_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char VIDEO_NATURAL_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char VIDEO_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char VIDEO_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x02, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x00, //de_maxplus 11
	0x40,
	0x00, //de_maxminus 11
	0x40,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x20,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char VIDEO_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char CAMERA_DYNAMIC_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
 0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFB,	 //ascr_skin_Rr
  0x16,	 //ascr_skin_Rg
  0x00,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFA,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x29,	 //ascr_skin_Mg
  0xF7,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x3F,	 //ascr_Cr
  0xFB,	 //ascr_Rr
  0xFD,	 //ascr_Cg
  0x16,	 //ascr_Rg
  0xF6,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x30,	 //ascr_Gr
  0x29,	 //ascr_Mg
  0xF9,	 //ascr_Gg
  0xF7,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x32,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x24,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF4,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char CAMERA_DYNAMIC_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char CAMERA_DYNAMIC_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
  0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char CAMERA_STANDARD_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x4e, //ascr_skin_Rg
	0x2e, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfa, //ascr_skin_Yg
	0x45, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x5d, //ascr_skin_Mg
	0xf5, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xf5, //ascr_Cg
	0x4e, //ascr_Rg
	0xf5, //ascr_Cb
	0x2e, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x5d, //ascr_Mg
	0xf1, //ascr_Gg
	0xf5, //ascr_Mb
	0x33, //ascr_Gb
	0xfa, //ascr_Yr
	0x38, //ascr_Br
	0xfa, //ascr_Yg
	0x1e, //ascr_Bg
	0x45, //ascr_Yb
	0xf2, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char CAMERA_STANDARD_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x02, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x18,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char CAMERA_STANDARD_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char CAMERA_NATURAL_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xe1, //ascr_skin_Rr
	0x3d, //ascr_skin_Rg
	0x27, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfb, //ascr_skin_Yg
	0x57, //ascr_skin_Yb
	0xe6, //ascr_skin_Mr
	0x46, //ascr_skin_Mg
	0xf0, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x8f, //ascr_Cr
	0xe1, //ascr_Rr
	0xf8, //ascr_Cg
	0x3d, //ascr_Rg
	0xf5, //ascr_Cb
	0x27, //ascr_Rb
	0xe6, //ascr_Mr
	0x86, //ascr_Gr
	0x46, //ascr_Mg
	0xf5, //ascr_Gg
	0xf0, //ascr_Mb
	0x4f, //ascr_Gb
	0xfa, //ascr_Yr
	0x37, //ascr_Br
	0xfb, //ascr_Yg
	0x1f, //ascr_Bg
	0x57, //ascr_Yb
	0xed, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char CAMERA_NATURAL_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char CAMERA_NATURAL_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_En
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char CAMERA_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char CAMERA_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char CAMERA_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char GALLERY_DYNAMIC_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFB,	 //ascr_skin_Rr
  0x16,	 //ascr_skin_Rg
  0x00,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFA,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x29,	 //ascr_skin_Mg
  0xF7,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x3F,	 //ascr_Cr
  0xFB,	 //ascr_Rr
  0xFD,	 //ascr_Cg
  0x16,	 //ascr_Rg
  0xF6,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x30,	 //ascr_Gr
  0x29,	 //ascr_Mg
  0xF9,	 //ascr_Gg
  0xF7,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x32,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x24,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF4,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char GALLERY_DYNAMIC_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char GALLERY_DYNAMIC_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char GALLERY_STANDARD_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x4e, //ascr_skin_Rg
	0x2e, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfa, //ascr_skin_Yg
	0x45, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x5d, //ascr_skin_Mg
	0xf5, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xf5, //ascr_Cg
	0x4e, //ascr_Rg
	0xf5, //ascr_Cb
	0x2e, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x5d, //ascr_Mg
	0xf1, //ascr_Gg
	0xf5, //ascr_Mb
	0x33, //ascr_Gb
	0xfa, //ascr_Yr
	0x38, //ascr_Br
	0xfa, //ascr_Yg
	0x1e, //ascr_Bg
	0x45, //ascr_Yb
	0xf2, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char GALLERY_STANDARD_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x06, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x18,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char GALLERY_STANDARD_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char GALLERY_NATURAL_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xe1, //ascr_skin_Rr
	0x3d, //ascr_skin_Rg
	0x27, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfb, //ascr_skin_Yg
	0x57, //ascr_skin_Yb
	0xe6, //ascr_skin_Mr
	0x46, //ascr_skin_Mg
	0xf0, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x8f, //ascr_Cr
	0xe1, //ascr_Rr
	0xf8, //ascr_Cg
	0x3d, //ascr_Rg
	0xf5, //ascr_Cb
	0x27, //ascr_Rb
	0xe6, //ascr_Mr
	0x86, //ascr_Gr
	0x46, //ascr_Mg
	0xf5, //ascr_Gg
	0xf0, //ascr_Mb
	0x4f, //ascr_Gb
	0xfa, //ascr_Yr
	0x37, //ascr_Br
	0xfb, //ascr_Yg
	0x1f, //ascr_Bg
	0x57, //ascr_Yb
	0xed, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char GALLERY_NATURAL_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char GALLERY_NATURAL_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char GALLERY_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char GALLERY_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char GALLERY_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x05, //trans_slope
	0x01, //trans_interval
	//end
};

static char BROWSER_DYNAMIC_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFB,	 //ascr_skin_Rr
  0x16,	 //ascr_skin_Rg
  0x00,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFA,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x29,	 //ascr_skin_Mg
  0xF7,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x3F,	 //ascr_Cr
  0xFB,	 //ascr_Rr
  0xFD,	 //ascr_Cg
  0x16,	 //ascr_Rg
  0xF6,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x30,	 //ascr_Gr
  0x29,	 //ascr_Mg
  0xF9,	 //ascr_Gg
  0xF7,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x32,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x24,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF4,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char BROWSER_DYNAMIC_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char BROWSER_DYNAMIC_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char BROWSER_STANDARD_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x4e, //ascr_skin_Rg
	0x2e, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfa, //ascr_skin_Yg
	0x45, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x5d, //ascr_skin_Mg
	0xf5, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xf5, //ascr_Cg
	0x4e, //ascr_Rg
	0xf5, //ascr_Cb
	0x2e, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x5d, //ascr_Mg
	0xf1, //ascr_Gg
	0xf5, //ascr_Mb
	0x33, //ascr_Gb
	0xfa, //ascr_Yr
	0x38, //ascr_Br
	0xfa, //ascr_Yg
	0x1e, //ascr_Bg
	0x45, //ascr_Yb
	0xf2, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char BROWSER_STANDARD_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x02, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x18,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char BROWSER_STANDARD_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char BROWSER_NATURAL_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xe1, //ascr_skin_Rr
	0x3d, //ascr_skin_Rg
	0x27, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfb, //ascr_skin_Yg
	0x57, //ascr_skin_Yb
	0xe6, //ascr_skin_Mr
	0x46, //ascr_skin_Mg
	0xf0, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x8f, //ascr_Cr
	0xe1, //ascr_Rr
	0xf8, //ascr_Cg
	0x3d, //ascr_Rg
	0xf5, //ascr_Cb
	0x27, //ascr_Rb
	0xe6, //ascr_Mr
	0x86, //ascr_Gr
	0x46, //ascr_Mg
	0xf5, //ascr_Gg
	0xf0, //ascr_Mb
	0x4f, //ascr_Gb
	0xfa, //ascr_Yr
	0x37, //ascr_Br
	0xfb, //ascr_Yg
	0x1f, //ascr_Bg
	0x57, //ascr_Yb
	0xed, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char BROWSER_NATURAL_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char BROWSER_NATURAL_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char BROWSER_AUTO_MDNIE_1[] = {
	//start
	0xDF,
  0x11,	 //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char BROWSER_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char BROWSER_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char EBOOK_DYNAMIC_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFB,	 //ascr_skin_Rr
  0x16,	 //ascr_skin_Rg
  0x00,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFA,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x29,	 //ascr_skin_Mg
  0xF7,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x3F,	 //ascr_Cr
  0xFB,	 //ascr_Rr
  0xFD,	 //ascr_Cg
  0x16,	 //ascr_Rg
  0xF6,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x30,	 //ascr_Gr
  0x29,	 //ascr_Mg
  0xF9,	 //ascr_Gg
  0xF7,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x32,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x24,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF4,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char EBOOK_DYNAMIC_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x02, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x08,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char EBOOK_DYNAMIC_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char EBOOK_STANDARD_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x4e, //ascr_skin_Rg
	0x2e, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfa, //ascr_skin_Yg
	0x45, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x5d, //ascr_skin_Mg
	0xf5, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xf5, //ascr_Cg
	0x4e, //ascr_Rg
	0xf5, //ascr_Cb
	0x2e, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x5d, //ascr_Mg
	0xf1, //ascr_Gg
	0xf5, //ascr_Mb
	0x33, //ascr_Gb
	0xfa, //ascr_Yr
	0x38, //ascr_Br
	0xfa, //ascr_Yg
	0x1e, //ascr_Bg
	0x45, //ascr_Yb
	0xf2, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char EBOOK_STANDARD_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x02, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x18,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char EBOOK_STANDARD_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char EBOOK_NATURAL_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xe1, //ascr_skin_Rr
	0x3d, //ascr_skin_Rg
	0x27, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfb, //ascr_skin_Yg
	0x57, //ascr_skin_Yb
	0xe6, //ascr_skin_Mr
	0x46, //ascr_skin_Mg
	0xf0, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x8f, //ascr_Cr
	0xe1, //ascr_Rr
	0xf8, //ascr_Cg
	0x3d, //ascr_Rg
	0xf5, //ascr_Cb
	0x27, //ascr_Rb
	0xe6, //ascr_Mr
	0x86, //ascr_Gr
	0x46, //ascr_Mg
	0xf5, //ascr_Gg
	0xf0, //ascr_Mb
	0x4f, //ascr_Gb
	0xfa, //ascr_Yr
	0x37, //ascr_Br
	0xfb, //ascr_Yg
	0x1f, //ascr_Bg
	0x57, //ascr_Yb
	0xed, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char EBOOK_NATURAL_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char EBOOK_NATURAL_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char EBOOK_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char EBOOK_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char EBOOK_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char EMAIL_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char EMAIL_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char EMAIL_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char TDMB_STANDARD_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x4e, //ascr_skin_Rg
	0x2e, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfa, //ascr_skin_Yg
	0x45, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x5d, //ascr_skin_Mg
	0xf5, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xf5, //ascr_Cg
	0x4e, //ascr_Rg
	0xf5, //ascr_Cb
	0x2e, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x5d, //ascr_Mg
	0xf1, //ascr_Gg
	0xf5, //ascr_Mb
	0x33, //ascr_Gb
	0xfa, //ascr_Yr
	0x38, //ascr_Br
	0xfa, //ascr_Yg
	0x1e, //ascr_Bg
	0x45, //ascr_Yb
	0xf2, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char TDMB_STANDARD_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x06, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x18,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char TDMB_STANDARD_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char TDMB_NATURAL_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xe1, //ascr_skin_Rr
	0x3d, //ascr_skin_Rg
	0x27, //ascr_skin_Rb
	0xfa, //ascr_skin_Yr
	0xfb, //ascr_skin_Yg
	0x57, //ascr_skin_Yb
	0xe6, //ascr_skin_Mr
	0x46, //ascr_skin_Mg
	0xf0, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x8f, //ascr_Cr
	0xe1, //ascr_Rr
	0xf8, //ascr_Cg
	0x3d, //ascr_Rg
	0xf5, //ascr_Cb
	0x27, //ascr_Rb
	0xe6, //ascr_Mr
	0x86, //ascr_Gr
	0x46, //ascr_Mg
	0xf5, //ascr_Gg
	0xf0, //ascr_Mb
	0x4f, //ascr_Gb
	0xfa, //ascr_Yr
	0x37, //ascr_Br
	0xfb, //ascr_Yg
	0x1f, //ascr_Bg
	0x57, //ascr_Yb
	0xed, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char TDMB_NATURAL_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x10,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char TDMB_NATURAL_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char TDMB_DYNAMIC_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFB,	 //ascr_skin_Rr
  0x16,	 //ascr_skin_Rg
  0x00,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xFA,	 //ascr_skin_Yg
  0x00,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x29,	 //ascr_skin_Mg
  0xF7,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFC,	 //ascr_skin_Wg
  0xF4,	 //ascr_skin_Wb
  0x3F,	 //ascr_Cr
  0xFB,	 //ascr_Rr
  0xFD,	 //ascr_Cg
  0x16,	 //ascr_Rg
  0xF6,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x30,	 //ascr_Gr
  0x29,	 //ascr_Mg
  0xF9,	 //ascr_Gg
  0xF7,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x32,	 //ascr_Br
  0xFA,	 //ascr_Yg
  0x24,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xF4,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFB,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xF3,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char TDMB_DYNAMIC_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char TDMB_DYNAMIC_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char TDMB_AUTO_MDNIE_1[] = {
	//start
	0xDF,
	0x11, //linear_on ascr_skin_on 0000 0000
  0x6A,	 //ascr_skin_cb
  0x9A,	 //ascr_skin_cr
  0x25,	 //ascr_dist_up
  0x1A,	 //ascr_dist_down
  0x16,	 //ascr_dist_right
  0x2A,	 //ascr_dist_left
  0x00,	 //ascr_div_up 20
  0x37,
  0x5A,
  0x00,	 //ascr_div_down
  0x4E,
  0xC5,
  0x00,	 //ascr_div_right
  0x5D,
  0x17,
  0x00,	 //ascr_div_left
  0x30,
  0xC3,
  0xFF,	 //ascr_skin_Rr
  0x40,	 //ascr_skin_Rg
  0x40,	 //ascr_skin_Rb
  0xFF,	 //ascr_skin_Yr
  0xF9,	 //ascr_skin_Yg
  0x40,	 //ascr_skin_Yb
  0xFF,	 //ascr_skin_Mr
  0x10,	 //ascr_skin_Mg
  0xF0,	 //ascr_skin_Mb
  0xFF,	 //ascr_skin_Wr
  0xFF,	 //ascr_skin_Wg
  0xF6,	 //ascr_skin_Wb
  0x3A,	 //ascr_Cr
  0xF9,	 //ascr_Rr
  0xFA,	 //ascr_Cg
  0x00,	 //ascr_Rg
  0xF0,	 //ascr_Cb
  0x00,	 //ascr_Rb
  0xFF,	 //ascr_Mr
  0x00,	 //ascr_Gr
  0x10,	 //ascr_Mg
  0xFF,	 //ascr_Gg
  0xF0,	 //ascr_Mb
  0x00,	 //ascr_Gb
  0xFF,	 //ascr_Yr
  0x1C,	 //ascr_Br
  0xF1,	 //ascr_Yg
  0x00,	 //ascr_Bg
  0x00,	 //ascr_Yb
  0xFF,	 //ascr_Bb
  0xFF,	 //ascr_Wr
  0x00,	 //ascr_Kr
  0xFF,	 //ascr_Wg
  0x00,	 //ascr_Kg
  0xFF,	 //ascr_Wb
  0x00,	 //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char TDMB_AUTO_MDNIE_2[] = {
	0xDE,
	0x10, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x3D,
	0x1F, //gamut_r2
	0xCB,
	0x1F, //gamut_r3
	0xF6,
	0x1F, //gamut_g1
	0xFF,
	0x04, //gamut_g2
	0x09,
	0x1F, //gamut_g3
	0xF6,
	0x1F, //gamut_b1
	0xFF,
	0x1F, //gamut_b2
	0xCB,
	0x04, //gamut_b3
	0x34,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x20,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x20,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char TDMB_AUTO_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf3, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char HMT_COLOR_TEMP_3000K_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HMT_COLOR_TEMP_3000K_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HMT_COLOR_TEMP_3000K_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char HMT_COLOR_TEMP_4000K_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HMT_COLOR_TEMP_4000K_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HMT_COLOR_TEMP_4000K_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char HMT_COLOR_TEMP_5000K_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HMT_COLOR_TEMP_5000K_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HMT_COLOR_TEMP_5000K_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char HMT_COLOR_TEMP_6500K_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HMT_COLOR_TEMP_6500K_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x02, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x40,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HMT_COLOR_TEMP_6500K_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char HMT_COLOR_TEMP_7500K_MDNIE_1[] = {
	//start
	0xDF,
	0x01, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xfc, //ascr_skin_Wg
	0xf6, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xfc, //ascr_Wg
	0x00, //ascr_Kg
	0xf4, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char HMT_COLOR_TEMP_7500K_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char HMT_COLOR_TEMP_7500K_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //mask 0 0000
	0x00, //nove
	0xf0, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0xff, //trans_on trans_block 0 000 0000
	0x04, //trans_slope
	0x01, //trans_interval
	//end
};

static char DSI_AFC[] = {
	0xE2,
	0x00,
	0x00,
	0x03,
	0x0F,
	0x00,
	0x00,
	0x00,
	0x00,
	0x05,
	0x9F,
	0x00,
	0x53,
	0x00,
	0x00,
	0x00,
	0x54,
	0x05,
	0x9F,
	0x01,
	0x2C,
	0x00,
	0x00,
	0x01,
	0x2D,
	0x05,
	0x9F,
	0x0A,
	0xE7,
	0x00,
	0x00,
	0x0A,
	0xE8,
	0x05,
	0x9F,
	0x0B,
	0xDF,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x40,
	0x00,
	0x80,
	0x00,
	0x80,
	0x01,
	0x00,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF
	//end
};

static char DSI_AFC_ON[] = {
	0xE2,
	0x01,
	0x00,
	0x03,
	0x0F,
	0x00,
	0x00,
	0x00,
	0x00,
	0x05,
	0x9F,
	0x00,
	0x53,
	0x00,
	0x00,
	0x00,
	0x54,
	0x05,
	0x9F,
	0x01,
	0x2C,
	0x00,
	0x00,
	0x01,
	0x2D,
	0x05,
	0x9F,
	0x0A,
	0xE7,
	0x00,
	0x00,
	0x0A,
	0xE8,
	0x05,
	0x9F,
	0x0B,
	0xDF,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x40,
	0x00,
	0x80,
	0x00,
	0x80,
	0x01,
	0x00,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF
	//end
};

static char DSI_AFC_OFF[] = {
	0xE2,
	0x00,
	0x00,
	0x03,
	0x0F,
	0x00,
	0x00,
	0x00,
	0x00,
	0x05,
	0x9F,
	0x00,
	0x53,
	0x00,
	0x00,
	0x00,
	0x54,
	0x05,
	0x9F,
	0x01,
	0x2C,
	0x00,
	0x00,
	0x01,
	0x2D,
	0x05,
	0x9F,
	0x0A,
	0xE7,
	0x00,
	0x00,
	0x0A,
	0xE8,
	0x05,
	0x9F,
	0x0B,
	0xDF,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x00,
	0x40,
	0x00,
	0x80,
	0x00,
	0x80,
	0x01,
	0x00,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF,
	0xFF
	//end
};

static char BACKUP_MDNIE_1[] = {
	//start
	0xDF,
	0x00, //linear_on ascr_skin_on 0000 0000
	0x6a, //ascr_skin_cb
	0x9a, //ascr_skin_cr
	0x25, //ascr_dist_up
	0x1a, //ascr_dist_down
	0x16, //ascr_dist_right
	0x2a, //ascr_dist_left
	0x00, //ascr_div_up 20
	0x37,
	0x5a,
	0x00, //ascr_div_down
	0x4e,
	0xc5,
	0x00, //ascr_div_right
	0x5d,
	0x17,
	0x00, //ascr_div_left
	0x30,
	0xc3,
	0xff, //ascr_skin_Rr
	0x00, //ascr_skin_Rg
	0x00, //ascr_skin_Rb
	0xff, //ascr_skin_Yr
	0xff, //ascr_skin_Yg
	0x00, //ascr_skin_Yb
	0xff, //ascr_skin_Mr
	0x00, //ascr_skin_Mg
	0xff, //ascr_skin_Mb
	0xff, //ascr_skin_Wr
	0xff, //ascr_skin_Wg
	0xff, //ascr_skin_Wb
	0x00, //ascr_Cr
	0xff, //ascr_Rr
	0xff, //ascr_Cg
	0x00, //ascr_Rg
	0xff, //ascr_Cb
	0x00, //ascr_Rb
	0xff, //ascr_Mr
	0x00, //ascr_Gr
	0x00, //ascr_Mg
	0xff, //ascr_Gg
	0xff, //ascr_Mb
	0x00, //ascr_Gb
	0xff, //ascr_Yr
	0x00, //ascr_Br
	0xff, //ascr_Yg
	0x00, //ascr_Bg
	0x00, //ascr_Yb
	0xff, //ascr_Bb
	0xff, //ascr_Wr
	0x00, //ascr_Kr
	0xff, //ascr_Wg
	0x00, //ascr_Kg
	0xff, //ascr_Wb
	0x00, //ascr_Kb
	0x00, //ascr_gamma_w
	0x00, //ascr_gamma_x0
	0x00,
	0x00, //ascr_gamma_x1
	0x80,
	0x01, //ascr_gamma_x2
	0x00,
	0x01, //ascr_gamma_x3
	0x80,
	0x02, //ascr_gamma_x4
	0x00,
	0x02, //ascr_gamma_x5
	0x80,
	0x03, //ascr_gamma_x6
	0x00,
	0x03, //ascr_gamma_x7
	0x80,
	0x04, //ascr_gamma_x8
	0x00,
	0x04, //ascr_gamma_x9
	0x80,
	0x05, //ascr_gamma_x10
	0x00,
	0x05, //ascr_gamma_x11
	0x80,
	0x06, //ascr_gamma_x12
	0x00,
	0x06, //ascr_gamma_x13
	0x80,
	0x07, //ascr_gamma_x14
	0x00,
	0x07, //ascr_gamma_x15
	0x80,
	0x08, //ascr_gamma_x16
	0x00,
	0x00, //ascr_gamma_y0
	0x00,
	0x00, //ascr_gamma_y1
	0x80,
	0x01, //ascr_gamma_y2
	0x00,
	0x01, //ascr_gamma_y3
	0x80,
	0x02, //ascr_gamma_y4
	0x00,
	0x02, //ascr_gamma_y5
	0x80,
	0x03, //ascr_gamma_y6
	0x00,
	0x03, //ascr_gamma_y7
	0x80,
	0x04, //ascr_gamma_y8
	0x00,
	0x04, //ascr_gamma_y9
	0x80,
	0x05, //ascr_gamma_y10
	0x00,
	0x05, //ascr_gamma_y11
	0x80,
	0x06, //ascr_gamma_y12
	0x00,
	0x06, //ascr_gamma_y13
	0x80,
	0x07, //ascr_gamma_y14
	0x00,
	0x07, //ascr_gamma_y15
	0x80,
	0x08, //ascr_gamma_y16
	0x00,
  0x00,	 //iove_on
  0x00,	 //iove_gain
  0x00,	 //iove_type
  0x10,	 //iove_histo_range_dark
  0xf9,	 //iove_histo_range_light
  0x01,	 //iove_diff_en
  0x00,	 //iove_diff_dark_min
  0xE0,
  0x00,	 //iove_diff_dark_max
  0x20,
  0x01,	 //iove_diff_light_min
  0x00,
  0x00,	 //iove_diff_light_max
  0x00,
  0x01,	 //iove_slope_en
  0x18,	 //iove_slope_dark_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_dark_max
  0x00,
  0x30,
  0x18,	 //iove_slope_light_min
  0x00,
  0xE0,
  0xE0,	 //iove_slope_light_max
  0x00,
  0x20,
  0x01,	 //iove_same_diff
  0x00,
  0x01,	 //iove_smoothing_en
  0x40,	 //iove_stretch_w
  0x03,	 //iove_pixel_num
  0xFF,
  0x01,	 //iove_trans_stretch_en
  0x02,	 //iove_trans_stretch_w
  0x01,	 //iove_trans_curve_en
  0x08,	 //iove_trans_curve_w
  0x01, // iOVE_TRANS_PATTERN_EN
  0x08, // iOVE_TRANS_PATTERN_W[6:0]
  0x01, // iOVE_TRANS_HISTO_EN
  0x08, // iOVE_TRANS_HISTO_W[6:0]
  0x01,	 //iove_pattern_en
  0x50,	 //iove_pattern_min
  0x7A,
  0x80,
  0x01,	 //iove_bg_en
  0x40,	 //iove_bg_min
  0x50,
  0x00,
  0x01,	 //iove_histo_ration_en
  0x00,	 //iove_histo_min
  0x80,
  0x20,
  0x00,
  0x01,	 //iove_cs_en
  0x01,	 //iove_cs_dark_min
  0x30,
  0x01,	 //iove_cs_dark_max
  0x60,
  0x01,	 //iove_cs_light_min
  0x30,
  0x01,	 //iove_cs_light_max
  0x00,
  0x01,	 //iove_cs_low_en
  0x0D,	 //iove_cs_low_min
  0x00,
  0x00,
  0x26,	 //iove_cs_low_max
  0x01,	 //iove_skin_cs_prob_en
  0x28,	 //iove_skin_cs_prob_increase
  0x01,	 //iove_skin_cs_gain
  0x00,
  0x40,	 //iove_skin_w
  0x6A,	 //iove_skin_CB
  0x9A,	 //iove_skin_cr
  0x3A,	 //dist_u
  0x1A,	 //dist_d
  0x16,	 //dist_r
  0x2A,	 //dist_l
  0x00,	 //skin_dist_u
  0x23,
  0x4F,
  0x00,
  0x4E,
  0xC5,
  0x00,
  0x5D,
  0x17,
  0x00,
  0x30,
  0xC3,
  0x06,
  0x40,	 //iove_skin_dark_w_x
  0x50,	 //iove_skin_dark_w_y
  0x20,
  0x40,
  0x00,
  0x60,
  0x40,
  0x60,
  0x00,
  0x60,
  0x30,
  0x60,
  0x01, // iOVE_S_EN
  0x01, // iOVE_S_DOWN_IN_LOW[8]
  0x00, // iOVE_S_DOWN_IN_LOW[7:0]
  0x00, // iOVE_S_DOWN_IN[8]
  0x00, // iOVE_S_DOWN_IN[7:0]
  0x60, // iOVE_S_3LINE_START[7:0]
  0x01, // iOVE_S_3LINE_SLOPE[11:8]
  0x00, // iOVE_S_3LINE_SLOPE[7:0]
  0x40, // iOVE_S_CURVE_GAIN[6:0]
};

static char BACKUP_MDNIE_2[] = {
	0xDE,
	0x00, //gamut_gamma_on gamut_blk_shift 0000 0000
	0x40, //gamut_scale
	0x04, //gamut_r1
	0x00,
	0x00, //gamut_r2
	0x00,
	0x00, //gamut_r3
	0x00,
	0x00, //gamut_g1
	0x00,
	0x04, //gamut_g2
	0x00,
	0x00, //gamut_g3
	0x00,
	0x00, //gamut_b1
	0x00,
	0x00, //gamut_b2
	0x00,
	0x04, //gamut_b3
	0x00,
	0x00, //slce_on cadrx_en 0000 0000
	0x00, //lce_gain 000 0000
	0x1C, //lce_color_gain 00 0000
	0x01, //lce_min_ref_offset
	0x00,
	0x94, //lce_illum_gain
	0x01, //lce_ref_offset 9
	0x34,
	0x01, //lce_ref_gain 9
	0x08,
	0x66, //lce_block_size h v 0000 0000
	0x03, //lce_dark_th 000
	0x01, //lce_reduct_slope 0000
	0x10, //lce_black cc1 0000 0000
	0x00, //lce_color_th 12
	0x26,
	0x0A, //lce_large_w
	0x03, //lce_med_w
	0x03, //lce_small_w
	0x00, //lce_lg_flicker Avg pixel_cnt 000
	0x0A, //lce_lg_avg_th
	0x0F, //lce_lg_pixel_th
	0x00, //lce_lg_pixel_cnt_th 23
	0x75,
	0x30,
	0x00, //lce_lg_mix_weight 7
	0x00, //cadrx_gain
	0x20, //cadrx_ui_illum_a1
	0x40, //cadrx_ui_illum_a2
	0x60, //cadrx_ui_illum_a3
	0x00, //cadrx_ui_illum_offset1
	0x94,
	0x00, //cadrx_ui_illum_offset2
	0x94,
	0x00, //cadrx_ui_illum_offset3
	0x94,
	0x00, //cadrx_ui_illum_offset4
	0x94,
	0x00, //cadrx_ui_illum_slope1
	0x00,
	0x00, //cadrx_ui_illum_slope2
	0x00,
	0x00, //cadrx_ui_illum_slope3
	0x00,
	0x00, //cadrx_ui_illum_slope4
	0x00,
	0x20, //cadrx_ui_ref_a1
	0x40, //cadrx_ui_ref_a2
	0x60, //cadrx_ui_ref_a3
	0x01, //cadrx_ui_ref_offset1
	0x08,
	0x01, //cadrx_ui_ref_offset2
	0x08,
	0x01, //cadrx_ui_ref_offset3
	0x08,
	0x01, //cadrx_ui_ref_offset4
	0x08,
	0x00, //cadrx_ui_ref_slope1
	0x00,
	0x00, //cadrx_ui_ref_slope2
	0x00,
	0x00, //cadrx_ui_ref_slope3
	0x00,
	0x00, //cadrx_ui_ref_slope4
	0x00,
	0x00, //le_en
	0x40, //le_diff
	0x03, //le_lmax 10
	0xB6,
	0x23, //le_p
	0x24, //le_w_tmf
	0x00, //le_w_struct_diff 9
	0x72,
	0x01, //le_w_struct_diff_gain
	0x00, //le_w_luminance 9
	0x0D,
	0x00, //le_luminance_slope 10
	0x04,
	0x07, //bi_filter_en bi_en bcr_en 000
	0x40, //reduce_halo_neg
	0x40, //reduce_halo_pos
	0x6E, //neg_bi_min
	0x82, //neg_bi_max
	0x00, //pos_bi_min
	0xff, //pos_bi_max
	0x01, // iAOLCE_S_EN
	0x00, // iAOLCE_S_DOWN_IN_LOW[8]
	0x10, // iAOLCE_S_DOWN_IN_LOW[7:0]
	0x00, // iAOLCE_S_DOWN_IN[8]
	0x20, // iAOLCE_S_DOWN_IN[7:0]
	0x40, // iAOLCE_S_3LINE_START[7:0]
	0x01, // iAOLCE_S_3LINE_SLOPE[11:8]
	0x00, // iAOLCE_S_3LINE_SLOPE[7:0]
	0x40, // iAOLCE_S_CURVE_GAIN[6:0]
	0x01, // iAOLCE_CLIP_BCR_EN
	0x00, // iAOLCE_CLIP_BCR[8]
	0x10, // iAOLCE_CLIP_BCR[7:0]
	0x01, // iAOLCE_TRANS_SLCE_GAIN_EN
	0x08, // iAOLCE_TRANS_SLCE_GAIN_W[6:0]
	0x01, // iFLATNESS_SEL iFLATNESS_EN
	0x01, // iFLATNESS_TH[5:0]
	0x0A, // iFLATNESS_GAMMA_TH[7:0]
	0x20, // iFLATNESS_GAMMA_GAIN[6:0]
	0x00, // iFLATNESS_FLAT1[7:0]
	0xFF, // iFLATNESS_FLAT2[7:0]
	0x00, // iFLATNESS_GAIN1[6:0]
	0x00, // iFLATNESS_GAIN2[6:0]
	0x00, // iFLATNESS_SLOPE_INT[4:0]
	0x00, // iFLATNESS_SLOPE_NUMER[7:0]
	0x00, // iFLATNESS_SLOPE_OFFSET[7:0]
	0x00, //nr fa de cs gamma 0 0000
	0xff, //nr_mask_th
	0x00, //de_gain 10
	0x00,
	0x02, //de_maxplus 11
	0x00,
	0x02, //de_maxminus 11
	0x00,
	0x14, //fa_edge_th
	0x00, //fa_step_p 10
	0x01,
	0x00, //fa_step_n 10
	0x01,
	0x00, //fa_max_de_gain 10
	0x10,
	0x00, //fa_pcl_ppi 14
	0x00,
	0x28, //fa_os_cnt_10_co
	0x3c, //fa_os_cnt_20_co
	0x04, //fa_edge_cnt_weight
	0x0f, //fa_avg_y_weight
	0x01, //cs_gain 10
	0x00,
	0x00, //curve_x_0
	0x08, //curve_x_1
	0x10, //curve_x_2
	0x18, //curve_x_3
	0x20, //curve_x_4
	0x28, //curve_x_5
	0x30, //curve_x_6
	0x38, //curve_x_7
	0x40, //curve_x_8
	0x48, //curve_x_9
	0x50, //curve_x_10
	0x58, //curve_x_11
	0x60, //curve_x_12
	0x68, //curve_x_13
	0x70, //curve_x_14
	0x78, //curve_x_15
	0x80, //curve_x_16
	0x88, //curve_x_17
	0x90, //curve_x_18
	0x98, //curve_x_19
	0xa0, //curve_x_20
	0xa8, //curve_x_21
	0xb0, //curve_x_22
	0xb8, //curve_x_23
	0xc0, //curve_x_24
	0xc8, //curve_x_25
	0xd0, //curve_x_26
	0xd8, //curve_x_27
	0xe0, //curve_x_28
	0xe8, //curve_x_29
	0xf0, //curve_x_30
	0xf8, //curve_x_31
	0x01, //curve_x_32
	0x00,
	0x00, //curve_y_0
	0x08, //curve_y_1
	0x10, //curve_y_2
	0x18, //curve_y_3
	0x20, //curve_y_4
	0x28, //curve_y_5
	0x30, //curve_y_6
	0x38, //curve_y_7
	0x40, //curve_y_8
	0x48, //curve_y_9
	0x50, //curve_y_10
	0x58, //curve_y_11
	0x60, //curve_y_12
	0x68, //curve_y_13
	0x70, //curve_y_14
	0x78, //curve_y_15
	0x80, //curve_y_16
	0x88, //curve_y_17
	0x90, //curve_y_18
	0x98, //curve_y_19
	0xa0, //curve_y_20
	0xa8, //curve_y_21
	0xb0, //curve_y_22
	0xb8, //curve_y_23
	0xc0, //curve_y_24
	0xc8, //curve_y_25
	0xd0, //curve_y_26
	0xd8, //curve_y_27
	0xe0, //curve_y_28
	0xe8, //curve_y_29
	0xf0, //curve_y_30
	0xf8, //curve_y_31
	0x01, //curve_y_32
	0x00,
};

static char BACKUP_MDNIE_3[] = {
	0xDD,
	0x01, //mdnie_en
	0x00, //nove
	0x00, //mask 0 0000
	0x00, //ascr algo aolce gamut 00 00 00 00
	0x07, //v_partial_on
	0x7f, //partial_en1
	0x7f, //partial_en2
	0x00, //roi_en
	0x00, //roi_block
	0x00, //roi_sx
	0x00, //roi_sx
	0x00, //roi_sy
	0x00, //roi_sy
	0x00, //roi_ex
	0x00, //roi_ex
	0x00, //roi_ey
	0x00, //roi_ey
	0x01, //trans_en
	0x00, //trans_on trans_block 0 000 0000
	0x00, //trans_slope
	0x00, //trans_interval
	//end
};

#define MDNIE_CMD_LW(cmd, last) 	\
{									\
	.msg.channel = 0,				\
	.msg.type = MIPI_DSI_DCS_LONG_WRITE,	\
	.msg.flags = 0,					\
	.msg.tx_len = sizeof(cmd),		\
	.msg.tx_buf = cmd,				\
	.msg.rx_len = 0,				\
	.msg.rx_buf = NULL,				\
	.last_command = last,			\
	.post_wait_ms = 0,				\
	.ctrl = 0, 						\
	.ctrl_flags = 0,				\
	.ss_txbuf = cmd					\
}

#define MDNIE_CMDS_SET(name)					\
	static struct dsi_cmd_desc name[] = { 		\
		MDNIE_CMD_LW(level_1_key_on, false),	\
		MDNIE_CMD_LW(name ## _1, false),		\
		MDNIE_CMD_LW(name ## _2, false),		\
		MDNIE_CMD_LW(name ## _3, false),		\
		MDNIE_CMD_LW(level_1_key_off, true),	\
	};

MDNIE_CMDS_SET(BYPASS_MDNIE)
MDNIE_CMDS_SET(BACKUP_MDNIE)
MDNIE_CMDS_SET(NEGATIVE_MDNIE)
MDNIE_CMDS_SET(GRAYSCALE_MDNIE)
MDNIE_CMDS_SET(GRAYSCALE_NEGATIVE_MDNIE)
MDNIE_CMDS_SET(COLOR_BLIND_MDNIE)
MDNIE_CMDS_SET(NIGHT_MODE_MDNIE)
MDNIE_CMDS_SET(COLOR_LENS_MDNIE)
MDNIE_CMDS_SET(HBM_CE_MDNIE)
MDNIE_CMDS_SET(HBM_CE_D65_MDNIE)
MDNIE_CMDS_SET(HBM_CE_MDNIE1)
MDNIE_CMDS_SET(HBM_CE_MDNIE2)
MDNIE_CMDS_SET(HBM_CE_MDNIE3)
MDNIE_CMDS_SET(RGB_SENSOR_MDNIE)
MDNIE_CMDS_SET(SCREEN_CURTAIN_MDNIE)
MDNIE_CMDS_SET(LIGHT_NOTIFICATION_MDNIE)
MDNIE_CMDS_SET(HDR_VIDEO_1_MDNIE)
MDNIE_CMDS_SET(HDR_VIDEO_2_MDNIE)
MDNIE_CMDS_SET(HDR_VIDEO_3_MDNIE)
MDNIE_CMDS_SET(HDR_VIDEO_4_MDNIE)
MDNIE_CMDS_SET(HDR_VIDEO_5_MDNIE)
MDNIE_CMDS_SET(VIDEO_ENHANCER_D65_MDNIE)
MDNIE_CMDS_SET(VIDEO_ENHANCER_AUTO_MDNIE)
MDNIE_CMDS_SET(VIDEO_ENHANCER_THIRD_D65_MDNIE)
MDNIE_CMDS_SET(VIDEO_ENHANCER_THIRD_AUTO_MDNIE)
MDNIE_CMDS_SET(UI_DYNAMIC_MDNIE)
MDNIE_CMDS_SET(UI_STANDARD_MDNIE)
MDNIE_CMDS_SET(UI_NATURAL_MDNIE)
MDNIE_CMDS_SET(UI_AUTO_MDNIE)
MDNIE_CMDS_SET(VIDEO_DYNAMIC_MDNIE)
MDNIE_CMDS_SET(VIDEO_STANDARD_MDNIE)
MDNIE_CMDS_SET(VIDEO_NATURAL_MDNIE)
MDNIE_CMDS_SET(VIDEO_AUTO_MDNIE)
MDNIE_CMDS_SET(CAMERA_DYNAMIC_MDNIE)
MDNIE_CMDS_SET(CAMERA_STANDARD_MDNIE)
MDNIE_CMDS_SET(CAMERA_NATURAL_MDNIE)
MDNIE_CMDS_SET(CAMERA_AUTO_MDNIE)
MDNIE_CMDS_SET(GALLERY_DYNAMIC_MDNIE)
MDNIE_CMDS_SET(GALLERY_STANDARD_MDNIE)
MDNIE_CMDS_SET(GALLERY_NATURAL_MDNIE)
MDNIE_CMDS_SET(GALLERY_AUTO_MDNIE)
MDNIE_CMDS_SET(BROWSER_DYNAMIC_MDNIE)
MDNIE_CMDS_SET(BROWSER_STANDARD_MDNIE)
MDNIE_CMDS_SET(BROWSER_NATURAL_MDNIE)
MDNIE_CMDS_SET(BROWSER_AUTO_MDNIE)
MDNIE_CMDS_SET(EBOOK_DYNAMIC_MDNIE)
MDNIE_CMDS_SET(EBOOK_STANDARD_MDNIE)
MDNIE_CMDS_SET(EBOOK_NATURAL_MDNIE)
MDNIE_CMDS_SET(EBOOK_AUTO_MDNIE)
MDNIE_CMDS_SET(EMAIL_AUTO_MDNIE)
MDNIE_CMDS_SET(TDMB_DYNAMIC_MDNIE)
MDNIE_CMDS_SET(TDMB_STANDARD_MDNIE)
MDNIE_CMDS_SET(TDMB_NATURAL_MDNIE)
MDNIE_CMDS_SET(TDMB_AUTO_MDNIE)
MDNIE_CMDS_SET(HMT_COLOR_TEMP_3000K_MDNIE)
MDNIE_CMDS_SET(HMT_COLOR_TEMP_4000K_MDNIE)
MDNIE_CMDS_SET(HMT_COLOR_TEMP_5000K_MDNIE)
MDNIE_CMDS_SET(HMT_COLOR_TEMP_6500K_MDNIE)
MDNIE_CMDS_SET(HMT_COLOR_TEMP_7500K_MDNIE)

static struct dsi_cmd_desc *mdnie_tune_value_dsi0[MAX_APP_MODE][MAX_MODE][MAX_OUTDOOR_MODE] = {
	/*
		DYNAMIC_MODE
		STANDARD_MODE
		NATURAL_MODE
		MOVIE_MODE
		AUTO_MODE
		READING_MODE
	*/
	// UI_APP
	{
		{UI_DYNAMIC_MDNIE,	NULL},
		{UI_STANDARD_MDNIE,	NULL},
		{UI_NATURAL_MDNIE,	NULL},
		{NULL,	NULL},
		{UI_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// VIDEO_APP
	{
		{VIDEO_DYNAMIC_MDNIE,	NULL},
		{VIDEO_STANDARD_MDNIE,	NULL},
		{VIDEO_NATURAL_MDNIE,	NULL},
		{NULL,	NULL},
		{VIDEO_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// VIDEO_WARM_APP
	{
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
	},
	// VIDEO_COLD_APP
	{
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
	},
	// CAMERA_APP
	{
		{CAMERA_DYNAMIC_MDNIE,	NULL},
		{CAMERA_STANDARD_MDNIE,	NULL},
		{CAMERA_NATURAL_MDNIE,	NULL},
		{NULL,	NULL},
		{CAMERA_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// NAVI_APP
	{
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
	},
	// GALLERY_APP
	{
		{GALLERY_DYNAMIC_MDNIE,	NULL},
		{GALLERY_STANDARD_MDNIE,	NULL},
		{GALLERY_NATURAL_MDNIE,	NULL},
		{NULL,	NULL},
		{GALLERY_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// VT_APP
	{
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
		{NULL,	NULL},
	},
	// BROWSER_APP
	{
		{BROWSER_DYNAMIC_MDNIE,	NULL},
		{BROWSER_STANDARD_MDNIE,	NULL},
		{BROWSER_NATURAL_MDNIE,	NULL},
		{NULL,	NULL},
		{BROWSER_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// eBOOK_APP
	{
		{EBOOK_DYNAMIC_MDNIE,	NULL},
		{EBOOK_STANDARD_MDNIE,	NULL},
		{EBOOK_NATURAL_MDNIE,	NULL},
		{NULL,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// EMAIL_APP
	{
		{EMAIL_AUTO_MDNIE,	NULL},
		{EMAIL_AUTO_MDNIE,	NULL},
		{EMAIL_AUTO_MDNIE,	NULL},
		{NULL,	NULL},
		{EMAIL_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// GAME_LOW_APP
	{
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
		{NULL,	NULL},
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
	},
	// GAME_MID_APP
	{
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
		{NULL,	NULL},
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
	},
	// GAME_HIGH_APP
	{
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
		{NULL,	NULL},
		{BYPASS_MDNIE,	NULL},
		{BYPASS_MDNIE,	NULL},
	},
	// VIDEO_ENHANCER_APP
	{
		{VIDEO_ENHANCER_D65_MDNIE,	NULL},
		{VIDEO_ENHANCER_D65_MDNIE,	NULL},
		{VIDEO_ENHANCER_D65_MDNIE,	NULL},
		{NULL,	NULL},
		{VIDEO_ENHANCER_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// VIDEO_ENHANCER_THIRD_APP
	{
		{VIDEO_ENHANCER_THIRD_D65_MDNIE,	NULL},
		{VIDEO_ENHANCER_THIRD_D65_MDNIE,	NULL},
		{VIDEO_ENHANCER_THIRD_D65_MDNIE,	NULL},
		{NULL,	NULL},
		{VIDEO_ENHANCER_THIRD_AUTO_MDNIE,	NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
	// TDMB_APP
	{
		{TDMB_DYNAMIC_MDNIE,       NULL},
		{TDMB_STANDARD_MDNIE,      NULL},
		{TDMB_NATURAL_MDNIE,       NULL},
		{NULL,         NULL},
		{TDMB_AUTO_MDNIE,          NULL},
		{EBOOK_AUTO_MDNIE,	NULL},
	},
};

static struct dsi_cmd_desc *hbm_ce_data[HBM_CE_MDNIE_IDX_MAX] = {
	NULL,
	HBM_CE_MDNIE1,
	HBM_CE_MDNIE2,
	HBM_CE_MDNIE3,
};



static struct dsi_cmd_desc *hmt_color_temperature_tune_value_dsi0[HMT_COLOR_TEMP_MAX] = {
	/*
		HMT_COLOR_TEMP_3000K, // 3000K
		HMT_COLOR_TEMP_4000K, // 4000K
		HMT_COLOR_TEMP_5000K, // 5000K
		HMT_COLOR_TEMP_6500K, // 6500K
		HMT_COLOR_TEMP_7500K, // 7500K
	*/
	NULL,
	HMT_COLOR_TEMP_3000K_MDNIE,
	HMT_COLOR_TEMP_4000K_MDNIE,
	HMT_COLOR_TEMP_5000K_MDNIE,
	HMT_COLOR_TEMP_6500K_MDNIE,
	HMT_COLOR_TEMP_7500K_MDNIE,
};

static struct dsi_cmd_desc *light_notification_tune_value_dsi0[LIGHT_NOTIFICATION_MAX] = {
	NULL,
	LIGHT_NOTIFICATION_MDNIE,
};

static struct dsi_cmd_desc *hdr_tune_value_dsi0[HDR_MAX] = {
	NULL,
	HDR_VIDEO_1_MDNIE,
	HDR_VIDEO_2_MDNIE,
	HDR_VIDEO_3_MDNIE,
	HDR_VIDEO_4_MDNIE,
	HDR_VIDEO_5_MDNIE,
};

#define RGB_SENSOR_MDNIE_1_SIZE ARRAY_SIZE(RGB_SENSOR_MDNIE_1)
#define RGB_SENSOR_MDNIE_2_SIZE ARRAY_SIZE(RGB_SENSOR_MDNIE_2)
#define RGB_SENSOR_MDNIE_3_SIZE ARRAY_SIZE(RGB_SENSOR_MDNIE_3)

#endif







